;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;
;
;
;
;
;   GOMEZ MUSIC INTERFACE                                   EXAMPLE-PROGGY
;
;
;
P486
LOCALS
JUMPS

CODE32	segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gmi32.inc
include devices.inc
include keys.inc

extrn C GUS_IRQ_Counter:DWORD
extrn C GUS_Event_Counter:DWORD
extrn C GUS_Ramp_Counter:DWORD
extrn C GUS_Wave_Counter:DWORD



WAIT_RETRACE MACRO
	LOCAL N1,N2
	mov 	dx,3dah
N1:	in 	al,dx
	test 	al,01h
	jnz 	short N1
N2:	in 	al,dx
	test 	al,08h
	jz 	short N2
	ENDM

SWITCH_FRAME MACRO
	LOCAL	N1,N2
	;
	;Now switch to current frame
	;
	mov 	dx,3dah
N1:	in 	al,dx
	test 	al,1
	jnz 	short N1

	mov	ebx,ds:[This_Page]
	sub	ebx,0b8000h
	shr	ebx,1
	mov 	dx,3d4h
	mov 	al,0dh
	out 	dx,al		;Start address low
	inc	dx
	mov 	al,bl
	out 	dx,al		;Set low start address

	dec 	dx
	mov 	al,0ch
	out 	dx,al		;Start address high
	inc 	dx
	mov	al,bh
	out 	dx,al

	xor	ds:[This_Page],1000h

	;
	;Wait for display period
	;
	mov 	dx,3dah
N2:	in 	al,dx
	test 	al,08h
	jz 	short N2
	ENDM

STXT		db	"Gomez Music Interface                               (C) 1996 by Marc van Shaney",10,13,'$'
ETXT0		db	"Usage: DPLAY.EXE [module.XM]",10,13,'$'
ETXT1		db	"Error: Could not load module . . .",10,13,'$'
ETXT2		db	"Error: Could not initialize music system.",10,13,'$'
ETXT3		db	"Error: No sound card detected.",10,13,'$'
SHandle		dd	?
ISTart		dd	0
This_Page	dd	0b8000h
tilde		db	"~",0
;
PUBLIC C main
main PROC NEAR
	mov	esi,OFFSET STXT
	call	Print32
	mov	eax,OFFSET tilde
	call    Scan_Argument
	jc	ERR0
	mov	esi,eax
	;
	;
	; Try to detect the best hardware available. The order is:
	;	GUS
	;	SB-DMA
	;	SB-Timer
	;	AdLib
	;	PC-Speaker
	;
	call	dword ptr ds:[GUS_Driver+40]
	mov	eax,OFFSET GUS_Driver
	jnc	short @@Doit
	call	dword ptr ds:[SBDMA_Driver+40]
	mov	eax,OFFSET SBDMA_Driver
	jnc	short @@Doit
	mov	eax,OFFSET SILENT_Driver
	jmp	Err3
	;
@@Doit: mov	ebx,GMI_SUPPORT_INT8 		;or GMI_USE_STEREO or GMI_USE_16BIT
	mov	ecx,22000
	call	Init_GMI
	jc	Err2
	mov	ebx,esi				;EBX = ptr to file-name
	xor	edx,edx				;Start at file offset 0
	call	GMI_Load_Song			;Load module
	jc	Err1
	mov	ds:[SHandle],eax
	call	GMI_Play_Song
	jc	Err2
@@Disp:	SWITCH_FRAME
	call	Display_Main_Screen
	call	Display_Instruments
	;
	call	Display_Beat
	GETKEY32
	test	ax,ax
	jz	@@Disp
	cmp	ax,CUrsor_Up
	jne	short @@K1
		cmp	ds:[IStart],0
		jle	@@Disp
		dec	ds:[ISTart]
		jmp	@@Disp
@@K1:	cmp	ax,CUrsor_Down
	jne	short @@K2
		inc	ds:[ISTart]
		jmp	@@Disp
@@K2:	cmp	ax,'s'
	jne	short @@K3
		call	Scope
		jmp	@@Disp
@@K3:	cmp	ax,CUrsor_Left
	jne	short @@K4
		mov	eax,ds:[GMI_Entry_No]
		xor	ebx,ebx
		dec	eax
		call	GMI_Position_Jump
		jmp	@@Disp
@@K4:	cmp	ax,CUrsor_Right
	jne	short @@K5
		mov	eax,ds:[GMI_Entry_No]
		xor	ebx,ebx
		inc	eax
		call	GMI_Position_Jump
		jmp	@@Disp
@@K5:	cmp	ax,'+'
	jne	short @@K6
		mov	eax,ds:[GMI_Volume]
		add	eax,4
		call	GMI_Set_Volume
		jmp	@@Disp
@@K6:	cmp	ax,'-'
	jne	short @@K7
		mov	eax,ds:[GMI_Volume]
		sub	eax,4
		js	@@Disp
		call	GMI_Set_Volume
		jmp	@@Disp
@@K7:	cmp	ax,'c'
	jne	short @@K8
		call	Channels
		jmp	@@Disp
@@K8:	cmp	ax,'g'
	jne	short @@K9
		call	GUS
		jmp	@@Disp
@@K9:	cmp	ax,Escape
	jne	@@Disp
	;
@@End:	call	GMI_Stop_Song
	mov	eax,ds:[SHandle]
	call 	GMI_Free_Song
	call	Exit_GMI
	mov 	ds:[v86_ax],3			;Set 80x25 text-mode
	mov	eax,10h
	call	Invoke_Real_Int
	jmp	Exit_PMODE32
;
Err0:   PRINT	3,"Usage: DPLAY.EXE [module.XM]"
	jmp	Exit_PMODE32
	;
Err1:   PRINT	3,"Error: Could not load module..."
	jmp	Exit_PMODE32
	;
Err2:   PRINT	3,"Error: Could not initilaize music system."
	jmp	Exit_PMODE32
	;
Err3:   PRINT	3,"Error: No soundcard detected."
	jmp	Exit_PMODE32
	;

main ENDP


;
;   GOMEZ MUSIC INTERFACE                        SONG-INFO DISPLAY ROUTINES
;
Display_Main_Screen:
	mov	edi,ds:[This_Page]
	sub	edi,ds:[DATA32_Address]		;ES:EDI = ptr to video-ram
	mov	esi,OFFSET MAIN_SCREEN
	mov	ecx,80*25*2/4
	rep	movsd				;Copy main-screen
	;
	mov	edi,ds:[This_Page]
	add	edi,160+20
	sub	edi,ds:[DATA32_Address]		;ES:EDI = ptr to video-ram
	mov	ah,30				;Screen attribute
	mov	esi,ds:[SHandle]
	add	esi,SNG_NAME
	mov	ecx,64				;64 chars to copy
@@L1:	lodsb
	stosw
	dec	ecx
	jnz	short @@L1
	retn
;
Display_Beat:
	mov	eax,ds:[GMI_Entry_No]
	mov	edi,160*4+11*2
	mov	bl,30
	call	PrintL
	mov	eax,ds:[GMI_Pattern_No]
	mov	edi,160*4+15*2
	mov	bl,30
	call	PrintL
	mov	eax,ds:[GMI_Beat_No]
	mov	edi,160*4+25*2
	mov	bl,30
	call	PrintL
	mov	eax,ds:[GMI_Speed]
	mov	edi,160*4+36*2
	mov	bl,30
	call	PrintL
	mov	eax,ds:[GMI_Tempo]
	mov	edi,160*4+40*2
	mov	bl,30
	call	PrintL
	mov	eax,ds:[GMI_Volume]
	mov	edi,160*4+53*2
	mov	bl,30
	call	PrintL
	mov	eax,ds:[GMI_Play_Frequency]
	mov	edi,160*4+68*2
	mov	bl,30
	call	PrintL
	retn
;
Display_Instruments:
	mov	ebp,ds:[IStart]
	shl	ebp,2
	add	ebp,ds:[SHandle]
	xor	ecx,ecx
@@L1:   push	ecx
	mov	esi,ds:[ebp+4*ecx+SNG_INSTRUMENT_PTR]
	test	esi,esi
	jz	@@Next
	;
	mov	edi,ecx
	imul	edi,160
	add	edi,8+6*160
	push	esi
	add	esi,INS_NAME
	mov	bl,30
	call	PrintT
	pop	esi
	test	ds:[esi+INS_FLAGS],FL_FULL_INSTRUMENT
	jz	@@Next
	;
	mov	eax,ds:[esi+INS_SAMPLES+SMP_ADDRESS]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+41*2
	call	PrintH
	mov	eax,ds:[esi+INS_SAMPLES+SMP_SIZE]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+50*2
	call	PrintH
	mov	eax,ds:[esi+INS_SAMPLES+SMP_LOOP_START]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+59*2
	call	PrintH
	mov	eax,ds:[esi+INS_SAMPLES+SMP_LOOP_END]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+68*2
	call	PrintH
	;
@@Next:	pop	ecx
	inc	ecx
	cmp	ecx,16
	jb	@@L1
	retn
;
;   GOMEZ MUSIC INTERFACE                                  CHANNEL DISPLAYS
;
Display_Channel_Screen:
	mov	edi,ds:[This_Page]
	sub	edi,ds:[DATA32_Address]		;ES:EDI = ptr to video-ram
	mov	esi,OFFSET CHANNEL_SCREEN
	mov	ecx,80*25*2/4
	rep	movsd				;Copy main-screen
	;
	mov	edi,ds:[This_Page]
	add	edi,160+20
	sub	edi,ds:[DATA32_Address]		;ES:EDI = ptr to video-ram
	mov	ah,30				;Screen attribute
	mov	esi,ds:[SHandle]
	add	esi,SNG_NAME
	mov	ecx,64				;64 chars to copy
@@L1:	lodsb
	stosw
	dec	ecx
	jnz	short @@L1
	;
	mov	eax,ds:[GMI_Flags]
	mov	edi,160*3+9*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Row_Address]
	mov	edi,160*3+24*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Tick]
	mov	edi,160*3+41*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Mixing_Buffer]
	mov	edi,160*3+59*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Channels]
	mov	edi,160*3+74*2
	mov	bl,30
	call	PrintL
	retn
;
Display_Channels:
	mov	ebp,OFFSET GMI_CHannel_Data
	xor	ecx,ecx
@@L1:   push	ecx
	;
	mov	bl,30
	mov	eax,ds:[ebp+CI_INSTRUMENT_NUMBER]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+7*2
	call	PrintL
	mov	eax,ds:[ebp+CI_INSTRUMENT_ADDRESS]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+11*2
	call	PrintH
	mov	eax,ds:[ebp+CI_SAMPLE_ADDRESS]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+20*2
	call	PrintH
	mov	eax,ds:[ebp+CI_PERIOD]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+38*2
	call	PrintH
	mov	eax,ds:[ebp+CI_RESAMPLE]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+56*2
	call	PrintH
	mov	eax,ds:[ebp+CI_FLAGS]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+65*2
	call	PrintH
	movzx	eax,ds:[ebp+CI_VOLUME]
	mov	edi,ss:[esp]
	imul	edi,160
	add	edi,6*160+74*2
	call	PrintL
	;
@@Next: add	ebp,SIZE GMI_CHANNEL_INFO
	pop	ecx
	inc	ecx
	cmp	ecx,16
	jb	@@L1
	retn
;
Channels:
	SWITCH_FRAME
	call	Display_Channel_Screen
	call	Display_Channels
	call	Display_Beat
	GETKEY32
	cmp	ax,CUrsor_Left
	jne	short @@K1
		mov	eax,ds:[GMI_Entry_No]
		xor	ebx,ebx
		dec	eax
		call	GMI_Position_Jump
		jmp	Channels
@@K1:	cmp	ax,CUrsor_Right
	jne	short @@K2
		mov	eax,ds:[GMI_Entry_No]
		xor	ebx,ebx
		inc	eax
		call	GMI_Position_Jump
		jmp	Channels
@@K2:   cmp	ax,'+'
	jne	short @@K6
		mov	eax,ds:[GMI_Volume]
		add	eax,4
		call	GMI_Set_Volume
		jmp	Channels
@@K6:	cmp	ax,'-'
	jne	short @@K7
		mov	eax,ds:[GMI_Volume]
		sub	eax,4
		js	Channels
		call	GMI_Set_Volume
		jmp	Channels
@@K7:	cmp	ax,Escape
	jne	Channels
	retn
;
;   GOMEZ MUSIC INTERFACE                                      GUS DISPLAYS
;
Display_GUS_Screen:
	mov	edi,ds:[This_Page]
	sub	edi,ds:[DATA32_Address]		;ES:EDI = ptr to video-ram
	mov	esi,OFFSET GUS_SCREEN
	mov	ecx,80*25*2/4
	rep	movsd				;Copy main-screen
	;
	mov	edi,ds:[This_Page]
	add	edi,160+20
	sub	edi,ds:[DATA32_Address]		;ES:EDI = ptr to video-ram
	mov	ah,30				;Screen attribute
	mov	esi,ds:[SHandle]
	add	esi,SNG_NAME
	mov	ecx,64				;64 chars to copy
@@L1:	lodsb
	stosw
	dec	ecx
	jnz	short @@L1
	;
	mov	eax,ds:[GMI_Flags]
	mov	edi,160*3+9*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Row_Address]
	mov	edi,160*3+24*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Tick]
	mov	edi,160*3+41*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Mixing_Buffer]
	mov	edi,160*3+59*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GMI_Channels]
	mov	edi,160*3+74*2
	mov	bl,30
	call	PrintL
	;
	mov	eax,ds:[GUS_IRQ_Counter]
	mov	edi,160*12+37*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GUS_Event_Counter]
	mov	edi,160*13+37*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GUS_Wave_Counter]
	mov	edi,160*14+37*2
	mov	bl,30
	call	PrintH
	mov	eax,ds:[GUS_Ramp_Counter]
	mov	edi,160*15+37*2
	mov	bl,30
	call	PrintH
	retn
;
GUS:	SWITCH_FRAME
	call	Display_GUS_Screen
	call	Display_Beat
	GETKEY32
	cmp	ax,CUrsor_Left
	jne	short @@K1
		mov	eax,ds:[GMI_Entry_No]
		xor	ebx,ebx
		dec	eax
		call	GMI_Position_Jump
		jmp	GUS
@@K1:	cmp	ax,CUrsor_Right
	jne	short @@K2
		mov	eax,ds:[GMI_Entry_No]
		xor	ebx,ebx
		inc	eax
		call	GMI_Position_Jump
		jmp	GUS
@@K2:   cmp	ax,'+'
	jne	short @@K6
		mov	eax,ds:[GMI_Volume]
		add	eax,4
		call	GMI_Set_Volume
		jmp	GUS
@@K6:	cmp	ax,'-'
	jne	short @@K7
		mov	eax,ds:[GMI_Volume]
		sub	eax,4
		js	GUS
		call	GMI_Set_Volume
		jmp	GUS
@@K7:	cmp	ax,Escape
	jne	GUS
	retn
;
;   GOMEZ MUSIC INTERFACE                                PRINT-FUNCTIONS
;
PrintL: add	edi,ds:[This_Page]
	sub	edi,ds:[DATA32_Address]
	xor	bh,bh				;BH = Number counter
@@L1:	xor	edx,edx
	mov	ecx,10
	idiv	ecx
	push	edx				;Save number
	inc	bh
	test	eax,eax
	jnz	short @@L1

@@L2:	pop	eax
	add	al,'0'
	mov	ah,bl
	stosw
	dec	bh
	jnz	short @@L2
	retn
;
PrintH: add	edi,ds:[This_Page]
	sub	edi,ds:[DATA32_Address]
	mov	edx,eax				;EDX = Number to print
	mov	bh,8
@@L1:	xor	eax,eax
	shld	eax,edx,4
	shl	edx,4
	mov	ah,bl
	add	al,'0'
	cmp	al,'9'
	jbe	short @@1
	add	al,'A'-'0'-10
@@1:	stosw
	dec	bh
	jnz	short @@L1
	retn
;
PrintT:	add	edi,ds:[This_Page]
	sub	edi,ds:[DATA32_Address]
	mov	ah,bl				;AH = Attribute
@@L1:	lodsb
	test	al,al
	jz	short @@End
	stosw
	jmp	short @@L1
@@End:	retn

;
;   GOMEZ MUSIC INTERFACE                            OSCILLOSCOPE FUNCTIONS
;
ALIGN 4
Old_Scope	dd 	320 dup (0)
Scope PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov 	ds:[v86_eax],13h
	mov	eax,10h
	call	Invoke_Real_Int		;Init 320x200x256 VGA-mode
	;
@@L2:   WAIT_RETRACE
	mov	edi,0a0000h
	sub	edi,ds:[DATA32_Address]
	mov	esi,ds:[GMI_Mixing_Buffer]
	mov	ebx,4
	test	ds:[GMI_Flags],GMI_USE_STEREO
	jz	short @@1
	shl	ebx,1
@@1:	xor	ecx,ecx
@@L1:	mov	eax,ds:[Old_Scope+4*ecx]
	mov	byte ptr ds:[edi+eax],0
	mov	eax,ds:[esi]
	sar	eax,15
	imul	eax,320
	add	eax,320*100
	mov	ds:[Old_Scope+4*ecx],eax
	mov	byte ptr ds:[edi+eax],10
	add	esi,ebx
	inc	edi
	inc	ecx
	cmp	ecx,320
	jb	short @@L1
	;
	GETKEY32
	test	ax,ax
	jz	@@L2
	;
	mov 	ds:[v86_eax],3h
	mov	eax,10h
	call	Invoke_Real_Int		;Go to text-mode

	pop	ebp
	pop	edi
	pop	esi
	retn
Scope ENDP


;
;   GOMEZ MUSIC INTERFACE                                THE-DRAW DATA FILE
;
MAIN_SCREEN LABEL BYTE
	DB      ' ',59,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,' ',59,' ',59
	DB      ' ',59,' ',27,'[',27,'t',27,'i',27,'t',27,'l',27,'e',27
	DB      ']',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',1,' ',59
        DB      ' ',59,'',49,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,' ',1,' ',59,' '
        DB      59,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,' ',59,' ',59,' '
        DB      59,' ',27,' ',27,'p',27,'a',27,'t',27,'t',27,'e',27,'r'
	DB      27,'n',27,':',27,' ',27,' ',27,' ',27,'/',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,'b',27,'e',27,'a',27,'t',27,':'
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'t',27,'e',27,'m'
        DB      27,'p',27,'o',27,':',27,' ',27,' ',27,' ',27,'/',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'v',27,'o',27,'l'
        DB      27,'u',27,'m',27,'e',27,':',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'f',27,'r',27,'e',27,'q',27,'u',27,'e',27,'n'
        DB      27,'c',27,'y',27,':',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'H',27,'z',27,' ',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,'',27,'[',27,'i',27,'n',27,'s',27,'t'
        DB      27,'r',27,'u',27,'m',27,'e',27,'n',27,'t',27,'.',27,'n'
        DB      27,'a',27,'m',27,'e',27,']',27,'',27,'',27,'',27,''
        DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
	DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'s',27,''
        DB      27,'',27,'[',27,'a',27,'d',27,'r',27,']',27,'',27,''
        DB      27,'',27,'',27,'[',27,'s',27,'i',27,'z',27,'e',27,']'
        DB      27,'',27,'',27,'[',27,'l',27,'s',27,'t',27,'a',27,'r'
        DB      27,'t',27,']',27,'',27,'',27,'[',27,'l',27,'e',27,'n'
        DB      27,'d',27,']',27,'',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,30,27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
	DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59,' '
	DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59,' '
        DB      59,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59,' '
        DB      59,' ',27,31,27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,''
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59,' '
        DB      59,' ',27,'',27,'',27,'',27,'',27,'',27,'',27,''
	DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
	DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
        DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
	DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
	DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
        DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
        DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
        DB      27,'',27,'',27,'',27,'',27,'',27,'',27,'',27,''
	DB      27,'',27,'',27,'',27,'',27,' ',27,' ',11,' ',59,' '
        DB      59,' ',59,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,'',48,''
        DB      48,'',48,'',48,'',48,'',48,'',48,'',48,' ',59,'.'
        DB      75,'.',75,'[',75,'g',75,'o',75,'m',75,'e',75,'z',75,'.'
        DB      75,'m',75,'u',75,'s',75,'i',75,'c',75,'.',75,'p',75,'l'
        DB      75,'a',75,'y',75,']',75,'.',75,'.',75,'.',75,'.',75,'.'
        DB      75,'.',75,'.',75,'.',75,'.',75,'.',75,'.',75,'.',75,'.'
        DB      75,'.',75,'.',75,'.',75,'.',75,'.',75,'.',75,'.',75,'.'
        DB      75,'[',75,'c',75,'o',75,'p',75,'y',75,'r',75,'i',75,'g'
        DB      75,'h',75,'t',75,'.',75,'1',75,'9',75,'9',75,'6',75,']'
        DB      75,'.',75,'.',75,'.',75,'.',75,'[',75,'m',75,'a',75,'r'
        DB      75,'c',75,'.',75,'v',75,'a',75,'n',75,'.',75,'s',75,'h'
	DB      75,'a',75,'n',75,'e',75,'y',75,']',75,'.',75,'.',75

CHANNEL_SCREEN LABEL BYTE
	DB      ' ',59,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,' ',59,' ',59
        DB      ' ',59,' ',27,'[',27,'t',27,'i',27,'t',27,'l',27,'e',27
        DB      ']',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',1,' ',59
        DB      ' ',59,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',1,' ',59
        DB      ' ',59,' ',27,' ',27,'f',27,'l',27,'a',27,'g',27,'s',27
        DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'r',27,'o',27,'w',27,':',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,'t',27,'i',27,'c',27,'k',27
        DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'b',27,'u',27,'f',27,'f',27
	DB      'e',27,'r',27,':',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'c',27,'h',27
	DB      'n',27,':',27,' ',27,' ',27,' ',27,' ',27,' ',11,' ',59
	DB      ' ',59,' ',27,' ',27,'p',27,'a',27,'t',27,'t',27,'e',27
	DB      'r',27,'n',27,':',27,' ',27,' ',27,' ',27,'/',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,'b',27,'e',27,'a',27,'t',27
	DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,'t',27,'e',27
	DB      'm',27,'p',27,'o',27,':',27,' ',27,' ',27,' ',27,'/',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'v',27,'o',27
	DB      'l',27,'u',27,'m',27,'e',27,':',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,'f',27,'r',27,'e',27,'q',27,'u',27,'e',27
	DB      'n',27,'c',27,'y',27,':',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,'H',27,'z',27,' ',27,' ',27,' ',0,' ',59
	DB      ' ',59,' ',27,'',27,'c',27,'h',27,'n',27,'',27,'i',27
        DB      'n',27,'s',27,'',27,'',27,'[',27,'i',27,'h',27,'d',27
        DB      'r',27,']',27,'',27,'',27,'',27,'[',27,'s',27,'h',27
        DB      'd',27,'r',27,']',27,'',27,'',27,'[',27,'h',27,'a',27
        DB      'n',27,'d',27,'l',27,'e',27,']',27,'',27,'[',27,'p',27
        DB      'e',27,'r',27,'i',27,'o',27,'d',27,']',27,'',27,'',27
        DB      '[',27,'f',27,'r',27,'q',27,'.',27,']',27,'',27,'',27
        DB      '',27,'[',27,'t',27,'u',27,'n',27,'e',27,']',27,'',27
        DB      '',27,'',27,'[',27,'f',27,'l',27,'a',27,'g',27,']',27
        DB      '',27,'',27,'',27,'',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'0',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'1',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'2',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'3',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'4',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
	DB      ' ',59,' ',27,'',27,' ',27,'5',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'6',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'7',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'8',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'9',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'A',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'B',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',0,' ',59
	DB      ' ',59,' ',27,'',27,' ',27,'C',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'D',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'E',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59
        DB      ' ',59,' ',27,'',27,' ',27,'F',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27,' ',27
	DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      '',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
	DB      ' ',27,'',27,' ',27,' ',27,'',27,' ',27,' ',11,' ',59
	DB      ' ',59,' ',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,'',27,'',27,'',27
	DB      '',27,'',27,'',27,'',27,'',27,' ',27,' ',11,' ',59
	DB      ' ',59,' ',59,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,'',48
	DB      '',48,'',48,'',48,'',48,'',48,'',48,'',48,' ',59
	DB      '.',79,'.',79,'.',79,'[',79,'g',79,'o',79,'m',79,'e',79
	DB      'z',79,'.',79,'m',79,'u',79,'s',79,'i',79,'c',79,'.',79
	DB      'p',79,'l',79,'a',79,'y',79,'e',79,'r',79,']',79,'.',79
	DB      '.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79
	DB      '.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79
	DB      '.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'[',79
	DB      'c',79,'o',79,'p',79,'y',79,'r',79,'i',79,'g',79,'h',79
	DB      't',79,'.',79,'1',79,'9',79,'9',79,'6',79,']',79,'.',79
	DB      '.',79,'[',79,'v',79,'a',79,'n',79,'.',79,'s',79,'h',79
	DB      'a',79,'n',79,'e',79,'y',79,']',79,'.',79,'.',79,'.',79

GUS_SCREEN LABEL BYTE
	DB      ' ',59,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
	DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,'',49,'',49
        DB      '',49,'',49,'',49,'',49,'',49,'',49,' ',59,' ',59
        DB      ' ',59,' ',27,'[',27,'t',27,'i',27,'t',27,'l',27,'e',27
        DB      ']',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',1,' ',59
        DB      ' ',59,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',1,' ',59
        DB      ' ',59,' ',27,' ',27,'f',27,'l',27,'a',27,'g',27,'s',27
        DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'r',27,'o',27,'w',27,':',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'t',27,'i',27,'c',27,'k',27
	DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'b',27,'u',27,'f',27,'f',27
        DB      'e',27,'r',27,':',27,' ',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,'c',27,'h',27,'n',27
	DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',11,' ',59
	DB      ' ',59,' ',27,' ',27,'p',27,'a',27,'t',27,'t',27,'e',27
        DB      'r',27,'n',27,':',27,' ',27,' ',27,' ',27,'/',27,' ',27
        DB      ' ',27,' ',27,' ',27,' ',27,'b',27,'e',27,'a',27,'t',27
        DB      ':',27,' ',27,' ',27,' ',27,' ',27,' ',27,'t',27,'e',27
        DB      'm',27,'p',27,'o',27,':',27,' ',27,' ',27,' ',27,'/',27
        DB      ' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,'v',27,'o',27
        DB      'l',27,'u',27,'m',27,'e',27,':',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,'f',27,'r',27,'e',27,'q',27,'u',27,'e',27
        DB      'n',27,'c',27,'y',27,':',27,' ',27,' ',27,' ',27,' ',27
        DB      ' ',27,' ',27,'H',27,'z',27,' ',27,' ',27,' ',0,' ',59
        DB      ' ',59,'',49,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,''
        DB      1,'',1,'',1,'',1,'',1,'',1,'',1,' ',1,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
	DB      49,'',49,'',49,'',49,'',49,'',49,'',49,'',49,''
        DB      49,'',49,'',49,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',49,' ',49,' ',49,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,'I',27,'R',27,'Q'
        DB      27,'-',27,'C',27,'o',27,'u',27,'n',27,'t',27,'e',27,'r'
        DB      27,' ',27,' ',27,':',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,'E',27,'v',27,'e'
        DB      27,'n',27,'t',27,'-',27,'C',27,'o',27,'u',27,'n',27,'t'
        DB      27,'e',27,'r',27,':',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,'W',27,'a',27,'v'
        DB      27,'e',27,'-',27,'C',27,'o',27,'u',27,'n',27,'t',27,'e'
        DB      27,'r',27,' ',27,':',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,'R',27,'a',27,'m'
        DB      27,'p',27,'-',27,'C',27,'o',27,'u',27,'n',27,'t',27,'e'
        DB      27,'r',27,' ',27,':',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
	DB      27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' ',27,' '
        DB      27,' ',27,' ',27,' ',1,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
	DB      59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' '
        DB      59,' ',59,' ',59,'',49,'',1,'',1,'',1,'',1,'',1
        DB      '',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1
        DB      '',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1
        DB      '',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1,'',1
        DB      '',1,'',1,'',1,'',1,'',1,'',1,'',1,' ',1,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
        DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59,' ',59
	DB      ' ',59,' ',59,' ',59,'.',79,'.',79,'.',79,'[',79,'g',79
	DB      'o',79,'m',79,'e',79,'z',79,'.',79,'m',79,'u',79,'s',79
	DB      'i',79,'c',79,'.',79,'p',79,'l',79,'a',79,'y',79,'e',79
	DB      'r',79,']',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79
	DB      '.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79
	DB      '.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79,'.',79
	DB      '.',79,'.',79,'[',79,'c',79,'o',79,'p',79,'y',79,'r',79
	DB      'i',79,'g',79,'h',79,'t',79,'.',79,'1',79,'9',79,'9',79
	DB      '6',79,']',79,'.',79,'.',79,'[',79,'v',79,'a',79,'n',79
	DB      '.',79,'s',79,'h',79,'a',79,'n',79,'e',79,'y',79,']',79
	DB      '.',79,'.',79,'.',79
CODE32 ENDS
END