;[]------------------------------------------------------------------------[]
;|                                                                          |
;| (c) 1993,1994,1995 by Marc van Shaney , aka Kaya Memisoglu               |
;|                                                                          |
;| This Source-Code was written by and is copyrighted by Kaya Memisoglu	    |
;| You may use the whole code or only parts of it in your own programs      |
;| whether they are commercial or not. BUT you must give credits for these  |
;| parts to me (Kaya Memisoglu  or  Marc van Shaney).                       |
;| I am not responsible for any damage or loss caused by this program, so   |
;| if you success in erasing your harddisk with this code, then it is your  |
;| own fault and you should not claim me to be responsible...               |
;| I would be very pleased if you also sent me a postcard or even a letter  |
;| if you can use this code. My address:                                    |
;|                                                                          |
;|        Kaya Memisoglu                                                    |
;|        Reichenberger Ring 50                                             |
;|        63512 Hainburg                                                    |
;|        Germany                                                           |
;|                                                                          |
;| You can also leave a message for Marc van Shaney on the Nirvana BBS:     |
;|                                                                          |
;|              Nirvana BBS     ++49-(0)6245-3056      Sysop:Raytrayza      |
;|                                                                          |
;|                                                                          |
;[]------------------------------------------------------------------------[]
;
;[]------------------------------------------------------------------------[]
;|
;| This is the ASM-example for CDMI. It simply loads DEMO.MOD and starts
;| to play this module through the PC-Loudspeaker.
;|
;| You must link this module with CDMI.OBJ, EXT386.OBJ, SPEAKER.ASM,
;|  ADLIB.ASM, SBDMA.ASM and SBTIMER.ASM
;|
;| In addition to APLAY.ASM it shows an oscilloscope and its main
;| purpose is to demonstrate (and to test) the CDMI_Poll_Music function
;|


P386
LOCALS
JUMPS
.MODEL USE16 LARGE
STACK		200h			;512 bytes stack shopuld be enough


include ext386.inc
include cdmi.inc
include devices.inc
include keys.inc
include vga.inc

;This macro shrinks the allocated memory to the size really needed by the
;program, because DOS allocates the WHOLE memory when loading an EXE prog.
;This naturally is not usable if you want to allocate some DOS-Heap.
;(This macro is from EXEPROG.ASM by Borland Inc.)
SHRINK_MEM MACRO
   MOV BX,SP
   ADD BX,15    ;convert SP into paragraphs
   SHR BX,4
   MOV AX,SS    ;calculate size of program using ES PSP address
   ADD BX,AX
   MOV AX,ES
   SUB BX,AX
   MOV AH,4AH   ;resize memory block with PSP
   INT 21H      ;address in ES
   ENDM



.Code
Device_Ptr	dd	?
Frame_Ptr	dd	?
FName		db	"DEMO.MOD",0
Dev0		db	"Using Gravis Ultrasound driver.",13,10,'$'
Dev1		db	"Using SB-DMA driver.",13,10,'$'
Dev2		db	"Using SB-TIMER driver.",13,10,'$'
Dev3		db	"Using AdLib driver.",13,10,'$'
Dev4		db	"Using PC-Speaker driver.",13,10,'$'

PRINT MACRO a
	push ds
	mov ax,cs
	mov ds,ax
	mov dx,OFFSET a
	mov ah,9
	int 21h
	pop ds
      ENDM
main PROC FAR
	.STARTUP
	SHRINK_MEM
	mov eax,DISPLAY_INFO or EXIT_ON_LOWMEM or EXIT_ON_RESET or VERBOSE_PAUSE
	call Init_EXT386 C,4096,eax

	mov bx,SEG GUS_Driver
	mov es,bx
	mov ebx,es:[OFFSET GUS_Driver]		;Get GUS device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G0
	PRINT Dev0
	jmp @@1

@@G0:	mov bx,SEG SBDMA_Driver
	mov es,bx
	mov ebx,es:[OFFSET SBDMA_Driver]	;Get SBDMA device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G1
	PRINT Dev1
	jmp @@1

@@G1:	mov bx,SEG SBTIMER_Driver
	mov es,bx
	mov ebx,es:[OFFSET SBTIMER_Driver]	;Get SBTIMER device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G2
	PRINT Dev2
	jmp @@1

@@G2:	mov bx,SEG ADLIB_Driver
	mov es,bx
	mov ebx,es:[OFFSET ADLIB_Driver]	;Get AdLib device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_DETECT]	;Test for device (IMPORTANT !)
	cmp ax,TRUE
	jne short @@G3
	PRINT Dev3
	jmp @@1

@@G3:	mov bx,SEG SPEAKER_Driver
	mov es,bx
	mov ebx,es:[OFFSET SPEAKER_Driver]	;Get PC-Speaker device
	mov cs:[Device_Ptr],ebx			;Ptr to device-header
	PRINT Dev4

@@1:	mov ax,SEG CDMI_DMA_Address
	mov ds,ax
	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_INIT]		;Init device (IMPORTANT !)
	call CDMI_Load_MOD C,OFFSET FName,cs
	cmp ax,0
	jl ERROR

	call CDMI_Play_Song C,16000,CDMI_LOOP_FLAG or CDMI_MIX_ALWAYS,dword ptr cs:[Device_Ptr]

	Init_Graphic
	mov eax,VGA_Width*VGA_Height
	call Malloc C,eax
	mov cs:[Frame_Ptr],eax

	mov ax,SEG CDMI_Poll_Counter
	mov ds,ax
	mov ds:[CDMI_poll_Counter],4
	or ds:[CDMI_Flags],CDMI_USE_POLLING
 @@2:   call CDMI_Poll_Music
	Clear_Frame cs:[Frame_Ptr],0
	call FDraw_Oscilloscope C,cs:[Frame_Ptr],ds:[CDMI_DMA_Size],ds:[CDMI_DMA_Address],1
	Put_Frame cs:[Frame_Ptr]
	call CDMI_Poll_Music
	GETKEY
	test ax,ax
	jz @@2

	Exit_Graphic

	call CDMI_Stop_Song
	call CDMI_Free_Song
ERROR:	les di,cs:[Device_Ptr]
	call dword ptr es:[di+DRV_EXIT]		;DeInit device (IMPORTANT !)
	call Exit_EXT386
	.EXIT
main ENDP



FDraw_Oscilloscope PROC NEAR
      ARG frame:dword,len:word,mem:dword,farbe:byte
      push bp
      mov bp,sp
      push di
      push esi

      xor ax,ax
      mov fs,ax
      les di,[frame]    	;In ES:DI ist der Puffer
      mov esi,[mem]           	;In FS:ESI sind die Daten

      add di,VGA_Width*100

      mov cx,[len]
      mov al,[farbe]
 @@L1:	movsx dx,[FS:ESI]
	xor dx,01111111b    	;Es mu umgedreht werden !
	sar dx,2
	fastimul bx,dx,VGA_Width
	mov byte ptr [es:di+bx],al
	inc esi
	inc di
 dec cx
 jnz short @@L1

      pop esi
      pop di
      pop bp
      retn
FDraw_Oscilloscope ENDP


END