;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

GMI_SYSTEM_FILE	equ	1

;
;
;
;   GOMEZ MUSIC INTERFACE                                          v1.0
;
;
;
CODE32	segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gmi32.inc
include devices.inc


Free_and_Zero	MACRO a
	LOCAL J
	mov	ecx,a
	test	ecx,ecx
	jz	short J
	call	Free
	mov	a,0
J:
	ENDM


;
;   GOMEZ MUSIC INTERFACE         			DATA AREA
;
;
;
; First come some PUBLIC variables, that will inform the host-program about
; the activities of the GMI. There are also some variables that may be
; modified in order to control some functions of the GMI.
;
; See GMI32.DOC for further information !
;
PUBLIC C GMI_Pattern_No
PUBLIC C GMI_Beat_No
PUBLIC C GMI_Entry_No
PUBLIC C GMI_Row_Address
PUBLIC C GMI_Flags
PUBLIC C GMI_Channel_Flags
PUBLIC C GMI_Channel_Data
PUBLIC C GMI_Volume
PUBLIC C GMI_Channels
PUBLIC C GMI_Tick
PUBLIC C GMI_Speed
PUBLIC C GMI_Tempo
PUBLIC C GMI_Song
PUBLIC C GMI_Tick_Speed
PUBLIC C GMI_Play_Frequency
PUBLIC C GMI_Poll_Counter
PUBLIC C GMI_Reverb
EXTRN  C GMI_IO_Buffer
EXTRN  C GMI_Mixing_Buffer
EXTRN  C GMI_Mixing_Size

ALIGN DWORD
GMI_Pattern_No		DD ?			;Current Pattern-no (read only)
GMI_Beat_No		DD ?			;Row-position (read only)
GMI_Entry_No		DD ?			;Sequency-Position (read only)
GMI_Row_Address		DD ?
GMI_Flags		DD ?			;Active flags (read only)
GMI_Volume		DD 0 			;Current volume (read only)
GMI_Play_Frequency	DD ?

GMI_Channel_Flags	DD 0ffffffffh		;Bits for (de)activating the
GMI_Channels		DD ?			;      Channels (read/write)
GMI_Tick		DD ?			;Tick-counter
GMI_Speed		DD ?
GMI_Tempo		DD ?
GMI_Tick_Speed		DD ?
GMI_Poll_Counter	DD ?			;How many polls left to do ?

GMI_Song		DD 0			;Points to the song-header
GMI_Reverb		REVERB_INFO <>


;
;   GOMEZ MUSIC INTERFACE         		             INTERNAL STUFF
;
ALIGN 16
GMI_Channel_Data	DB SIZE GMI_CHANNEL_INFO * GMI_MAX_CHANNELS dup (?)
GMI_Freq_Table		DD ?
Period_Table		DD 130 dup (?)

Timer_Inc		DW ?
Timer_Pos		DW ?
Old_Flat_Timer		DD ?
Old_Real_TImer		DD ?

BPM_Count		DD ?
BPM_Divider		DD ?
Ticks_Left		DD ?
Current_Row		DD ?
Current_Channel		DD ?

LOOP_Pattern_No		dd ?		;These variables are for a pattern-loop
LOOP_Entry_No		dd ?
LOOP_Beat_No		dd ?
LOOP_Address		dd ?
LOOP_Count		dd 0


;
;   GOMEZ MUSIC INTERFACE         			SOUND DRIVER STUFF
;
PUBLIC DRV_Load_Sample

DRV_Mixing		DD ?
DRV_Init		DD ?
DRV_Exit		DD ?
DRV_Set_Frequency	DD ?
DRV_Set_Sample		DD ?
DRV_Set_Volume		DD ?
DRV_Stop_Sample		DD ?
DRV_Load_Sample		DD ?
DRV_Free_Sample		DD ?
DRV_Init_Mixer		DD ?
DRV_Exit_Mixer		DD ?
DRV_Set_Mixer_Handler	DD ?
DRV_Set_Master_Volume	DD ?

DRV_Play_Voice 		DD ?
DRV_Stop_Voice 		DD ?
DRV_Set_Next_Voice	DD ?
DRV_Set_Play_Handler	DD ?


INFO_Size		DD 0
INFO_Frequency		DD ?
INFO_Channels		DB ?
INFO_Resolution		DB ?
			DW ?
INFO_Flags		DD ?


;
;   GOMEZ MUSIC INTERFACE         		       SOFTWARE MIXER STUFF
;
EXTRN SM_Set_Sample:near
EXTRN SM_Set_Frequency:near
EXTRN SM_Set_VOlumeMono:near
EXTRN SM_Set_VOlumeStereo:near
EXTRN SM_Stop_Sample:near
EXTRN SM_Mixing:near
EXTRN SM_Init_Mixer:near
EXTRN SM_Exit_Mixer:near
EXTRN SM_Set_MAster_VOlume:near
EXTRN SM_Set_Mixer_Handler:near

EXTRN SM_Mix_Mono:near
EXTRN SM_Mix_MonoQ:near
EXTRN SM_Mix_Stereo:near
EXTRN SM_Mix_StereoQ:near
EXTRN SM_Conv_Mono8:near
EXTRN SM_Conv_Mono16:near
EXTRN SM_Conv_Stereo8:near
EXTRN SM_Conv_Stereo16:near

EXTRN SM_DMA_Buffer:dword
EXTRN SM_DMA_Size:dword
EXTRN SM_DMA_Max:dword
EXTRN SM_DMA_Count:dword
EXTRN SM_Mixing_Size:dword
EXTRN SM_Mixing_Buffer:dword
EXTRN SM_Volume_Table:dword
EXTRN SM_Boost_Table:dword
EXTRN SM_Mixing_Proc:dword
EXTRN SM_Convert_Proc:dword



;
;
;
;   GOMEZ MUSIC INTERFACE                               PATTERN-INTERPRETER
;
;
;
;
;
; Now come all effects/commands. Each command performs the following
; things:
;   Increment ESI by size of OPCODE/OPERAND(s)
;   Decrement CL by same size
;   Do some effects
;
; Registers that MUST be preserved:
;   ESI (ptr to pattern-stream)
;   EDI (ptr to channel-info)
;   EBP (Ptr to song-header)
;
; Remind that you never need to set panning or volume, because this will be
; done every tick for implementig volume/panning envelopes.
;
MAX_EFFECTS	equ	48

ALIGN DWORD
PATCommandTable dd OFFSET PAT_Nothing
		dd OFFSET PAT_New_Note
		dd OFFSET PAT_New_Instrument
		dd OFFSET PAT_New_Period
		dd OFFSET PAT_Note_Off
		dd OFFSET PAT_Reset_Instrument
		dd OFFSET PAT_Set_Note
		dd OFFSET PAT_Set_Period
		dd OFFSET PAT_Parameter
		dd OFFSET PAT_Arpeggio
		dd OFFSET PAT_Porta_Up
		dd OFFSET PAT_Porta_Down
		dd OFFSET PAT_Tone_Porta
		dd OFFSET PAT_Vibrato
		dd OFFSET PAT_Porta_and_VSlide
		dd OFFSET PAT_Vibrato_and_VSlide
		dd OFFSET PAT_Tremolo
		dd OFFSET PAT_Set_Panning
		dd OFFSET PAT_Set_Sample_Offset
		dd OFFSET PAT_Volume_Slide
		dd OFFSET PAT_Position_Jump
		dd OFFSET PAT_Set_Volume
		dd OFFSET PAT_Pattern_Break
		dd OFFSET PAT_Set_Tempo
		dd OFFSET PAT_Set_Speed
		dd OFFSET PAT_Set_Global_Volume
		dd OFFSET PAT_Global_Volume_Slide
		dd OFFSET PAT_Set_Envelope_Position
		dd OFFSET PAT_Panning_Slide
		dd OFFSET PAT_Multi_Retrigger
		dd OFFSET PAT_Tremor
		dd OFFSET PAT_ExtraFine_Slide_Up
		dd OFFSET PAT_ExtraFine_Slide_Down
		dd OFFSET PAT_Fine_Slide_Up
		dd OFFSET PAT_Fine_Slide_Down
		dd OFFSET PAT_Set_Glissando_Control
		dd OFFSET PAT_Set_Vibrato_Control
		dd OFFSET PAT_Set_Finetune
		dd OFFSET PAT_Pattern_Loop
		dd OFFSET PAT_Set_Tremolo_Control
		dd OFFSET PAT_Retrigger
		dd OFFSET PAT_Fine_Volume_Slide_Up
		dd OFFSET PAT_Fine_Volume_Slide_Down
		dd OFFSET PAT_Note_Cut
		dd OFFSET PAT_Note_Delay
		dd OFFSET PAT_Pattern_Delay
		dd OFFSET PAT_Set_Filter
		dd OFFSET PAT_Invert_Loop
		dd OFFSET PAT_Fine_Vibrato
		dd OFFSET PAT_New_Note_and_Instrument
		dd OFFSET PAT_Traeller
		dd OFFSET PAT_Reverse_Sample
		dd 128-(($-PATCommandTable)/4) DUP (OFFSET PAT_Parameter)
		dd 32 dup (OFFSET PAT_Set_Channel)
		dd 65 dup (OFFSET PAT_Set_Direct_Volume)
		dd 256-224 dup (OFFSET PAT_Nothing)
;
PAT_Nothing:
	inc	esi
	retn
;
PAT_Parameter:					;This one is used for skipping a stupid value
	add	esi,2
	retn
;
PAT_Set_Note:					;Used for portamentos etc...
	movzx	edx,byte ptr ds:[esi+1]		;EDX = note
	mov	ebx,ds:[edi+CI_SAMPLE_ADDRESS]
	add	esi,2
	mov	eax,ds:[Period_Table+4*edx]	;EAX = Period
	mov	ds:[edi+CI_DST_PERIOD],eax	;Save periods
	;
	test	ds:[edi+CI_FLAGS],FL_NEW_INSTRUMENT
	jz	short @@1
	mov	al,ds:[ebx+SMP_VOLUME]		;AL = Sample volume
	mov	bl,ds:[ebx+SMP_PANNING]
	mov	ds:[edi+CI_VOLUME],al
	mov	ds:[edi+CI_TRM_VOLUME],al
	mov	ds:[edi+CI_PANNING],bl
	and	ds:[edi+CI_FLAGS],NOT FL_NEW_INSTRUMENT
@@1:	retn
;
PAT_Set_Period:					;Used for protamentos etc...
	movzx	eax,word ptr ds:[esi+1]		;EDX = note
	mov	ebx,ds:[edi+CI_SAMPLE_ADDRESS]
	add	esi,3
	mov	ds:[edi+CI_DST_PERIOD],eax	;Save periods
	;
	test	ds:[edi+CI_FLAGS],FL_NEW_INSTRUMENT
	jz	short @@1
	mov	al,ds:[ebx+SMP_VOLUME]		;AL = Sample volume
	mov	bl,ds:[ebx+SMP_PANNING]
	mov	ds:[edi+CI_VOLUME],al
	mov	ds:[edi+CI_TRM_VOLUME],al
	mov	ds:[edi+CI_PANNING],bl
	and	ds:[edi+CI_FLAGS],NOT FL_NEW_INSTRUMENT
@@1:	retn
;
PAT_Note_Off:
	inc	esi
	testflag dword ptr ds:[edi+CI_FLAGS],FL_VOLUME_ENVELOPE
	jnz 	short @@2
	and	ds:[edi+CI_FLAGS],NOT FL_PLAY_CHANNEL
	mov	ecx,ds:[CUrrent_Channel]
	jmp 	ds:[DRV_Stop_Sample]

@@2:	mov 	ds:[edi+CI_FADE_POS],0ffffh
	retn
;
PAT_New_Note:
	mov	ecx,ds:[CUrrent_Channel]
	call	ds:[DRV_Stop_Sample]		;Stop this channel
	movzx	edx,byte ptr ds:[esi+1]		;EDX = note
	add	esi,2
	mov	eax,ds:[Period_Table+4*edx]	;EAX = Period
	mov	ebx,ds:[edi+CI_INSTRUMENT_ADDRESS]
	mov	ds:[edi+CI_PERIOD],eax		;Save periods
	mov	eax,ds:[ebx+INS_AVIB]		;EAX = Auto vibrato stuff
	mov	ecx,ds:[ebx+INS_FADE_OUT]	;ECX = fade-out stuff
	mov	ds:[edi+CI_AVIB],eax
	mov	ds:[edi+CI_FADE_OUT],ecx
	mov	ecx,ds:[ebx+INS_FLAGS]          ;ECX = Instrument flags
	;
	movzx	eax,ds:[ebx+edx+INS_SAMPLE_NOTES]
	fastimul edx,eax,SIZE GMI_SAMPLE
	lea	edx,[edx+ebx+INS_SAMPLES]	;EDX = ptr to Sample_Header
	test	ds:[edi+CI_FLAGS],FL_NEW_INSTRUMENT
	jz	short @@1
	mov	al,ds:[edx+SMP_VOLUME]		;AL = Sample volume
	mov	bl,ds:[edx+SMP_PANNING]
	mov	ds:[edi+CI_VOLUME],al
	mov	ds:[edi+CI_TRM_VOLUME],al
	mov	ds:[edi+CI_PANNING],bl
@@1:    ;
	mov	ds:[edi+CI_SAMPLE_ADDRESS],edx
	mov	ebx,dword ptr ds:[edx+SMP_RESAMPLE]
	xor	eax,eax				;EAX = 0
	mov	ds:[edi+CI_RESAMPLE],ebx	;Save resample
	mov	ds:[edi+CI_FLAGS],ecx		;Save flags
	mov	ds:[edi+CI_VENVELOPE_POS],eax	;Clear this stuff
	mov	ds:[edi+CI_PENVELOPE_POS],eax
	mov	ds:[edi+CI_FADE_POS],eax
	;
	mov	eax,ds:[edx+SMP_HANDLE]		;EAX = Sample-Handle
	xor	ebx,ebx				;EBX = Start address
	mov	ecx,ds:[Current_Channel]
	call	ds:[DRV_Set_Sample]
	mov	edx,ds:[edi+CI_PERIOD]		;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]
	imul	dword ptr ds:[ebx+4*edx]
	shrd	eax,edx,16			;EAX = current frequency
	jmp	ds:[DRV_Set_Frequency]
;
PAT_New_Note_and_Instrument:
	mov	ecx,ds:[CUrrent_Channel]
	call	ds:[DRV_Stop_Sample]		;Stop this channel
	mov	al,byte ptr ds:[esi+1]		;EAX = new inst-number
	and	eax,0ffh
	jz	@@E                      	;Is EAX = 0 ???
	mov	ebx,ds:[ebp+4*eax+SNG_INSTRUMENT_PTR-4]
	movzx	edx,byte ptr ds:[esi+2]		;EDX = note
	add	esi,3
	test	ebx,ebx				;Is it a valid ptr ?
	jz	@@E
	;
	mov	ds:[edi+CI_INSTRUMENT_NUMBER],eax
	mov	ds:[edi+CI_INSTRUMENT_ADDRESS],ebx
	;
	mov	eax,ds:[Period_Table+4*edx]	;EAX = Period
	mov	ds:[edi+CI_PERIOD],eax		;Save periods
	mov	eax,ds:[ebx+INS_AVIB]		;EAX = Auto vibrato stuff
	mov	ecx,ds:[ebx+INS_FADE_OUT]	;ECX = fade-out stuff
	mov	ds:[edi+CI_AVIB],eax
	mov	ds:[edi+CI_FADE_OUT],ecx
	mov	eax,ds:[ebx+INS_FLAGS]          ;EAX = Instrument flags
	xor	ecx,ecx				;ECX = 0
	mov	ds:[edi+CI_FLAGS],eax		;Save flags
	mov	ds:[edi+CI_VENVELOPE_POS],ecx	;Clear this stuff
	mov	ds:[edi+CI_PENVELOPE_POS],ecx
	mov	ds:[edi+CI_FADE_POS],ecx
	;
	movzx	eax,ds:[ebx+edx+INS_SAMPLE_NOTES]
	fastimul edx,eax,SIZE GMI_SAMPLE
	lea	edx,[edx+ebx+INS_SAMPLES]	;EDX = ptr to Sample_Header
	mov	ds:[edi+CI_SAMPLE_ADDRESS],edx

	mov	al,byte   ptr ds:[edx+SMP_VOLUME]
	mov	bl,byte   ptr ds:[edx+SMP_PANNING]
	mov	ecx,dword ptr ds:[edx+SMP_RESAMPLE]
	mov	ds:[edi+CI_VOLUME],al
	mov 	ds:[edi+CI_TRM_VOLUME],al
	mov	ds:[edi+CI_PANNING],bl
	mov	ds:[edi+CI_RESAMPLE],ecx
	;
	mov	eax,ds:[edx+SMP_HANDLE]		;EAX = Sample-Handle
	xor	ebx,ebx				;EBX = Start address
	mov	ecx,ds:[Current_Channel]
	call	ds:[DRV_Set_Sample]
	mov	edx,ds:[edi+CI_PERIOD]		;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]
	imul	dword ptr ds:[ebx+4*edx]
	shrd	eax,edx,16			;EAX = current frequency
	jmp	ds:[DRV_Set_Frequency]
@@E:    retn
;
PAT_New_Period:
	mov	ecx,ds:[CUrrent_Channel]
	call	ds:[DRV_Stop_Sample]		;Stop this channel
	mov	ebx,ds:[edi+CI_INSTRUMENT_ADDRESS]
	movzx	eax,word ptr ds:[esi+1]		;EAX = Period
	add	esi,3
	mov	ds:[edi+CI_PERIOD],eax		;Save periods
	mov	eax,ds:[ebx+INS_AVIB]		;EAX = Auto vibrato stuff
	mov	ecx,ds:[ebx+INS_FADE_OUT]	;ECX = fade-out stuff
	mov	ds:[edi+CI_AVIB],eax
	mov	ds:[edi+CI_FADE_OUT],ecx
	lea	edx,[ebx+INS_SAMPLES]		;EDX = ptr to Sample_Header
	mov	ecx,ds:[ebx+INS_FLAGS]		;ECX = Flags
	;
	test	ds:[edi+CI_FLAGS],FL_NEW_INSTRUMENT
	jz	short @@1
	mov	al,ds:[edx+SMP_VOLUME]		;AL = Sample volume
	mov	bl,ds:[edx+SMP_PANNING]
	mov	ds:[edi+CI_VOLUME],al
	mov	ds:[edi+CI_TRM_VOLUME],al
	mov	ds:[edi+CI_PANNING],bl
@@1:    ;
	mov	ds:[edi+CI_SAMPLE_ADDRESS],edx
	mov	ebx,dword ptr ds:[edx+SMP_RESAMPLE]
	xor	eax,eax				;EAX = 0
	mov	ds:[edi+CI_RESAMPLE],ebx	;Save resample
	mov	ds:[edi+CI_FLAGS],ecx		;Save flags
	mov	ds:[edi+CI_VENVELOPE_POS],eax	;Clear this stuff
	mov	ds:[edi+CI_PENVELOPE_POS],eax
	mov	ds:[edi+CI_FADE_POS],eax
	;
	mov	eax,ds:[edx+SMP_HANDLE]		;EAX = Sample-Handle
	xor	ebx,ebx				;EBX = Start address
	mov	ecx,ds:[Current_Channel]
	call	ds:[DRV_Set_Sample]
	mov	edx,ds:[edi+CI_PERIOD]		;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
;
PAT_New_Instrument:
	mov	al,byte ptr ds:[esi+1]			;EAX = new inst-number
	add	esi,2
	and	eax,0ffh
	jz	short @@E                               ;Is EAX = 0 ???
	mov	ebx,ds:[ebp+4*eax+SNG_INSTRUMENT_PTR-4]	;EBX = Inst. header
	test	ebx,ebx					;Is it a valid ptr ?
	jz	short @@E

	lea	edx,[ebx+INS_SAMPLES]			;EDX = ptr to first sample
	mov	ds:[edi+CI_INSTRUMENT_NUMBER],eax
	mov	ds:[edi+CI_INSTRUMENT_ADDRESS],ebx
	mov	ds:[edi+CI_SAMPLE_ADDRESS],edx
	or	ds:[edi+CI_FLAGS],FL_NEW_INSTRUMENT
@@E:	retn
;
PAT_Reset_Instrument:
	mov	edx,ds:[edi+CI_SAMPLE_ADDRESS]
	xor	eax,eax
	xor	ebx,ebx
	inc	esi
	mov	al,byte ptr ds:[edx+SMP_VOLUME]
	mov	bl,byte ptr ds:[edx+SMP_PANNING]
	mov	ds:[edi+CI_VOLUME],al
	mov 	ds:[edi+CI_TRM_VOLUME],al
	mov	ds:[edi+CI_PANNING],bl
	retn
;
PAT_Set_Sample_Offset:
	mov	edx,ds:[edi+CI_SAMPLE_ADDRESS]
	movzx	ebx,byte ptr ds:[esi+1]
	add	esi,2
	shl	ebx,8				;EBX = Start address
	mov	eax,ds:[edx+SMP_HANDLE]		;EAX = Sample-Handle
	mov	ecx,ds:[Current_Channel]
	jmp 	ds:[DRV_Set_Sample]
;
PAT_Pattern_Break:
	movzx 	eax,byte ptr ds:[esi+1]		;EAX = Row to jump to
	add	esi,2
	xor	ecx,ecx				;ECX = current beat
	mov 	ds:[GMI_Beat_No],eax		;Save beat
	mov	ebx,ds:[GMI_Entry_No]		;EBX=New order entry
	inc	ebx
	cmp	ebx,ds:[ebp+SNG_ORDER_COUNT]
	jb	short @@1
		mov	ebx,ds:[ebp+SNG_RESTART_POSITION]
@@1:    movzx	edx,ds:[ebp+ebx+SNG_ORDER_LIST]	;EDX=Pattern_No
	mov	ds:[GMI_Entry_No],ebx
	mov	ds:[GMI_Pattern_No],edx
	mov	ebx,ds:[ebp+4*edx+SNG_PATTERN_PTR]      ;ESI = pattern-address
	add	ebx,8				;EBX = pattern start
	;                                  
@@L1:	cmp	eax,ecx				;Current_Row = Dst_Row ???
	je	short @@End
	movzx	edx,byte ptr ds:[ebx]		;EDX = row-size
	inc	ecx				;Next beat
	add	ebx,edx				;Next row in pattern
	jmp	short @@L1
	;                                  
@@End:	mov	ds:[GMI_Row_Address],ebx	;Save for next decode
	retn
;
PAT_Position_Jump:
	movzx 	eax,byte ptr ds:[esi+1]		;EAX = Row to jump to
	add	esi,2
	mov 	ds:[GMI_Beat_No],0		;Save beat
	mov	ds:[GMI_Entry_No],eax		;EAX=New order entry
@@1:    movzx	edx,ds:[ebp+eax+SNG_ORDER_LIST]	;EDX=Pattern_No
	mov	ds:[GMI_Pattern_No],edx
	mov	ebx,ds:[ebp+4*edx+SNG_PATTERN_PTR]      ;ESI = pattern-address
	add	ebx,8				;EBX = pattern start
	mov	ds:[GMI_Row_Address],ebx	;Save for next decode
	retn
;
PAT_Set_Panning:
	mov 	al,ds:[esi+1]
	add	esi,2
	mov     ds:[edi+CI_PANNING],al
	retn
;
PAT_Set_Channel:
	sub	eax,128				;EAX = effect no
	inc	esi
	mov	ds:[Current_Channel],eax	;Save channel
	fastimul edi,eax,SIZE GMI_CHANNEL_INFO	;Set channel...
	add	edi,OFFSET GMI_CHannel_Data	;EDI = ptr to channel data
	retn
;
PAT_Set_Volume:
	mov 	al,ds:[esi+1]
	add	esi,2
	mov     ds:[edi+CI_VOLUME],al
	mov 	ds:[edi+CI_TRM_VOLUME],al
	retn
;
PAT_Set_Direct_Volume:
	sub	al,160				;EAX = Volume
	inc	esi
	mov     ds:[edi+CI_VOLUME],al
	mov 	ds:[edi+CI_TRM_VOLUME],al
	retn
;
PAT_Fine_Slide_Up:
	movzx 	eax,byte ptr ds:[esi+1]		;EAX = Slide value
	mov 	edx,ds:[edi+CI_PERIOD]
	shl 	eax,2
	jnz	short @@1
	mov	eax,ds:[edi+CI_PERIOD_SLIDE]
	;                                  
@@1:    add	esi,2
	mov	ds:[edi+CI_PERIOD_SLIDE],eax
	add 	edx,eax				;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov 	ds:[edi+CI_PERIOD],edx		;Save new period
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
;
PAT_Fine_Slide_Down:
	movzx 	eax,byte ptr ds:[esi+1]		;EAX = Slide value
	mov 	edx,ds:[edi+CI_PERIOD]
	shl 	eax,2
	jnz	short @@1
	mov	eax,ds:[edi+CI_PERIOD_SLIDE]
	;                                  
@@1:    add	esi,2
	mov	ds:[edi+CI_PERIOD_SLIDE],eax
	add 	edx,eax				;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov 	ds:[edi+CI_PERIOD],edx		;Save new period
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
;
PAT_ExtraFine_Slide_Up:
	movzx 	eax,byte ptr ds:[esi+1]		;EAX = Slide value
	mov 	edx,ds:[edi+CI_PERIOD]
	and	eax,0ffh
	jnz	short @@1
	mov	eax,ds:[edi+CI_PERIOD_SLIDE]
	;                                  
@@1:    add	esi,2
	mov	ds:[edi+CI_PERIOD_SLIDE],eax
	sub 	edx,eax				;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov 	ds:[edi+CI_PERIOD],edx		;Save new period
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
;
PAT_ExtraFine_Slide_Down:
	mov 	al,byte ptr ds:[esi+1]		;EAX = Slide value
	mov 	edx,ds:[edi+CI_PERIOD]
	and	eax,0ffh
	jnz	short @@1
	mov	eax,ds:[edi+CI_PERIOD_SLIDE]
	;                                  
@@1:    add	esi,2
	mov	ds:[edi+CI_PERIOD_SLIDE],eax
	add 	edx,eax				;EDX = Current period
	mov	ebx,ds:[GMI_Freq_Table]		;EBX = ptr to frq-table
	mov 	ds:[edi+CI_PERIOD],edx		;Save new period
	mov	ecx,ds:[Current_Channel]	;ECX = current channel
	mov	eax,ds:[edi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
;
PAT_Fine_Volume_Slide_Up:
	mov 	al,byte ptr ds:[esi+1]
	add	esi,2
	test	al,al
	jnz	short @@2
	mov	al,ds:[edi+CI_VOLUME_SLIDE]
 @@2:	mov	ds:[edi+CI_VOLUME_SLIDE],al
	;                                  
	add 	al,ds:[edi+CI_VOLUME]
	cmp 	al,64
	jb 	short @@1
	mov 	al,64
 @@1:	mov 	ds:[edi+CI_VOLUME],al
	mov 	ds:[edi+CI_TRM_VOLUME],al
	retn
;
PAT_Fine_Volume_Slide_Down:
	mov 	al,byte ptr ds:[esi+1]
	add	esi,2
	neg	al
	jnz	short @@2
	mov	al,ds:[edi+CI_VOLUME_SLIDE]
@@2:	mov	ds:[edi+CI_VOLUME_SLIDE],al
	;                                  
	add 	al,ds:[edi+CI_VOLUME]
	jns 	short @@1
	xor	al,al
@@1:	mov 	ds:[edi+CI_VOLUME],al
	mov 	ds:[edi+CI_TRM_VOLUME],al
	retn
;
PAT_Set_Speed:
	movzx 	eax,byte ptr ds:[esi+1]
	add	esi,2
	test 	eax,eax
	jz 	short @@1
	cmp 	eax,20h			;if greater than 20h then
	jae 	short @@BPM		;it is BPM else it is ticks
	mov 	ds:[GMI_Speed],eax	;per beat
	mov 	ds:[Ticks_Left],eax
	retn
@@BPM:	mov 	ds:[GMI_Tempo],eax
@@1:	retn
;
PAT_Set_Tempo:
	movzx 	eax,byte ptr ds:[esi+1]
	add	esi,2
	test 	eax,eax
	jz 	short @@1
	mov 	ds:[GMI_Tempo],eax
@@1:	retn
;
PAT_Set_Envelope_Position:
	movzx 	eax,byte ptr ds:[esi+1]
	add	esi,2
	mov 	ds:[edi+CI_VENVELOPE_POS],eax
	retn
;
PAT_Pattern_Loop:
	movzx 	ebx,byte ptr ds:[esi+1]
	add	esi,2
	test 	ebx,ebx
	jz 	short @@1
	dec 	ds:[LOOP_Count]
	jz 	short @@3		;Zero means last pass
	jns 	short @@2		;Sign means first pass
	;                                  
	mov 	ds:[LOOP_Count],ebx
@@2:	mov 	eax,ds:[LOOP_Entry_No]
	mov 	ebx,ds:[LOOP_Pattern_No]
	mov 	ds:[GMI_Entry_No],eax
	mov 	ds:[GMI_Pattern_No],ebx
	mov 	eax,ds:[LOOP_Beat_No]
	mov 	ebx,ds:[LOOP_Address]
	mov 	ds:[GMI_Beat_No],eax
	mov	ds:[GMI_Row_Address],ebx
@@3:	retn
	;                                  
@@1:    mov 	eax,ds:[GMI_Entry_No]
	mov 	ebx,ds:[GMI_Pattern_No]
	mov 	ds:[LOOP_Entry_No],eax
	mov 	ds:[LOOP_Pattern_No],ebx
	mov 	eax,ds:[GMI_Beat_No]
	mov 	ebx,ds:[Current_Row]
	mov 	ds:[LOOP_Beat_No],eax
	mov 	ds:[LOOP_Address],ebx
	retn
;
PAT_Arpeggio:
	mov	bl,ds:[esi+1]			;EBX = arpeggio-values
	mov	ds:[edi+CI_COMMAND],OFFSET DoArpeggio
	add	esi,2
	test	ds:[GMI_Flags],GMI_LINEAR_FREQUENCY
	jnz	short @@LIN
	;
	push 	ebx
	and 	ebx,0fh			;Lower 4 bits
	mov 	eax,ds:[4*ebx+OFFSET ArpeggioTable]
	imul 	dword ptr ds:[edi+CI_PERIOD]
	shrd 	eax,edx,12
	mov 	ds:[edi+CI_ARP2],eax
	pop 	ebx
	shr 	ebx,4			;Upper 4 bits
	mov 	eax,ds:[4*ebx+OFFSET ArpeggioTable]
	mov 	ebx,ds:[edi+CI_PERIOD]
	mov 	ds:[edi+CI_ARP1],ebx
	mul 	ebx
	shrd 	eax,edx,12
	mov 	ds:[edi+CI_ARP3],eax
	retn
	;
@@LIN:	push 	ebx
	and 	ebx,0fh			;Lower 4 bits
	shl	ebx,6
	add  	ebx,ds:[edi+CI_PERIOD]
	mov 	ds:[edi+CI_ARP2],ebx
	pop 	eax
	shr 	eax,4			;Upper 4 bits
	mov 	ebx,ds:[edi+CI_PERIOD]
	shl	eax,6
	mov 	ds:[edi+CI_ARP1],ebx
	add  	eax,ebx
	mov 	ds:[edi+CI_ARP3],eax
	retn
;
PAT_Porta_Up:
	movzx 	eax,byte ptr ds:[esi+1]
	add	esi,2
	shl 	eax,2
	jz 	short @@1
	mov 	ds:[edi+CI_PERIOD_SLIDE],eax
@@1:	mov 	ds:[edi+CI_COMMAND],OFFSET DoSlideUp
	retn
;
PAT_Porta_Down:
	movzx 	eax,byte ptr ds:[esi+1]
	add	esi,2
	shl 	eax,2
	jz 	short @@1
	mov 	ds:[edi+CI_PERIOD_SLIDE],eax
@@1:	mov 	ds:[edi+CI_COMMAND],OFFSET DoSlideDown
	retn
;
PAT_Tone_Porta:
	mov 	eax,ds:[edi+CI_DST_PERIOD]	;EAX = Destination period
	movzx 	ebx,byte ptr ds:[esi+1]		;EBX = Slide speed
	add	esi,2
	test 	eax,eax
	jz 	short @@End
	shl 	ebx,2				;Shift slide speed
	jz 	short @@1
	mov	ds:[edi+CI_PERIOD_SLIDE],ebx
@@1:	cmp 	eax,ds:[edi+CI_PERIOD]		;Destination
	je 	short @@End
	jb 	short @@Up
	mov 	ds:[edi+CI_COMMAND],OFFSET DoPortaDown
	retn
@@Up:	mov 	ds:[edi+CI_COMMAND],OFFSET DoPortaUp
@@End:	retn
;
PAT_Vibrato:
	mov 	bl,ds:[esi+1]			;BL = Vibrato parameter
	add	esi,2
	cmp 	dword ptr ds:[edi+CI_PERIOD],0
	je 	short @@End
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVibrato
	mov 	al,bl
	shr 	al,4  				;Speed in AL
	and 	bl,0fh				;Depth in BL
	shl 	al,2
	jz 	short @@1
	mov 	ds:[edi+CI_VIB_SPEED],al
@@1:    shl	bl,2
	jz 	short @@End
	mov 	ds:[edi+CI_VIB_DEPTH],bl
@@End:	retn
;
PAT_Fine_Vibrato:
	mov 	bl,ds:[esi+1]			;BL = Vibrato parameter
	add	esi,2
	cmp 	dword ptr ds:[edi+CI_PERIOD],0
	je 	short @@End
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVibrato
	mov 	al,bl
	shr 	al,4  				;Speed in AL
	shl 	al,2
	jz 	short @@1
	mov 	ds:[edi+CI_VIB_SPEED],al
@@1:    and 	bl,0fh				;Depth in BL
	jz 	short @@End
	mov 	ds:[edi+CI_VIB_DEPTH],bl
@@End:	retn
;
PAT_Pattern_Delay:
	movzx 	eax,byte ptr ds:[esi+1]
	add	esi,2
	mul 	ds:[GMI_Speed]
	add 	ds:[Ticks_Left],eax
	retn
;
PAT_Tremolo:
	mov 	bl,ds:[esi+1]			;BL = Tremolo parameter
	add	esi,2
	mov 	ds:[edi+CI_COMMAND],OFFSET DoTremolo
	mov 	al,bl
	shr 	al,4  				;Speed in AL
	and	bl,0fh
	shl 	al,2
	jz 	short @@1
	mov 	ds:[edi+CI_TRM_SPEED],al
@@1:    shl 	bl,2				;Depth in BL
	jz 	short @@End
	mov 	ds:[edi+CI_TRM_DEPTH],bl
@@End:	retn
;
PAT_Volume_Slide:
	mov 	al,ds:[esi+1]
	add	esi,2
	test	al,0fh
	jz	short @@1
	and	al,0fh
	neg	al
	mov 	ds:[edi+CI_VOLUME_SLIDE],al
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVOlumeSlideDown
	retn
@@1:	;                                  
	shr	al,4
	jz	short @@Old
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVOlumeSlideUp
	mov 	ds:[edi+CI_VOLUME_SLIDE],al
	retn
@@Old:  ;
	mov	al,ds:[edi+CI_VOLUME_SLIDE]
	test	al,al
	js	@@Down
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVOlumeSlideUp
	retn
@@Down:	mov 	ds:[edi+CI_COMMAND],OFFSET DoVOlumeSlideDown
	retn
;
PAT_Panning_Slide:
	mov 	al,ds:[esi+1]
	add	esi,2
	test 	al,al
	jnz 	short @@2
	mov 	al,ds:[edi+CI_PAN_SPEED]
@@2:	mov 	ds:[edi+CI_PAN_SPEED],al
	test 	al,0f0h
	jz 	short @@1
	mov 	ds:[edi+CI_COMMAND],OFFSET DoPanningSlideLeft
	retn
@@1:   	mov 	ds:[edi+CI_COMMAND],OFFSET DoPanningSlideRight
	retn
;
PAT_Multi_Retrigger:
	mov 	al,byte ptr ds:[esi+1]
	add	esi,2
	mov 	ds:[edi+CI_COMMAND],OFFSET DoMultiRetrigger
	test 	al,al
	jz 	short @@1
	mov 	bl,al
	shr 	bl,4
	and 	al,0fh
	mov 	ds:[edi+CI_TRG_SPEED],al
	mov 	ds:[edi+CI_TRG_VOLUME],bl
	mov 	ds:[edi+CI_TRG_POS],al
@@1:	retn
;
PAT_Tremor:
	mov 	al,ds:[esi+1]
	add	esi,2
	mov 	ds:[edi+CI_COMMAND],OFFSET DoTremor
	test 	al,al
	jz 	short @@2
	mov 	bl,al
	and 	al,0fh
	shr 	bl,4
	mov 	ds:[edi+CI_TRM_ON],bl
	add 	al,bl
	mov 	ds:[edi+CI_TRM_OFF],al
@@2:	retn
;
PAT_Set_Glissando_Control:
	mov 	al,ds:[esi+1]
	add	esi,2
	test 	al,al
	jz 	short @@1
	or 	ds:[GMI_Flags],FL_GLISSANDO_CTRL
	retn
@@1:	and 	ds:[GMI_Flags],NOT FL_GLISSANDO_CTRL
	retn
;
PAT_Set_Tremolo_Control:
	mov 	al,ds:[esi+1]
	add	esi,2
	and 	al,03
	mov 	ds:[edi+CI_TRM_FORM],al
	retn
;
PAT_Set_Vibrato_Control:
	mov 	al,ds:[esi+1]
	add	esi,2
	and 	al,03
	mov 	ds:[edi+CI_VIB_FORM],al
	retn
;
PAT_Set_Finetune:
	add	esi,2
	retn
;
PAT_Retrigger:
	mov 	al,byte ptr ds:[esi+1]
	add	esi,2
	mov 	ds:[edi+CI_COMMAND],OFFSET DoRetrigger
	and 	al,0fh
	jz 	short @@1
	mov 	ds:[edi+CI_TRG_SPEED],al
	mov 	ds:[edi+CI_TRG_POS],al
@@1:	retn
;
PAT_Note_Cut:
	mov 	al,ds:[esi+1]
	add	esi,2
	mov 	ds:[edi+CI_COMMAND],OFFSET DoNoteCut
	mov 	ds:[edi+CI_NOTE_DELAY],al
	retn
;
PAT_Note_Delay:
	mov 	al,ds:[esi+1]
	add	esi,2
	mov 	ds:[edi+CI_COMMAND],OFFSET DoNoteDelay
	mov 	ds:[edi+CI_NOTE_DELAY],al
	retn
;
PAT_Porta_and_VSlide:
	mov 	al,ds:[esi+1]
	add	esi,2
	test	al,0fh
	jz	short @@1
	and	al,0fh
	neg	al
	mov 	ds:[edi+CI_VOLUME_SLIDE],al
	jmp 	@@2
@@1:	;                                  
	shr	al,4
	jz	short @@2
	mov 	ds:[edi+CI_VOLUME_SLIDE],al
@@2:  	;
	mov 	eax,ds:[edi+CI_DST_PERIOD]	;EAX = Destination period
	cmp 	eax,ds:[edi+CI_PERIOD]		;Destination
	jb 	short @@Up
	mov 	ds:[edi+CI_COMMAND],OFFSET DoPortaDown_and_VSlide
	retn
@@Up:	mov 	ds:[edi+CI_COMMAND],OFFSET DoPortaUp_and_VSlide
	retn
;
PAT_Vibrato_and_VSlide:
	mov 	al,ds:[esi+1]
	add	esi,2
	test	al,0fh
	jz	short @@1
	and	al,0fh
	neg	al
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVibrato_and_VSlide
	mov 	ds:[edi+CI_VOLUME_SLIDE],al
	retn
@@1:	;                                  
	shr	al,4
	jz	short @@Old
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVibrato_and_VSlide
	mov 	ds:[edi+CI_VOLUME_SLIDE],al
	retn
@@Old:  ;
	mov 	ds:[edi+CI_COMMAND],OFFSET DoVibrato_and_VSlide
	retn
;
PAT_Set_Filter:
PAT_Invert_Loop:
PAT_Set_Global_Volume:
PAT_Global_Volume_Slide:
PAT_Traeller:
PAT_Reverse_Sample:
	add	esi,2
	retn


;
;
; Now follows the pattern-decoder. Note the structure of a pattern:
;
; Header (8 bytes):
;     1 dword    size of pattern including header
;     1 dword    number of rows in this pattern
;
; Patterndata:
;     [ROW_SIZE] [OPCODE/OPARENDS] [OPCODE/OPERANDS]
;                  
;                  
;              Opcodes including oparnds
;      
;     Size of this row in bytes (including this byte)
;
; Some special values:
;   128-159   Set Channel
;   160-224	Set Volume
;
;
; Note the following things:
;   Not all channels must be saved
;   A zero in row-size means pattern-break.
;   When starting the decoder, the current channel is 0
;      (So you do not need to save a 128d)
;
;
; Note: The following registers must be initialized:
;   DS     -   Code-Alias / Data-Selector
;   ES     -   Code-Alias / Data-Selector
;
Decode_Row PROC NEAR
	mov	edi,OFFSET GMI_Channel_Data
	mov	ecx,ds:[GMI_Channels]
@@L2:	mov	ds:[edi+CI_COMMAND],OFFSET DoNothing
	add	edi,SIZE GMI_CHANNEL_INFO
	dec	ecx
	jnz	short @@L2
	;
	or	ds:[GMI_Flags],GMI_FIRST_TICK
	inc 	ds:[GMI_Beat_No]
	mov 	ebp,ds:[GMI_Song]			;EBP points to song_header
	mov 	esi,ds:[GMI_Row_Address]                ;ESI points to pattern-data
@@Re:	mov 	edi,OFFSET GMI_CHannel_Data		;EDI points to channel-info
	mov	ds:[Current_Row],esi			;Save row start adr.
	mov	ds:[Current_Channel],0
	movzx 	ecx,byte ptr ds:[esi]			;ECX = row-size
	inc	esi					;Point to first opcode
	sub 	cl,1
	jc	short @@Next				;CL=0 ==> Break !
	add	ecx,esi					;ECX = Ptr to next row
	mov	ds:[GMI_Row_Address],ecx
	cmp	ecx,esi					;
	je	short @@End				;CL=1 ==> Ready !
	mov	dword ptr ds:[@@C1-4],ecx		;Save in code !
	;
@@L1:   movzx	eax,byte ptr ds:[esi]			;EAX = opcode
	call	dword ptr ds:[PATCommandTable+4*eax]
	cmp	esi,12345678h				;ESI = opcode-ptr
@@C1:	jb 	short @@L1
@@End:	retn

@@Next:	;
	mov	eax,ds:[GMI_Entry_No]			;EAX=New order entry
	inc	eax
	cmp	eax,ds:[ebp+SNG_ORDER_COUNT]
	jb	short @@1
		mov	eax,ds:[ebp+SNG_RESTART_POSITION]
@@1:    mov	ds:[GMI_Beat_No],0
	movzx	ebx,ds:[ebp+eax+SNG_ORDER_LIST]		;EBX=Pattern_No
	mov	ds:[GMI_Entry_No],eax
	mov	ds:[GMI_Pattern_No],ebx
	mov	esi,ds:[ebp+4*ebx+SNG_PATTERN_PTR]      ;ESI = pattern-address
	add	esi,8					;Skip pattern size (in bytes)
	mov	ds:[GMI_Row_Address],esi		;Save it here
	jmp	@@Re					;Restart decoder
Decode_Row ENDP





;
;   GOMEZ MUSIC INTERFACE         		            EFFECT PROCESSING
;
VibratoTable LABEL BYTE
	db   0, 24, 49, 74, 97,120,141,161,180,197,212,224,235,244
	db 250,253,255,253,250,244,235,224,212,197,180,161,141,120
	db  97, 74, 49, 24
ArpeggioTable LABEL DWORD
	dd 4096,3866,3649,3444,3251,3069,2896,2733,2580,2435,2299
	dd 2170,2048,1933,1824,1722
;
;The following macro is used for tremolo/vibrato etc. It decides which wave-form
;to use and retuens the apropriate value.
;
;AH contains wave-form
;DH contains wave-width
;DL contains wave-position
;
;Returns value in EAX
;
GET_WAVE MACRO
	LOCAL nosn,set,notr,mas
	mov     al,dl			;AL = Wave position
	test    ah,ah			;AH = Wave form
	jnz     short nosn
	 shr    al,2
	 mov    ebx,OFFSET VibratoTable
	 and    al,1fh
	 xlatb
	 mul    dh			;AX = Depth * Wave
	 shr    eax,8
	 test   dl,80h
	 jz     short mas
	 neg    eax
	 jmp    short mas

nosn: 	dec     ah
	jnz     short notr
	 shl    al,1
	 jnc    short set
	  not   al
set:     mul    dh
	 shr    eax,8
	 test   dl,80h
	 jz     short mas
	 neg    eax
	jmp     short mas

notr:    movzx  eax,dh
	 test   dl,80h
	 jz     short mas
	  neg   eax
mas:
	ENDM
;
DoNothing:
	retn
;
DoSlideUp:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov	edx,ds:[esi+CI_PERIOD]
	mov	ebx,ds:[GMI_Freq_Table]
	sub	edx,ds:[esi+CI_PERIOD_SLIDE]
	jle	short @@E
	mov	ds:[esi+CI_PERIOD],edx
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
@@E:	retn
;
DoSlideDown:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov	edx,ds:[esi+CI_PERIOD]
	mov	ebx,ds:[GMI_Freq_Table]
	add	edx,ds:[esi+CI_PERIOD_SLIDE]
	mov	ds:[esi+CI_PERIOD],edx
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
@@E:	retn
;
DoPortaUp:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov	edx,ds:[esi+CI_PERIOD]
	mov	ebx,ds:[esi+CI_DST_PERIOD]
	sub	edx,ds:[esi+CI_PERIOD_SLIDE]
	cmp	edx,ebx
	jge	short @@1
	mov	edx,ebx
@@1:	mov	ds:[esi+CI_PERIOD],edx
	mov	ebx,ds:[GMI_Freq_Table]
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
@@E:	retn
;
DoPortaDown:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov	edx,ds:[esi+CI_PERIOD]
	mov	ebx,ds:[esi+CI_DST_PERIOD]
	add	edx,ds:[esi+CI_PERIOD_SLIDE]
	cmp	edx,ebx
	jle	short @@1
	mov	edx,ebx
@@1:	mov	ds:[esi+CI_PERIOD],edx
	mov	ebx,ds:[GMI_Freq_Table]
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
@@E:	retn
;
DoPortaUp_and_VSlide:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov 	al,ds:[esi+CI_VOLUME]
	add 	al,ds:[esi+CI_VOLUME_SLIDE]
	cmp 	al,64
	jl 	short @@1
	mov 	ds:[esi+CI_VOLUME],64
	mov 	ds:[esi+CI_TRM_VOLUME],64
	mov 	ds:[esi+CI_COMMAND],OFFSET DoPortaUp
	jmp	@@P
@@1:    test	al,al
	jns	short @@2
	xor	al,al
	mov 	ds:[esi+CI_COMMAND],OFFSET DoPortaUp
@@2:	mov 	ds:[esi+CI_VOLUME],al
	mov 	ds:[esi+CI_TRM_VOLUME],al
@@P:	;
	mov	edx,ds:[esi+CI_PERIOD]
	mov	ebx,ds:[esi+CI_DST_PERIOD]
	sub	edx,ds:[esi+CI_PERIOD_SLIDE]
	cmp	edx,ebx
	jge	short @@3
	mov	edx,ebx
@@3:	mov	ds:[esi+CI_PERIOD],edx
	mov	ebx,ds:[GMI_Freq_Table]
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
@@E:	retn
;
DoPortaDown_and_VSlide:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov 	al,ds:[esi+CI_VOLUME]
	add 	al,ds:[esi+CI_VOLUME_SLIDE]
	cmp 	al,64
	jl 	short @@1
	mov 	ds:[esi+CI_VOLUME],64
	mov 	ds:[esi+CI_TRM_VOLUME],64
	mov 	ds:[esi+CI_COMMAND],OFFSET DoPortaDown
	jmp	@@P
@@1:    test	al,al
	jns	short @@2
	xor	al,al
	mov 	ds:[esi+CI_COMMAND],OFFSET DoPortaDown
@@2:	mov 	ds:[esi+CI_VOLUME],al
	mov 	ds:[esi+CI_TRM_VOLUME],al
@@P:	;
	mov	edx,ds:[esi+CI_PERIOD]
	mov	ebx,ds:[esi+CI_DST_PERIOD]
	add	edx,ds:[esi+CI_PERIOD_SLIDE]
	cmp	edx,ebx
	jle	short @@3
	mov	edx,ebx
@@3:	mov	ds:[esi+CI_PERIOD],edx
	mov	ebx,ds:[GMI_Freq_Table]
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp	ds:[DRV_Set_Frequency]
@@E:	retn
;
DoArpeggio:
	mov 	al,ds:[esi+CI_ARPEGGIO_POS]
	mov	ebx,ds:[GMI_Freq_Table]
	cmp	al,1
	je	short @@1
	ja	short @@2
	;
	mov 	edx,ds:[esi+CI_ARP2]
	mov 	byte ptr ds:[esi+CI_ARPEGGIO_POS],1
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp 	ds:[DRV_Set_Frequency]
@@1:    ;
	mov 	edx,ds:[esi+CI_ARP3]
	mov 	byte ptr ds:[esi+CI_ARPEGGIO_POS],2
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp 	ds:[DRV_Set_Frequency]
@@2:    ;
	mov 	edx,ds:[esi+CI_ARP1]
	mov 	byte ptr ds:[esi+CI_ARPEGGIO_POS],0
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp 	ds:[DRV_Set_Frequency]
;
DoVibrato:
	mov 	ah,ds:[esi+CI_VIB_FORM]
	mov 	dx,word ptr ds:[esi+CI_VIB_POS]
	GET_WAVE
	add 	dl,ds:[esi+CI_VIB_SPEED]	;Get sine-increment
	mov	ebx,ds:[GMI_Freq_Table]
	mov 	ds:[esi+CI_VIB_POS],dl	;Save Vibrato-position
	mov 	edx,ds:[esi+CI_PERIOD]		;EDX = period
	add 	edx,eax				;EDX = new period
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp 	ds:[DRV_Set_Frequency]
;
DoVibrato_and_Vslide:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov 	al,ds:[esi+CI_VOLUME]
	add 	al,ds:[esi+CI_VOLUME_SLIDE]
	cmp 	al,64
	jl 	short @@1
	mov 	ds:[esi+CI_VOLUME],64
	mov 	ds:[esi+CI_TRM_VOLUME],64
	mov 	ds:[esi+CI_COMMAND],OFFSET DoVibrato
	jmp	@@E
@@1:    test	al,al
	jns	short @@2
	xor	al,al
	mov 	ds:[esi+CI_COMMAND],OFFSET DoVibrato
@@2:	mov 	ds:[esi+CI_VOLUME],al
	mov 	ds:[esi+CI_TRM_VOLUME],al
@@E:	;
	mov 	ah,ds:[esi+CI_VIB_FORM]
	mov 	dx,word ptr ds:[esi+CI_VIB_POS]
	GET_WAVE
	add 	dl,ds:[esi+CI_VIB_SPEED]	;Get sine-increment
	mov	ebx,ds:[GMI_Freq_Table]
	mov 	ds:[esi+CI_VIB_POS],dl	;Save Vibrato-position
	mov 	edx,ds:[esi+CI_PERIOD]		;EDX = period
	add 	edx,eax				;EDX = new period
	mov	eax,ds:[esi+CI_RESAMPLE]	;EAX = Resample
	imul	dword ptr ds:[ebx+4*edx]	;EAX = current frequency
	shrd	eax,edx,16
	jmp 	ds:[DRV_Set_Frequency]
;
DoTremolo:
	mov 	ah,ds:[esi+CI_TRM_FORM]
	mov 	dx,word ptr ds:[esi+CI_TRM_POS]

	GET_WAVE
	add 	al,ds:[esi+CI_TRM_VOLUME]	;Add sine to period
	jns 	short @@2
	xor 	al,al
	jmp 	short @@3
 @@2:   cmp 	al,64
	jb 	short @@3
	mov 	al,64
 @@3:	add 	dl,ds:[esi+CI_TRM_SPEED]	;Get sine-increment
	mov 	ds:[esi+CI_VOLUME],al
	mov 	ds:[esi+CI_TRM_POS],dl		;Save Vibrato-position
	retn
;
DoRetrigger:
	dec 	ds:[esi+CI_TRG_POS]
	jz 	short @@1
	retn
@@1:   	mov 	al,ds:[esi+CI_TRG_SPEED]
	mov	edx,ds:[esi+CI_SAMPLE_ADDRESS]
	mov 	ds:[esi+CI_TRG_POS],al
	xor	ebx,ebx
	mov	eax,ds:[edx+SMP_HANDLE]		;EAX = Sample-Handle
	jmp 	ds:[DRV_Set_Sample]
;
DoNoteCut:
	dec 	byte ptr ds:[esi+CI_CUT_POS]
	jnz 	short @@1
	xor 	eax,eax
	mov 	ds:[esi+CI_VOLUME],al
	and	ds:[esi+CI_FLAGS],NOT FL_PLAY_CHANNEL
	jmp	ds:[DRV_Stop_Sample]
@@1:	retn
;
DoNoteDelay:
	retn
;
DoTremor:
	mov 	al,ds:[esi+CI_TRM_POS]
	inc 	al
	cmp 	al,ds:[esi+CI_TRM_OFF]
	ja 	short @@1
	cmp 	al,ds:[esi+CI_TRM_ON]
	ja 	short @@2
	mov 	ds:[esi+CI_TRM_POS],al
	retn
	;
 @@1:   mov 	bl,ds:[esi+CI_TRM_VOLUME]
	mov 	ds:[esi+CI_TRM_POS],0
	mov 	ds:[esi+CI_VOLUME],bl
	retn
 @@2:   mov 	ds:[esi+CI_TRM_POS],al
	mov 	ds:[esi+CI_VOLUME],0
	retn
;
DoMultiRetrigger:
	dec 	byte ptr ds:[esi+CI_TRG_POS]
	jz 	short @@1
	retn
 @@1:	mov 	al,ds:[esi+CI_TRG_SPEED]
	mov	bl,ds:[esi+CI_TRG_VOLUME]
	mov 	ds:[esi+CI_TRG_POS],al
	mov 	al,ds:[esi+CI_VOLUME]
	;                                  
	cmp 	bl,5
	jb 	short @@2
	ja 	short @@V1
	mov 	cl,bl
	mov	bl,1
	dec 	cl
	shl 	bl,cl
	sub 	al,bl
	jmp 	short @@E
	;                                  
 @@V1:	cmp 	bl,6
	jne 	short @@V2
	mov 	bl,al
	shr 	bl,2		;3/4 of original volume
	sub 	al,bl
	jmp 	short @@E
 @@V2:  ;                                  
	cmp 	bl,7
	jne 	short @@V3
	shr 	al,1		;1/2 of original volume
	jmp 	short @@E
 @@V3:  ;                                  
	cmp 	bl,8		;Not defined !
	je 	short @@2
	cmp 	bl,0dh
	ja 	short @@V4
	sub 	bl,0dh
	mov 	cl,bl
	mov 	bl,1
	shl 	bl,cl
	add 	al,bl
	jmp 	short @@E
 @@V4:  ;                                  
	cmp 	bl,0eh
	ja 	short @@V5
	mov 	bl,al
	shl 	al,1
	add 	al,bl
	shr 	al,1		;*3/2
	jmp 	short @@E
 @@V5:  ;                                  
	shl 	al,1
	;
 @@E:   cmp 	al,64
	jbe 	short @@Ok
	mov 	al,64
	jg 	short @@Ok
	xor 	al,al
 @@Ok:	mov 	ds:[esi+CI_VOLUME],al
 @@2:	mov	edx,ds:[esi+CI_SAMPLE_ADDRESS]
	xor	ebx,ebx
	mov	eax,ds:[edx+SMP_HANDLE]		;EAX = Sample-Handle
	jmp 	ds:[DRV_Set_Sample]
;
DoPanningSlideRight:
	mov 	al,ds:[esi+CI_PAN_SPEED]
	and	al,0fh
	sub 	ds:[esi+CI_PANNING],al
	jc 	short @@1
	retn
@@1:	mov 	byte ptr ds:[esi+CI_PANNING],0
	mov 	ds:[esi+CI_COMMAND],OFFSET DoNothing
	retn
;
DoPanningSlideLeft:
	mov 	al,ds:[esi+CI_PAN_SPEED]
	shr	al,4
	add 	ds:[esi+CI_PANNING],al
	jc 	short @@1
	retn
@@1:	mov 	byte ptr ds:[esi+CI_PANNING],255
	mov 	ds:[esi+CI_COMMAND],OFFSET DoNothing
	retn
;
DoVolumeSlideUp:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov 	al,ds:[esi+CI_VOLUME]
	add 	al,ds:[esi+CI_VOLUME_SLIDE]
	cmp 	al,64
	jb 	short @@1
	mov 	ds:[esi+CI_VOLUME],64
	mov 	ds:[esi+CI_TRM_VOLUME],64
	mov 	ds:[esi+CI_COMMAND],OFFSET DoNothing
	retn
@@1:	mov 	ds:[esi+CI_VOLUME],al
	mov 	ds:[esi+CI_TRM_VOLUME],al
@@E:	retn
;
DoVolumeSlideDown:
	test	ds:[GMI_Flags],GMI_FIRST_TICK
	jnz	short @@E
	mov 	al,ds:[esi+CI_VOLUME]
	add 	al,ds:[esi+CI_VOLUME_SLIDE]
	jns 	short @@1
	mov 	ds:[esi+CI_VOLUME],0
	mov 	ds:[esi+CI_TRM_VOLUME],0
	mov 	ds:[esi+CI_COMMAND],OFFSET DoNothing
	retn
@@1:	mov 	ds:[esi+CI_VOLUME],al
	mov 	ds:[esi+CI_TRM_VOLUME],al
@@E:	retn
;
DoInverse:
DoVolumeSlide_n_Vibrato:
DoVolumeSlide_n_PortaDown:
DoVolumeSlide_n_PortaUp:
DoTraeller:
	retn

;
;
; This MACRO processes an envelope of the instrument and saves the result
; in the appropriate field of the Channel_Info
;
; envtype can be: FL_VOLUME_ENVELOPE
;             or  FL_PANNING_ENVELOPE
;
; Each envelope is structured like this:
;              word	NOP (Number of Points)
;		word	SUSTAIN
;		word	LOOP_START
;		word	LOOP_END
;		data:	(12 *)
;			word	X
;			word	Y
;
Process_Envelope MACRO envtype
	LOCAL ENDE,L1,L2,NORM,OK,J1,J2
	testflag dword ptr ds:[esi+CI_FLAGS],envtype
	jz ENDE
	;
	mov 	ebx,ds:[esi+CI_INSTRUMENT_ADDRESS]
	if envtype eq FL_VOLUME_ENVELOPE
		envsus 		equ	FL_VOLUME_ENVELOPE_SUSTAIN
		envloop		equ	FL_VOLUME_ENVELOPE_LOOP
		envpos		equ	CI_VENVELOPE_POS
		envdest		equ	CI_ENVELOPE_VOLUME
		add	ebx,INS_VENVELOPE
	else
		envsus 		equ	FL_PANNING_ENVELOPE_SUSTAIN
		envloop		equ	FL_PANNING_ENVELOPE_LOOP
		envpos		equ	CI_PENVELOPE_POS
		envdest		equ	CI_ENVELOPE_PANNING
		add 	ebx,INS_PENVELOPE
	endif
	;
	mov 	eax,ds:[esi+envpos]
	inc 	eax

	testflag dword ptr ds:[esi+CI_FLAGS],envsus
	jz 	short L1
	cmp 	dword ptr ds:[esi+CI_FADE_POS],0
	jne 	short L1
	movzx 	ecx,word ptr ds:[ebx+2]
	mov 	cx,ds:[ebx+4*ecx+8]		;Get sustain point
	cmp 	eax,ecx
	jbe 	short L1
	mov 	eax,ecx				;Set to sustain-value
	jmp 	short Ok
	;
L1:	testflag dword ptr ds:[esi+CI_FLAGS],envloop
	jz 	short Norm
	movzx 	ecx,word ptr ds:[ebx+6]
	mov 	cx,ds:[ebx+4*ecx+8]	   	;Get loop end point
	cmp 	eax,ecx
	jbe 	short Ok
	movzx 	ecx,word ptr ds:[ebx+4]		;Get loop start point
	mov 	ax,ds:[ebx+4*ecx+8]		;
	jmp 	short Ok
	;
Norm:	movzx 	ecx,word ptr ds:[ebx]
	mov 	cx,ds:[ebx+4*ecx+8-4]		;Get last point
	cmp 	eax,ecx
	jb 	short Ok
	mov 	eax,ecx
Ok:	mov 	ds:[esi+envpos],eax
	;
	;
	;Now the volume will be calulate within the envelope
	;
L2:  	add 	ebx,4				;Get the current position
	cmp 	ax,ds:[ebx+4]
	ja 	short L2
	jne 	short J2

J1:	mov 	ax,ds:[ebx+6]			;Get volume
	mov	ds:[esi+envdest],al
	jmp 	short ENDE

J2:	mov 	cx,ds:[ebx+6]	    		;CX = Y2
	sub	cx,ds:[ebx+2]          		;CX = Y2-Y1
	sub 	ax,ds:[ebx]			;AX = X-X1
	imul 	cx				;DX:AX contains delta
	mov 	cx,ds:[ebx+4]			;CX = X2
	sub 	cx,ds:[ebx]			;CX = X2-X1
	idiv 	cx                  		;AX = (Y2-Y1)/(X2-X1)*(X-X1)
	add 	ax,ds:[ebx+2]			;AX = Y(X)+Y1
	mov 	ds:[esi+envdest],al
ENDE:
       ENDM


;
;
; The following routine processes all effects, calls the mixing routine,
; postprocesses the output and eventually calls the reverb-engine etc...
;
Do_Tick PROC NEAR
	mov 	esi,OFFSET GMI_Channel_Data
	xor	ecx,ecx
	;
	@@L1:   push	ecx				;ECX = Channel-No
		test	ds:[esi+CI_FLAGS],FL_PLAY_CHANNEL
		jz	@@Next
		call	ds:[esi+CI_COMMAND]
;		mov	ecx,ss:[esp]			;ECX = Channel-No
;		call 	ds:[esi+CI_COMMAND+4]		;Perform effect
		;
		Process_Envelope FL_VOLUME_ENVELOPE
		Process_Envelope FL_PANNING_ENVELOPE
		;
		xor	eax,eax
		xor	ebx,ebx
		mov	al,ds:[esi+CI_VOLUME]		;AL = volume
		mov	bl,ds:[esi+CI_PANNING]		;EBX = panning
		test	ds:[esi+CI_FLAGS],FL_VOLUME_ENVELOPE
		jz	short @@J3			;JZ: No volume envelope
		;                              
		mov	ecx,ds:[esi+CI_FADE_POS]	;ECX = Fade-pos
		mul	byte  ptr ds:[esi+CI_ENVELOPE_VOLUME]
		test	ecx,ecx				;Is there fade-out ?
		jz	short @@J1			;JE: No fade-out
		sub	ecx,ds:[esi+CI_FADE_OUT]        ;ECX = new fade-pos.
		jg	short @@J2                      ;JG: No overflow !
		xor	ecx,ecx
		and	ds:[esi+CI_FLAGS],NOT FL_PLAY_CHANNEL
		mov	ds:[esi+CI_FADE_POS],ecx	;Save new fade-pos
		mov	ecx,ds:[Current_Channel]
		call	ds:[DRV_Stop_Sample]
		jmp	@@Next
	@@J2:   imul	ecx				;EAX = Volume*Fade-out
		shr	eax,16				;EAX = Real volume
		mov	ds:[esi+CI_FADE_POS],ecx	;Save new fade-pos
	@@J1:   shr	eax,6				;EAX = Current volume
		;                              
	@@J3:   test	ds:[esi+CI_FLAGS],FL_PANNING_ENVELOPE
		jz	short @@J4
		xor	ecx,ecx				;ECX = 0
		sub 	ebx,128				;EBX = Panning-128
		mov 	cl,ds:[esi+CI_ENVELOPE_PANNING]	;ECX = E_Pan
		mov	edx,ebx
		sub 	ecx,32				;ECX = E_Pan-32
		sar	edx,31				;EDX = SIgn of EBX
		xor	ebx,edx
		sub	edx,ebx				;EDX = -Abs(EBX)
		add	edx,128				;EDX = 128-abs(pan-128))
		imul	edx,ecx				;(EPan-32)*(128-abs(pan-128))
		add	ebx,128				;EBX = Orig. Panning
		sar 	edx,5				;.../32
		add 	ebx,edx				;EBX = FInal panning
		;                              
	@@J4:	mov	ecx,ss:[esp]			;ECX = Channel-no
		call	ds:[DRV_Set_Volume]		;Set volume/Panning
		;
	@@Next:	pop 	ecx				;ECX = Channel
		add 	esi,SIZE GMI_CHANNEL_INFO
		inc 	ecx
		cmp	ecx,ds:[GMI_Channels]
		jb	@@L1
	call	ds:[DRV_Mixing]
	;
	and	ds:[GMI_Flags],NOT GMI_FIRST_TICK
	mov 	eax,ds:[BPM_Count]
	xor 	edx,edx
	add 	eax,ds:[GMI_Tempo]
	idiv 	ds:[BPM_Divider]
	mov 	ds:[BPM_Count],edx
	sub 	ds:[Ticks_Left],eax
	jnbe 	short @@End
	mov 	eax,ds:[GMI_Speed]
	add 	ds:[Ticks_Left],eax
	call 	Decode_Row
@@End:	retn
Do_Tick ENDP


;
;
;
;   GOMEZ MUSIC INTERFACE                             INTERRUPTS / HANDLERS
;
;
;
GMI_DMA_Handler:
	push	ds
	mov 	ds,cs:[DATA32_Selector]
	mov	eax,ds:[SM_DMA_Buffer]
	call 	ds:[DRV_Set_Next_Voice]
	and 	ds:[GMI_Flags],NOT GMI_BUFFER_READY_FLAG
	pop	ds
	clc					;Continue output
	retn
;
GMI_Timer_Handler:
	retn
;
GMI_Timer_Interrupt:
	pushad
	mov 	al,20h
	out 	20h,al				;Send EOI to interrupt controler
	test 	cs:[GMI_Flags],GMI_BUSY
	jnz 	@@End
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	or 	ds:[GMI_Flags],GMI_BUSY		;Set interrupt busy flag
	cld
	sti
	;
	inc 	ds:[GMI_Tick]
	test 	ds:[GMI_Flags],GMI_USE_POLLING
	jnz 	@@Poll
	test 	ds:[GMI_Flags],GMI_BUFFER_READY_FLAG
	jz 	short @@2
	cmp 	ds:[SM_DMA_Count],4
	ja 	short @@4
@@2:  	call	Do_Tick
	;
@@4:  	test 	ds:[GMI_Flags],GMI_SUPPORT_INT8
	jz 	short @@5
	mov 	ax,ds:[Timer_Inc]
	add 	ds:[Timer_Pos],ax
	jnc 	short @@5
		pop 	es
		and 	ds:[GMI_Flags],NOT GMI_BUSY
		pop	ds
		popad
		jmp 	cs:[Old_Flat_Timer]
@@5:	pop 	es
	and 	ds:[GMI_Flags],NOT GMI_BUSY
	pop	ds
@@End:  popad
	iretd
	;
@@Poll:	inc ds:[GMI_Poll_Counter]
	jmp short @@4
;
GMI_Wave_Interrupt:
	pushad
	mov 	al,20h
	out 	20h,al				;Send EOI to interrupt controler
	test 	cs:[GMI_Flags],GMI_BUSY
	jnz 	@@End
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	or 	ds:[GMI_Flags],GMI_BUSY		;Set interrupt busy flag
	cld
	sti
	;
	inc 	ds:[GMI_Tick]
	call	Do_Tick
	;
	test 	ds:[GMI_Flags],GMI_SUPPORT_INT8
	jz 	short @@5
	mov 	ax,ds:[Timer_Inc]
	add 	ds:[Timer_Pos],ax
	jnc 	short @@5
		pop 	es
		and 	ds:[GMI_Flags],NOT GMI_BUSY
		pop	ds
		popad
		jmp 	cs:[Old_Flat_Timer]
@@5:	pop 	es
	and 	ds:[GMI_Flags],NOT GMI_BUSY
	pop	ds
@@End:  popad
	iretd
;
GMI_Wave_Handler:
	push	ds
	mov 	ds,cs:[DATA32_Selector]
	fastimul edx,ecx,SIZE GMI_Channel_Info
	and	ds:[edx+GMI_Channel_Data+CI_FLAGS],NOT FL_PLAY_CHANNEL
	pop	ds
	retn

;
;
;
;   GOMEZ MUSIC INTERFACE                               FRONT-END FUNCTIONS
;
;
;
;
;
; Now come the highest-level routines for the user:
;  GMI_Free_Song
;  GMI_Play_Song
;  GMI_Stop_Song
;  GMI_Set_Volume
;  GMI_Uncompress_Pattern
;  GMI_Compress_Pattern
;  GMI_Play_Sample
;
;
;Init_GMI:
;  Input:
;	EAX	- DATA32 ptr to music driver
;	EBX	- Flags
;	ECX	- Desired mixing frequency
;  Output:
;	CF	- Error flag
;
PUBLIC C Init_GMI
Init_GMI PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp
	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	;
	test	ds:[GOMEZ_System],7 shl 11	;Test for FPU
	stc					;Carry for error
	jz	@@End				;No FPU ==> Error
	;
	and	ebx,0fffffh		;Mask away internal flags
	mov	ds:[GMI_Flags],ebx
	mov	ebx,ds:[eax]		;EBX = bytes0...3 of magic
	mov	edx,ds:[eax+4]		;EDX = bytes4...7 of magic
	cmp	ebx,'NUOS'
	je	short @@Sound
	cmp	ebx,'EVAW'
	je	@@Wave
	stc
	jmp	@@End

@@Sound:;
	;
	; Use sound-device like SB,SBDMA etc...
	;
	or 	ds:[GMI_Flags],GMI_SOUND_DRIVER or GMI_FORCE_8BIT_SAMPLES
	mov	ds:[DRV_Set_Frequency],OFFSET SM_Set_Frequency
	mov	ds:[DRV_Set_Volume],OFFSET SM_Set_VolumeMono
	mov	ds:[DRV_Set_Sample],OFFSET SM_Set_Sample
	mov	ds:[DRV_Stop_Sample],OFFSET SM_Stop_Sample
	mov	ds:[DRV_Mixing],OFFSET SM_Mixing
	mov	ds:[DRV_Init_Mixer],OFFSET SM_Init_Mixer
	mov	ds:[DRV_Exit_Mixer],OFFSET SM_Exit_Mixer
	mov	ds:[DRV_Set_Mixer_Handler],OFFSET SM_Set_Mixer_Handler
	mov	ds:[DRV_Set_Master_Volume],OFFSET SM_Set_Master_Volume

	mov	ebx,ds:[eax+32]
	mov	ds:[DRV_Init],ebx
	mov	ebx,ds:[eax+36]
	mov	ds:[DRV_Exit],ebx
	mov	ebx,ds:[eax+44]
	mov	ds:[DRV_Play_Voice],ebx
	mov	ebx,ds:[eax+48]
	mov	ds:[DRV_Stop_Voice],ebx
	mov	ebx,ds:[eax+52]
	mov	ds:[DRV_Set_Next_Voice],ebx
	mov	ebx,ds:[eax+56]
	mov	ds:[DRV_Set_Play_Handler],ebx
	;
	mov	ds:[INFO_Size],0
	mov	ds:[INFO_Frequency],ecx
	mov	ds:[INFO_Channels],1
	test	ds:[GMI_Flags],GMI_USE_STEREO
	jz	short @@1
	mov	ds:[INFO_Channels],2
@@1:	mov	ds:[INFO_Resolution],8
	test	ds:[GMI_Flags],GMI_USE_16BIT
	jz	short @@2
	mov	ds:[INFO_Resolution],16
@@2:	;
	call	ds:[DRV_Init]
	jc	@@End				;Error ???
	;
	mov	eax,OFFSET INFO_Size
	call	ds:[DRV_Play_Voice]
	and	ds:[GMI_Flags],NOT (GMI_USE_STEREO OR GMI_USE_16BIT OR GMI_TIMER_MODE)
	mov	eax,ds:[INFO_Frequency]		;EAX = Play freq.
	mov	ds:[GMI_Play_Frequency],eax
	mov	ds:[SM_Mixing_Proc],OFFSET SM_Mix_Mono
	test	ds:[GMI_Flags],GMI_QUALITY_MODE
	jz	short @@9
	mov	ds:[SM_Mixing_Proc],OFFSET SM_Mix_MonoQ
@@9:	cmp	ds:[INFO_Channels],1
	jbe	short @@3
	or	ds:[GMI_Flags],GMI_USE_STEREO
	mov	ds:[SM_Mixing_Proc],OFFSET SM_Mix_Stereo
	test	ds:[GMI_Flags],GMI_QUALITY_MODE
	jz	short @@3
	mov	ds:[SM_Mixing_Proc],OFFSET SM_Mix_StereoQ
@@3:    ;
	cmp	ds:[INFO_Resolution],8
	jbe	short @@4
	or	ds:[GMI_Flags],GMI_USE_16BIT
@@4:	test	ds:[INFO_Flags],SOUND_USES_TIMER
	jz	short @@5
	or	ds:[GMI_Flags],GMI_TIMER_MODE
@@5:    test	ds:[INFO_Flags],SOUND_SIGNED_DATA
	jz	short @@6
	or	ds:[GMI_Flags],GMI_SIGNED_DATA
@@6:	test	ds:[INFO_Flags],SOUND_LOW_DMA_BUFFER
	jz	short @@6
	or	ds:[GMI_Flags],GMI_LOW_DMA_BUFFER
@@10:	;
	mov	ds:[SM_Convert_Proc],OFFSET SM_Conv_Mono8
	test	ds:[GMI_Flags],GMI_USE_STEREO
	jz	short @@7
	mov	ds:[SM_Convert_Proc],OFFSET SM_Conv_Stereo8
	test	ds:[GMI_Flags],GMI_USE_16BIT
	jz	short @@8
	mov	ds:[SM_Convert_Proc],OFFSET SM_Conv_Stereo16
	jmp	short @@8
@@7:	test	ds:[GMI_Flags],GMI_USE_16BIT
	jz	short @@8
	mov	ds:[SM_Convert_Proc],OFFSET SM_Conv_Mono16
@@8:	;
	test	ds:[GMI_Flags],GMI_LOW_DMA_BUFFER
	jz	short @@High
	mov	ecx,65032                       ;Size of DMA-Buffer
	call	DOS_DMA_Malloc			;Allocate DMA-Buffer
	jc	@@End
	mov	ds:[SM_DMA_Buffer],eax
	jmp	@@J1

@@High:	mov	ecx,65032                       ;Size of DMA-Buffer
	call	DMA_Malloc			;Allocate DMA-Buffer
	jc	@@End
	mov	ds:[SM_DMA_Buffer],eax

@@J1:	mov	ecx,32000
	call	Malloc
	jc	@@End
	mov	ds:[SM_Mixing_Buffer],eax

	mov	ecx,GMI_BOOST_SIZE+16
	call	Malloc
	jc	@@End
	mov	ds:[SM_Boost_Table],eax
	;
	mov	ecx,65*256*4
	call	Malloc				;Allocate volume-table
	jc	@@End
	mov	ds:[SM_Volume_Table],eax
	mov	edi,eax				;DS:EDI = ptr to vol-table
	xor	ebx,ebx				;EBX = curreent volume
@@L1:	xor	ecx,ecx				;256 values to process
	@@L2:	movsx	eax,cl			;EAX = current sample-data
		imul	eax,ebx			;EAX = Vol*Sample (14 Bit)
		shl	eax,5
		stosd				;Save sample (19 Bit)
		inc	cl
		jnz	short @@L2		;Next sample
	inc	bl
	cmp	bl,64
	jbe	@@L1                            ;Next volume
	;
	jmp	@@Common




@@Wave:	;
	;
	; Use wavetable thing like GUS
	;
	or 	ds:[GMI_Flags],GMI_WAVE_DRIVER
	mov	ebx,ds:[eax+32]
	mov	ds:[DRV_Init],ebx
	mov	ebx,ds:[eax+36]
	mov	ds:[DRV_Exit],ebx
	mov	ebx,ds:[eax+44]
	mov	ds:[DRV_Load_Sample],ebx
	mov	ebx,ds:[eax+48]
	mov	ds:[DRV_Free_Sample],ebx
	mov	ebx,ds:[eax+52]
	mov	ds:[DRV_Set_Sample],ebx
	mov	ebx,ds:[eax+56]
	mov	ds:[DRV_Set_Frequency],ebx
	mov	ebx,ds:[eax+60]
	mov	ds:[DRV_Set_Volume],ebx
	mov	ebx,ds:[eax+64]
	mov	ds:[DRV_Stop_Sample],ebx
	mov	ebx,ds:[eax+68]
	mov	ds:[DRV_Init_Mixer],ebx
	mov	ebx,ds:[eax+72]
	mov	ds:[DRV_Exit_Mixer],ebx
	mov	ebx,ds:[eax+76]
	mov	ds:[DRV_Mixing],ebx
	mov	ebx,ds:[eax+80]
	mov	ds:[DRV_Set_Mixer_Handler],ebx
	mov	ebx,ds:[eax+84]
	mov	ds:[DRV_Set_Master_Volume],ebx

	mov	ds:[GMI_Play_Frequency],0
	call	ds:[DRV_Init]
	jc	@@End


@@Common:
	;
	;
	; Common code for wave-tabel and sound-system
	;
	mov	ecx,20000h		;Enough for 32000 periods
	call	Malloc
	mov	ds:[GMI_Freq_Table],eax
	jc	@@End

@@End:	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
Init_GMI ENDP



;
;Exit_GMI:
;  Input:
;	Nothing
;  Output:
;	CF	- error flag
;
PUBLIC C Exit_GMI
Exit_GMI PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]

	Free_And_Zero	ds:[SM_Volume_Table]
	Free_And_Zero	ds:[SM_Boost_Table]
	Free_And_Zero	ds:[GMI_Freq_Table]
	Free_And_Zero	ds:[SM_DMA_Buffer]
	Free_And_Zero	ds:[SM_Mixing_Buffer]

	call	ds:[DRV_Exit]
	pop	ds
	retn
Exit_GMI ENDP




;
;GMI_Free_Song:
;  Input:
;	EAX	- DATA32 ptr to song-header
;  Output:
;	CF	- error flag
;
PUBLIC C GMI_Free_Song
GMI_Free_Song PROC NEAR
	push	ds
	push	es
	push	edi
	push	esi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]
	mov	esi,eax			;ds:ESI points to song header
	test	eax,eax
	jz	@@end

	;
	;
	; First lets free all patterns
	;
	mov	edi,255
@@L1: 	mov	ecx,ds:[esi+4*edi+SNG_PATTERN_PTR]
	test	ecx,ecx			;Is there a pattern allocated ???
	jz	short @@No1
	call	Free

@@No1:	dec	edi
	jns	short @@L1

	;
	;
	; Now lets go for the instruments & samples
	;
	mov	edi,255
@@L2:	mov	ebp,ds:[esi+4*edi+SNG_INSTRUMENT_PTR]
	test	ebp,ebp			;Is there an instrument header
	jz	short @@No2
	test	ds:[ebp+INS_FLAGS],FL_FULL_INSTRUMENT
	jz	short @@No4		;JZ: No samples - only name
	;
	push	edi			;Save inst-counter !
	mov	edi,15*SIZE GMI_SAMPLE
@@L3:	mov	ecx,ds:[ebp+edi+INS_SAMPLES+SMP_ADDRESS]
	test	ecx,ecx			;Is there a sample ???
	jz	short @@No3
	call	Free			;Free sample
@@No3:  test	ds:[GMI_Flags],GMI_WAVE_DRIVER
	jz	short @@NoW
	mov	eax,ds:[ebp+edi+INS_SAMPLES+SMP_HANDLE]
	call	ds:[DRV_Free_Sample]
@@NoW:	sub	edi,SIZE GMI_SAMPLE     ;Next sample-header
	jns	short @@L3
	pop	edi			;Now edi is inst-counter again !
	;
@@No4:	mov	ecx,ebp
	call	Free			;Free instrument header !

@@No2:  dec	edi
	jns	short @@L2

	mov	ecx,esi
	call	Free

@@end:	clc
	pop	ebp
	pop	esi
	pop	edi
	pop	es
	pop	ds
	retn
GMI_Free_Song ENDP




;
;GMI_Play_Song:
;  Input:
;	EAX	- DATA32 ptr to song-header
;  Output:
;	CF	- error flag
;
PUBLIC C GMI_Play_Song
GMI_Play_Song PROC NEAR
	push	ds
	push	es
	push	edi
	push	esi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	ds:[GMI_Song],eax		;Save song header
	mov	esi,eax				;DS:ESI = ptr to song
	;
	mov	ds:[BPM_Divider],125
        mov	ds:[BPM_Count],0
	mov	ds:[GMI_Tick],0
	mov	ds:[GMI_Entry_No],0
	mov	ds:[GMI_Beat_No],0
	mov	ds:[GMI_Poll_Counter],0
	mov	eax,ds:[esi+SNG_START_SPEED]
	mov	ds:[GMI_Speed],eax
	mov	eax,ds:[esi+SNG_START_TEMPO]
	mov	ds:[GMI_Tempo],eax
	mov	eax,ds:[esi+SNG_START_VOLUME]
	mov	ds:[GMI_Volume],eax
	mov	eax,ds:[esi+SNG_CHANNEL_COUNT]
	mov	ds:[GMI_Channels],eax
	movzx	eax,byte ptr ds:[esi+SNG_ORDER_LIST]
	mov	ds:[GMI_Pattern_No],eax
	mov	eax,ds:[esi+4*eax+SNG_PATTERN_PTR]
	add	eax,8				;Skip pattern-size etc...
	mov	ds:[GMI_Row_Address],eax
	;
	mov	eax,18 shl 16			;EAX = 18 Ticks/second
	xor	edx,edx
	mov	ebx,ds:[esi+SNG_TICK_SPEED]
	mov	ds:[GMI_Tick_Speed],ebx
	idiv	ebx
	mov	ds:[Timer_Inc],ax
	mov	ds:[Timer_Pos],0
	;
	mov	eax,ds:[esi+SNG_FLAGS]		;EAX = song flags
	and	eax,GMI_AMIGA_FREQUENCY or GMI_LINEAR_FREQUENCY
	and	ds:[GMI_FLags],0fffffff0h-GMI_BUFFER_READY_FLAG
        or	eax,GMI_PLAYING_FLAG
	or	ds:[GMI_Flags],eax		;Set nmew song-spec flags

	;
	;
	; Now we build the frequency table. Depending wether the desired
	; table is linear or amiga-like (exponential) the formular is:
	;
	; Linear table:
	;	Period_Table[note] = 10*12*16*4 - Note*16*4
	;
	;      Frequency[period]  = 8363 * 2^((6*12*16*4 - period)/(12*16*4))
	;
	;
	; Amiga table:
	;	Period_Table[note] = 27392 / 2^(Note/12)
	;
	;      Frequency[period]  = 8363*1712 / period
	;
	fstcw	ds:[@@CW]		;Save control word
	and	ds:[@@CW],1111000011111111b
	or	ds:[@@CW],0000001100000000b
	fldcw	ds:[@@CW]		;Load control word

	test	eax,GMI_LINEAR_FREQUENCY
	jz	short @@Amiga
	;
	xor	ecx,ecx			;ECX = Notes
	mov	edi,OFFSET Period_Table
@@LL1:  mov	eax,10*12*16*4
	sub	eax,ecx			;EAX = 10*12*16*4 - note*16*4
	stosd
	add	ecx,16*4
	cmp	ecx,128*16*4
	jb	short @@LL1

	xor	ecx,ecx
	mov	edi,ds:[GMI_Freq_Table]
@@LL2:  mov	eax,6*12*16*4
	sub	eax,ecx			;EAX = 6*12*16*4 - period
	push	eax			;Push period
	fild	dword ptr ds:[@@C1]	;ST(1) = 12*16*4
	fild	dword ptr ss:[esp]	;ST(0) = period
	fdiv	st(0),st(1)		;ST(0) = x := period / 12*16*4
	fld	st(0)			;ST(0) = ST(1)
	frndint				;ST(0) = round(ST(0))
	fsub	st(1),st(0)		;ST(1) = fraction
	fxch	st(1)			;ST(0) = fraction / ST(1) = integer
	f2xm1				;ST(0) = 2^ST(0) - 1
	fimul	dword ptr ds:[@@C2]	;ST(0) = 8363 * (2^x - 1)
	fiadd	dword ptr ds:[@@C2]	;ST(0) = 8363 * 2^x
	fscale				;ST(0) = 2^x
	fistp	dword ptr ss:[esp]	;Save result on stack
	ffree	st(0)
	ffree	st(1)
	pop	eax			;EAX = result
	stosd				;Save it !
	inc	ecx
	cmp	ecx,10*12*16*4
	jb	short @@LL2
	jmp	@@Device
	;
@@Amiga:xor	ecx,ecx			;ECX = note
	mov	edi,OFFSET Period_Table
@@AL1:  push	ecx
	fild	dword ptr ss:[esp]	;ST(0) = note
	fidiv	dword ptr ds:[@@C3]	;ST(0) = note / 12
	fld	st(0)			;ST(1) = ST(0)
	frndint				;ST(0) = round(note/12)
	fsub	st(1),st(0)		;ST(1) = fraction
	fxch	st(1)
	f2xm1                           ;ST(0) = 2^fraction - 1
	fiadd	dword ptr ds:[@@C5]	;ST(0) = 2^fraction
	fscale				;ST(0) = 2^(note/12)
	fild	dword ptr ds:[@@C4]	;ST(0) = 27392 / ST(1) = 2^...
	fdiv	st(0),st(1)		;ST(0) = 27392 / 2^(Note/12)
	fistp	dword ptr ss:[esp]	;Save result on stack
	ffree	st(0)
	ffree	st(1)
	pop	eax			;EAX = result
	stosd				;Save it !
	inc	ecx
	cmp	ecx,128
	jb	short @@AL1

	mov	ecx,1
	mov	edi,ds:[GMI_Freq_Table]
	xor	eax,eax
	stosd				;Reset first period
@@AL2:	xor	edx,edx
	mov	eax,8363*1712*256
	div	ecx			;EAX = 8363*1712 / period
	stosd
	inc	ecx
	cmp	ecx,29000		;Highest period
	jb	short @@AL2


@@Device:
	;
	;
	; Now follows some device-specific code (wave-table, sound driver,
	; timer driver)
	;
	test	ds:[GMI_Flags],GMI_WAVE_DRIVER
	jnz	@@Wave
	;
	mov	ecx,ds:[GMI_Channels]
	call	ds:[DRV_Init_Mixer]
	jc	@@End
	;
	test	ds:[GMI_Flags],GMI_TIMER_MODE
	jnz	@@Timer
	;
	mov	ebx,ds:[SM_DMA_Buffer]		;EBX = ptr to DMA-Buffer
	mov	eax,ds:[GMI_Play_Frequency]	;EAX = Sample-Freq
	mov	ds:[ebx+4],eax			;Save play frequency
	mov	ecx,dword ptr ds:[INFO_Channels]
	mov	ds:[ebx+8],ecx
	xor	edx,edx
	idiv	ds:[GMI_Tick_Speed]		;EAX = Samples/Tick
	and 	al,11111110b			;Make it aligned for dword-mode
	mov	ds:[SM_Mixing_Size],eax
	mov	ecx,eax				;ECX = Tick size (in samples)
	test	ds:[GMI_Flags],GMI_USE_STEREO
	jz	short @@1
	shl	ecx,1				;ECX *= 2 for stereo samples
@@1:	test	ds:[GMI_Flags],GMI_USE_16BIT
	jz	short @@2
	shl	ecx,1				;ECX *= 2 for 16bit samples
@@2:    mov	ds:[SM_DMA_Size],ecx		;Save DMA tick size (in bytes)
	mov	eax,65000
	xor	edx,edx				;EDX:EAX is DMA buffer size
	idiv	ecx				;EAX = Number of buffers
	inc	eax				;EAX += One active buffer
	mov	ds:[SM_DMA_Max],eax
	mov	ds:[SM_DMA_Count],1000		;Force restart at buffer 0
	dec	eax
	imul	ds:[SM_Mixing_Size]		;EAX = Number_of_Buffers * size
	mov	ds:[ebx],eax			;Save in Sample-header
	call    Do_Tick
	call	Do_Tick				;Calc next two buffers
	and	ds:[GMI_Flags],NOT GMI_BUFFER_READY_FLAG
	;
	mov	eax,ds:[GMI_Volume]
	call	ds:[DRV_Set_Master_Volume]
	mov	eax,OFFSET GMI_DMA_Handler
	call	ds:[DRV_Set_Play_Handler]
	mov	eax,ds:[SM_DMA_Buffer]
	call	ds:[DRV_Play_Voice]
	mov	eax,ds:[SM_DMA_Buffer]
	call	ds:[DRV_Set_Next_Voice]
	;
	cli					;Turn off interrupts
	mov 	al,36h				;Select timer
	out 	43h,al
	mov 	ebx,ds:[GMI_Tick_Speed]
	inc	ebx
	xor 	edx,edx
	mov 	eax,123333h                    	;Calculate timer constant
	div 	ebx
	out 	40h,al
	shr 	eax,8
	out 	40h,al                      	;Set new timer speed
	;
	xor	eax,eax
	mov     ebx,OFFSET GMI_Timer_Interrupt
	call 	Set_Flat_IRQ
	mov	ds:[Old_Flat_Timer],ebx
	xor	eax,eax
	call	Link_Real_IRQ
	mov	ds:[Old_Real_Timer],ebx
	sti
	clc
	jmp	@@End
	;
@@Timer:mov	ebx,ds:[SM_DMA_Buffer]		;EBX = ptr to DMA-Buffer
	mov	eax,ds:[GMI_Play_Frequency]	;EAX = Sample-Freq
	mov	ds:[ebx+4],eax			;Save play frequency
	mov	ecx,dword ptr ds:[INFO_Channels]
	mov	ds:[ebx+8],ecx			;Save flags etc...
	xor	edx,edx
	idiv	ds:[GMI_Tick_Speed]		;EAX = Samples/Tick
	and 	al,11111110b			;Make it aligned for dword-mode
	mov	ds:[SM_Mixing_Size],eax
	mov	ds:[ebx],eax			;Save sample-size
	lea	edx,[4*eax+10h]			;EDX = Size of one tmp-buffer
	mov	ds:[SM_DMA_Size],edx
	lea	ebx,[ebx+4*eax+10h]		;EBX = ptr to 2nd DMA-Buffer
	mov	ds:[ebx],eax			;Save sample-size
	mov	eax,ds:[GMI_Play_Frequency]
	mov	ds:[ebx+4],eax                  ;Save frequency
	mov	ds:[ebx+8],ecx			;Save flags etc...
	mov	ds:[SM_DMA_Max],2
	mov	ds:[SM_DMA_Count],1000		;Force restart at buffer 0
	mov	ebx,ds:[SM_DMA_Buffer]		;EBX = ptr to whole buffer
	call    Do_Tick
	and	ds:[GMI_Flags],NOT GMI_BUFFER_READY_FLAG
	call	Do_Tick				;Calc next two buffers
	;
	mov	eax,ds:[GMI_Volume]
	call	ds:[DRV_Set_Master_Volume]
	mov	eax,OFFSET GMI_Timer_Handler
	call	ds:[DRV_Set_Play_Handler]
	mov	eax,ds:[SM_DMA_Buffer]
	call	ds:[DRV_Play_Voice]
	mov	eax,ds:[SM_DMA_Buffer]
	add	eax,ds:[SM_DMA_Size]
	call	ds:[DRV_Set_Next_Voice]
	clc
	jmp	@@End
	;
@@Wave: mov	ecx,ds:[GMI_Channels]
	call	ds:[DRV_Init_Mixer]
	jc	@@End
	mov	eax,ds:[GMI_Volume]
	call	ds:[DRV_Set_Master_Volume]
	mov	eax,OFFSET GMI_Wave_Handler
	call	ds:[DRV_Set_Mixer_Handler]
	;
	cli					;Turn off interrupts
	mov 	al,36h				;Select timer
	out 	43h,al
	mov 	ebx,ds:[GMI_Tick_Speed]
	xor 	edx,edx
	mov 	eax,123333h                    	;Calculate timer constant
	div 	ebx
	out 	40h,al
	shr 	eax,8
	out 	40h,al                      	;Set new timer speed
	;
	xor	eax,eax
	mov     ebx,OFFSET GMI_Wave_Interrupt
	call 	Set_Flat_IRQ
	mov	ds:[Old_Flat_Timer],ebx
	xor	eax,eax
	call	Link_Real_IRQ
	mov	ds:[Old_Real_Timer],ebx
	sti
	clc
	jmp	@@End
	;
@@End:	pop	ebp
	pop	esi
	pop	edi
	pop	es
	pop	ds
	retn

	ALIGN DWORD
	@@C1	dd	12*16*4
	@@C2	dd	8363*256
	@@C3	dd	12
	@@C4	dd      27392
	@@C5	dd	1
	@@CW	dw	?
GMI_Play_Song ENDP



;
;GMI_Stop_Song:
;  Input:
;	Nothing
;  Output:
;	CF	- error flag
;
PUBLIC C GMI_Stop_Song
GMI_Stop_Song PROC NEAR
	push	ds
	push	es

	test	ds:[GMI_Flags],GMI_PLAYING_FLAG
	jz	@@End
	test	ds:[GMI_Flags],GMI_WAVE_DRIVER
	jnz	@@Wave
	test	ds:[GMI_Flags],GMI_TIMER_MODE
	jnz	@@Timer

	;
	cli
	call	ds:[DRV_Stop_Voice]		;Stop output
	xor	eax,eax
	call	ds:[DRV_Set_Play_Handler]	;Kill play-handler
	cli					;Make it safer
	mov 	al,36h				;Select timer
	out 	43h,al
	mov	al,0ffh
	out 	40h,al
	out 	40h,al
	xor	eax,eax
	mov     ebx,ds:[Old_Flat_Timer]
	call 	Set_Flat_IRQ
	xor	eax,eax
	mov	ebx,ds:[Old_Real_Timer]
	call	UnLink_Real_IRQ			;Restore timer IRQ
	sti
	call	ds:[DRV_Exit_Mixer]
	jmp	@@End
	;
@@TImer:cli
	call	ds:[DRV_Stop_Voice]		;Stop output
	xor	eax,eax
	call	ds:[DRV_Set_Play_Handler]	;Kill play-handler
	sti
	call	ds:[DRV_Exit_Mixer]
	jmp	@@End
	;
@@Wave: cli					;Make it safer
	mov 	al,36h				;Select timer
	out 	43h,al
	mov	al,0ffh
	out 	40h,al
	out 	40h,al
	xor	eax,eax
	mov     ebx,ds:[Old_Flat_Timer]
	call 	Set_Flat_IRQ
	xor	eax,eax
	mov	ebx,ds:[Old_Real_Timer]
	call	UnLink_Real_IRQ			;Restore timer IRQ
	sti
	call	ds:[DRV_Exit_Mixer]
	xor	eax,eax
	call	ds:[DRV_Set_Mixer_Handler]
	;
@@End:  and	ds:[GMI_Flags],NOT GMI_PLAYING_FLAG
	clc
	pop	es
	pop	ds
	retn
GMI_Stop_Song ENDP




PUBLIC C GMI_Continue_Song
GMI_Continue_Song PROC NEAR
	retn
GMI_Continue_Song ENDP



;
;GMI_Position_Jump:
;  Input:
;	EAX	- entry-no
;	EBX	- beat-no
;  Output:
;	CF	- error flag
;
PUBLIC C GMI_Position_Jump
GMI_Position_Jump PROC NEAR
	push	ds
	mov	ds,cs:[DATA32_Selector]
	mov	edx,ds:[GMI_Song]		;EDX = ptr to song-header
	cmp	eax,ds:[edx+SNG_ORDER_COUNT]
	jae	short @@Err
	movzx	ecx,ds:[edx+eax+SNG_ORDER_LIST]	;ECX = pattern-number
	;
	cli					;Disable music IRQ
	mov	ds:[GMI_Entry_No],eax
	mov	ds:[GMI_Pattern_No],ecx
	mov	edx,ds:[edx+4*ecx+SNG_PATTERN_PTR]
	xor	ecx,ecx				;ECX = beat-counter
	cmp	ds:[edx+4],ebx			;Compare beat-counter
	jb	short @@2
	add	edx,8				;Skip pattern-header
	jmp	@@End
	;
@@2:	add	edx,8
@@L1:   cmp	ecx,ebx				;Current beat == dst-beat ???
	jae	short @@End
	movzx	eax,byte ptr ds:[edx]		;EAX = Row-size
	add	edx,eax
	inc	ecx
	jmp	short @@L1
	;
@@End:  mov	ds:[GMI_Row_Address],edx
	mov	ds:[GMI_Beat_No],ecx		;Beat 0
	sti
	clc
	pop	ds
	retn
	;
@@Err:	stc
	pop	ds
	retn
GMI_Position_Jump ENDP




;
;GMI_Set_Volume:
;   Input:
;	EAX	- New volume
;   Output:
;	EAX	- Current volume
;
PUBLIC C GMI_Set_Volume
GMI_Set_Volume PROC NEAR
	call	ds:[DRV_Set_Master_Volume]
	mov	ds:[GMI_Volume],eax
	retn
GMI_Set_Volume ENDP
code32 ends
END