;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

GMI_SYSTEM_FILE	equ	1

;
;
;
;   GOMEZ MUSIC INTERFACE                                   FILE ROUTINES
;
;
;
CODE32	segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gmi32.inc
include devices.inc



;
;   GOMEZ MUSIC INTERFACE                                      DATA AREA
;
extrn C GMI_Flags:DWORD
extrn C GMI_IO_Buffer:DWORD

extrn DRV_Load_Sample:DWORD

ALIGN DWORD
FHandle			dd	?
FStart			dd	?
Song_Header		dd	?
I_Flags			dd	?
I_Count			dd	?
S_Count			dd	?
P_Count			dd	?
Temp_Ptr		dd	?
No_Rows			dd	?
No_Channels		dd	?
Last_Note		dd	?

IO_Buffer		equ	(OFFSET GMI_IO_Buffer)



;
;   GOMEZ MUSIC INTERFACE                             GENERAL SONG LOADER
;
;
;
; Now comes the general song-Loader of the GMI. The syntax is:
;
;     GMI_Load_Song
;       In:
;           EBX     - DATA32 ptr to file-name
;           EDX     - Start position (Normally 0)
;       Out:
;           EAX     - Ptr to song header or zero on error
;
;
PUBLIC C GMI_Load_Song
GMI_Load_Song PROC NEAR
	push 	ds
	push	ebx
	push	edx

	mov 	ds,cs:[DATA32_Selector]
	mov	ds:[FStart],edx			;First lets save the start pos.

	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[FHandle],eax
	;
	mov	ebx,ds:[FHandle]
	mov	ecx,ds:[FStart]
	mov	al,SEEK_SET
	call 	Seek
	jc	@@Err
	mov 	ebx,ds:[FHandle]		;Handle in EBX
	mov	ecx,4				;4 bytes to read
	mov	edx,OFFSET IO_Buffer
	call 	Read
	jc	@@Err

	mov	ebx,ds:[FHandle]
	mov	ecx,1080
	add	ecx,ds:[FStart]
	mov	al,SEEK_SET
	call 	Seek                    ;Look for M.K. etc...
	mov	ebx,ds:[FHandle]
	mov	edx,OFFSET IO_Buffer+4
	mov	ecx,4
	call 	Read			;Read it !

	mov	ebx,ds:[FHandle]
	mov	ecx,2ch
	add	ecx,ds:[FStart]
	mov	al,SEEK_SET
	call 	Seek
	mov	ebx,ds:[FHandle]
	mov	edx,OFFSET IO_Buffer+8
	mov	ecx,4
	call 	Read			;Read it !

	mov	ebx,ds:[FHandle]
	call 	Close
	jc	@@Err
	;
	cmp 	d ds:[IO_Buffer+4],'.K.M'
	je 	@@MOD
	cmp 	d ds:[IO_Buffer+4],'4TLF'
	je 	@@MOD
	cmp 	d ds:[IO_Buffer+4],'6TLF'
	je 	@@MOD
	cmp 	d ds:[IO_Buffer+4],'8TLF'
	je 	@@MOD
	cmp 	d ds:[IO_Buffer+4],'!K&M'
	je 	@@MOD
	cmp 	d ds:[IO_Buffer+4],'!K!M'
	je 	@@MOD
	;
	cmp 	d ds:[IO_Buffer],'etxE'
	jne 	short @@1
		pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_XM
	;
@@1:	cmp 	d ds:[IO_Buffer],'RAF'
	jne 	short @@2
		pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_FAR
	;
@@2:	cmp 	w ds:[IO_Buffer],'TM'
	jne 	short @@3
	cmp 	b ds:[IO_Buffer+2],'M'
	jne 	short @@3
		pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_MTM
	;
@@3:	cmp 	w ds:[IO_Buffer],06669h
	jne 	short @@4
		pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_669
	;
@@4:	cmp 	d ds:[IO_Buffer+8],'MRCS'
	jne 	short @@5
		pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_S3M
	;
@@5:	cmp 	w ds:[IO_Buffer+5],'HC'
	je 	@@MOD
	cmp 	w ds:[IO_Buffer+6],'HC'
	je 	@@MOD
	;
	mov	ebx,ss:[esp+4]		;DS:EBX points to file-name
	mov 	ecx,128
 @@NAM: mov 	edx,ds:[ebx]
	and 	edx,NOT 20202000h
	cmp 	edx,'DOM.'
	je 	short @@MOD
	cmp 	edx,'MTS.'
	je 	short @@STM
	inc 	ebx
	cmp 	dl,0
	je 	short @@Err
	cmp 	dh,0
	je 	short @@Err
	rol 	edx,16
	cmp 	dl,0
	je 	short @@Err
	cmp 	dh,0
	je 	short @@Err
	dec 	ecx
	jnz 	short @@NAM
	jmp 	short @@Err
	;
@@MOD:          pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_MOD

@@STM:		pop	edx
		pop	ebx
		pop 	ds
		jmp 	GMI_Load_STM
	;
@@Err:	stc
	pop	edx
	pop	ebx
	pop 	ds
	retn
GMI_Load_Song ENDP



;
;
; Load_Sample:
;   Input:
;	EAX	- DATA32 ptr to sample-header
;   Output:
;	CF	- Error flag
;
Load_Sample PROC NEAR
	push	esi
	push	edi
	push	ebp

	mov	ebp,eax				;EBP = Sample-header ptr
	mov	ds:[ebp+SMP_HANDLE],eax 	;Set handle
	;
	test	ds:[GMI_Flags],GMI_FORCE_8BIT_SAMPLES
	jz	short @@1
	test	ds:[ebp+SMP_FLAGS],FL_16BIT
	jz	short @@1
		mov	esi,ds:[ebp+SMP_ADDRESS]
		mov	ecx,ds:[ebp+SMP_SIZE]
		lea	edi,[esi+ecx]
		lea	esi,[esi+2*ecx]
		neg	ecx
	@@L1:	mov	al,ds:[esi+2*ecx+1]
		mov	ds:[edi+ecx],al
		inc	ecx
		jnz	short @@L1
		and	ds:[ebp+SMP_FLAGS],NOT FL_16BIT
		mov     ebx,ds:[ebp+SMP_ADDRESS]
		mov	ecx,ds:[ebp+SMP_SIZE]
		call	Realloc
		jc	@@Err
		mov	ds:[ebp+SMP_ADDRESS],eax
@@1:	;
	test	ds:[GMI_Flags],GMI_WAVE_DRIVER
	jz	short @@Suc
		mov	eax,ds:[ebp+SMP_ADDRESS]
		mov	ebx,ds:[ebp+SMP_SIZE]
		mov	ecx,ds:[ebp+SMP_LOOP_START]
		mov	edx,ds:[ebp+SMP_LOOP_END]
		mov	esi,ds:[ebp+SMP_FLAGS]
		call	ds:[DRV_Load_Sample]
		mov	ds:[ebp+SMP_HANDLE],eax
		jc	@@Err
	test	ds:[GMI_Flags],GMI_MIX_ALWAYS
	jnz	short @@Suc
		mov	ecx,ds:[ebp+SMP_ADDRESS]
		call	Free
		mov	d ds:[ebp+SMP_ADDRESS],0
	;
@@Suc:	clc
@@Err:	pop	ebp
	pop	edi
	pop	esi
	retn
Load_Sample ENDP

;
;   GOMEZ MUSIC INTERFACE                                   XM-LOADER
;
;
;
; Now comes the XM-Loader of the GMI. The syntax is:
;
;     GMI_Load_XM
;       In:
;           EBX     - DATA32 ptr to file-name
;           EDX     - Start position (Normally 0)
;       Out:
;           EAX     - Ptr to song header or zero on error
;
;
PUBLIC C GMI_Load_XM
GMI_Load_XM PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]         ;DS=ES=Code-alias
	mov	ds:[FStart],edx			;First lets save the start pos.

	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[FHandle],eax

	mov	ebx,eax
	mov	ecx,ds:[FStart]
	mov	al,SEEK_SET
	call	Seek				;Seek to start of song

	mov 	ecx,66000
	call 	Malloc                      	;Lets allocate some buffers
	jc 	@@Err
	mov 	ds:[Temp_Ptr],eax

	mov 	ecx,SIZE GMI_SONG_HEADER
	call 	Malloc 				;Allocate song-header
	jc 	@@Err
	mov	ds:[Song_Header],eax

	mov 	ebp,eax				;DS:EBP points to Song_Header
	mov	edi,eax                   	;ES:EDI = ptr to song-header
	xor	eax,eax
	mov 	ecx,SIZE GMI_SONG_HEADER/4
	rep 	stosd				;Clear header
	;
	;
	; Here begins the module-reader. First we will read in the XM-Header
	; and then check for some signature etc...
	;
	mov	ebx,ds:[FHandle]
	mov	ecx,SIZE XM_MAIN_HEADER
	mov	edx,OFFSET IO_Buffer
	call 	Read				;Get main-header

	lea 	edx,[ebp+SNG_ORDER_LIST]
	mov 	ecx,256
	mov	ebx,ds:[FHandle]
	call 	Read				;Get order-table

	cmp 	d ds:[IO_Buffer.XM_Magic],'etxE'
	jne 	@@Err				;No signature - error

	lea	edi,[ebp+SNG_NAME]		;ES:EDI points to song-name
	mov	esi,OFFSET IO_Buffer+XM_NAME
	mov	ecx,20/4                        ;Lets copy the name
	rep	movsd

	movzx 	eax,ds:[IO_Buffer.XM_START_TEMPO]
	mov 	ds:[ebp+SNG_START_TEMPO],eax
	mov 	ax,ds:[IO_Buffer.XM_START_SPEED]
	mov 	ds:[ebp+SNG_START_SPEED],eax
	mov	ds:[ebp+SNG_TICK_SPEED],50
	mov 	ds:[ebp+SNG_START_VOLUME],64
	mov 	ax,ds:[IO_Buffer.XM_ENTRY_COUNT]
	mov 	ds:[ebp+SNG_ORDER_COUNT],eax
	mov 	ax,ds:[IO_Buffer.XM_PATTERN_COUNT]
	mov 	ds:[P_Count],eax
	mov 	ax,ds:[IO_Buffer.XM_INSTRUMENT_COUNT]
	mov 	ds:[I_Count],eax
	mov 	ax,ds:[IO_Buffer.XM_CHANNEL_COUNT]
	mov 	ds:[ebp+SNG_CHANNEL_COUNT],eax
	mov 	eax,GMI_AMIGA_FREQUENCY
	test	ds:[IO_Buffer.XM_FLAGS],1
	jz	short @@9
	mov	eax,GMI_LINEAR_FREQUENCY
@@9:	mov	ds:[ebp+SNG_FLAGS],eax
	;
	;
	; Now all patterns will be read into memory and converted
	; into the GMI internal format
	;
	xor 	edi,edi				;EDI will hold pattern-no
@@L1:   mov	edx,OFFSET IO_Buffer
	mov 	ecx,9				;ECX = Size of pattern-header
	mov	ebx,ds:[FHandle]
	call 	Read 				;Read in header...

	movzx 	ecx,w ds:[IO_Buffer+7]		;ECX = Packed ptn-size
	mov	edx,ds:[Temp_Ptr]
	mov	ebx,ds:[FHandle]
	call 	Read                            ;Read in compressed pattern

	mov	esi,ds:[Temp_Ptr]		;ESI = ptr to source
	movzx	ecx,w ds:[IO_Buffer+5]		;ECX = Number of rows to process
	mov	eax,ds:[ebp+SNG_CHANNEL_COUNT]	;EAX = Number of channels
	call 	Convert_XM			;Convert it !
	mov	ds:[ebp+4*edi+SNG_PATTERN_PTR],eax		;Save new pattern ptr
	jc	@@Err				;Carry ==> Error !

	inc 	edi				;Next pattern...
	dec 	ds:[P_Count]
	jnz 	@@L1

	mov	ecx,ds:[Temp_Ptr]
	call 	Free

	;
	;
	; Now the instruments will be processed
	;
@@L2:   mov	edx,OFFSET IO_Buffer
	mov 	ecx,SIZE XM_INSTRUMENT_MAIN_HEADER	;Size of instrument header
	mov	ebx,ds:[FHandle]
	call 	Read 				;Read in header...

	mov	ecx,SIZE GMI_INSTRUMENT
	cmp	ds:[IO_Buffer.XM_INST_SAMPLE_COUNT],0
	ja	short @@1
	mov	ecx,36				;Room for name & flags
@@1:    push	ecx				;ECX = Size of header
	call	Malloc
	pop	ecx				;ECX = Size of header
	jc	@@Err
	mov	ds:[ebp+SNG_INSTRUMENT_PTR],eax
	mov	edi,eax				;EDI = ptr to inst.-header

	push	edi
	xor	eax,eax
	shr	ecx,2				;ECX = number of dwords to clear
	rep	stosd				;Lets clear the instrument header
	mov 	edi,ss:[esp]			;EDI = ptr to inst-header
	mov	esi,OFFSET IO_Buffer.XM_INST_NAME
	lea 	edi,[edi+INS_NAME]
	mov	ecx,11
	rep	movsw				;Copy it !
	pop	edi
	;
	movzx 	eax,ds:[IO_Buffer.XM_INST_SAMPLE_COUNT]
	test 	eax,eax				;EAX = number of samples
	jz 	@@NextI				;No sample
	mov  	ds:[S_Count],eax               	;Save sample-counter
	mov	edx,OFFSET IO_Buffer
	mov 	ecx,SIZE XM_INSTRUMENT_SUB_HEADER	;Size of instrument header
	mov	ebx,ds:[FHandle]
	call 	Read 				;Read in header...
	jc	@@Err
	mov 	al,ds:[IO_Buffer.XM_INST_AVIB_TYPE]
	mov 	ds:[edi+INS_AVIB_FORM],al
	mov 	al,ds:[IO_Buffer.XM_INST_AVIB_SWEEP]
	mov 	ds:[edi+INS_AVIB_SWEEP],al
	mov 	al,ds:[IO_Buffer.XM_INST_AVIB_DEPTH]
	mov 	ds:[edi+INS_AVIB_DEPTH],al
	mov 	al,ds:[IO_Buffer.XM_INST_AVIB_SPEED]
	mov 	ds:[edi+INS_AVIB_SPEED],al
	movzx 	eax,ds:[IO_Buffer.XM_INST_FADE_OUT]
	mov 	ds:[edi+INS_FADE_OUT],eax
	movzx 	eax,ds:[IO_Buffer.XM_INST_VE_COUNT]
	mov 	ds:[edi+INS_VENVELOPE_SIZE],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_VE_SUSTAIN]
	mov 	ds:[edi+INS_VENVELOPE_SUSTAIN],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_VE_LOOP_START]
	mov 	ds:[edi+INS_VENVELOPE_LOOP_START],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_VE_LOOP_END]
	mov 	ds:[edi+INS_VENVELOPE_LOOP_END],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_PE_COUNT]
	mov 	ds:[edi+INS_PENVELOPE_SIZE],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_PE_SUSTAIN]
	mov 	ds:[edi+INS_PENVELOPE_SUSTAIN],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_PE_LOOP_START]
	mov 	ds:[edi+INS_PENVELOPE_LOOP_START],ax
	movzx 	eax,ds:[IO_Buffer.XM_INST_PE_LOOP_END]
	mov 	ds:[edi+INS_PENVELOPE_LOOP_END],ax
	mov	d ds:[edi+INS_FLAGS],FL_USE_PANNING or FL_PLAY_CHANNEL or FL_FULL_INSTRUMENT
	;
	mov	ebx,edi					;EBX = saved inst-ptr
	lea 	edi,[ebx+INS_VENVELOPE_POINTS]
	mov 	esi,OFFSET IO_Buffer+129-33
	mov 	ecx,48/4
	rep 	movsd					;Copy volume-envelope
	lea 	edi,[ebx+INS_PENVELOPE_POINTS]
	mov 	esi,OFFSET IO_Buffer+177-33
	mov 	ecx,48/4
	rep 	movsd					;Copy panning-envelope
	lea 	edi,[ebx+INS_SAMPLE_NOTES]
	mov 	esi,OFFSET IO_Buffer+33-33
	mov 	ecx,96/4
	rep 	movsd					;Copy sample-note table

	mov	edi,ebx					;EDI = ptr to instrument
	;
	test	ds:[IO_Buffer.XM_INST_VE_TYPE],1
	jz 	short @@V0
	or 	d ds:[edi+INS_FLAGS],FL_VOLUME_ENVELOPE
@@V0:	test	ds:[IO_Buffer.XM_INST_VE_TYPE],2
	jz 	short @@V1
	or 	d ds:[edi+INS_FLAGS],FL_VOLUME_ENVELOPE_SUSTAIN
@@V1:	test	ds:[IO_Buffer.XM_INST_VE_TYPE],4
	jz 	short @@V2
	or 	d ds:[edi+INS_FLAGS],FL_VOLUME_ENVELOPE_LOOP
@@V2:	;
	test	ds:[IO_Buffer.XM_INST_PE_TYPE],1
	jz 	short @@P0
	or 	d ds:[edi+INS_FLAGS],FL_PANNING_ENVELOPE
@@P0:	test	ds:[IO_Buffer.XM_INST_PE_TYPE],2
	jz 	short @@P1
	or 	d ds:[edi+INS_FLAGS],FL_PANNING_ENVELOPE_SUSTAIN
@@P1:	test	ds:[IO_Buffer.XM_INST_PE_TYPE],4
	jz 	short @@P2
	or 	d ds:[edi+INS_FLAGS],FL_PANNING_ENVELOPE_LOOP
@@P2:

	;
	;
	; Now we read in all sample-headers
	;
	; Note the calculation of the resampling factor:
	;
	;	Resample = 2 ^ /(FineTune + RelativeNote*16*8)/12*16*8) shl 16
	;
	lea	edi,[edi+INS_SAMPLES]		;EDI = ptr to sample-header
	push	edi				;Save ptr !
@@L3:	mov	ebx,ds:[FHandle]
	mov 	ecx,40				;Now follow the sample-headers
	mov	edx,OFFSET IO_Buffer
	call 	Read
	;
	mov 	al,b ds:[IO_Buffer+12]
	mov 	ds:[edi+SMP_VOLUME],al
	mov 	al,b ds:[IO_Buffer+15]
	mov 	ds:[edi+SMP_PANNING],al
	mov	ds:[edi+SMP_FLAGS],FL_PLAY_CHANNEL

	fstcw	ds:[@@CW]			;Save control word
	and	ds:[@@CW],1111000011111111b
	or	ds:[@@CW],0000001100000000b    	;Round to next / 64bit precision
	fldcw	ds:[@@CW]			;Load control word
	movsx 	eax,b ds:[IO_Buffer+16]		;EAX = relative note
	dec	eax				;Adjust note by one
	shl	eax,7				;EAX = RelativeNote * 16*8
	movsx	ebx,b ds:[IO_Buffer+13]		;EBX = FineTune
	add	eax,ebx				;EAX = FineTune + RN*16*8
	push	eax
	fild	d ss:[esp]			;ST(0) = EAX
	fidiv	d ds:[@@C1]			;ST(0) /= 12*16*8
	fld	st(0)				;ST(0) = ST(1)
	frndint					;ST(0) = round(ST(0))
	fsub	st(1),st(0)			;ST(1) = fraction
	fiadd	d ds:[@@C3]			;ST(0) += 16bit fudge
	fxch	st(1)				;ST(0) = fraction / ST(1) = integer
	f2xm1					;ST(0) = 2^ST(0) - 1
	fiadd	d ds:[@@C2]			;ST(0) = 2^ST(0)
	fscale					;ST(0) = 2^(x-1)
	fistp	d ss:[esp]			;Save result on stack
	ffree	st(0)
	pop	eax				;EAX = result
	mov 	ds:[edi+SMP_RESAMPLE],eax
	;
	mov 	bl,b ds:[IO_Buffer+14]		;Flags...
	mov 	eax,d ds:[IO_Buffer]		;EAX = Size of sample
	mov 	ecx,d ds:[IO_Buffer+4]		;ECX = Loop-Start
	mov 	edx,d ds:[IO_Buffer+8]		;EDX = Loop-Size
	test 	bl,16				;Is it 16bit ?
	jz 	short @@3
	shr 	eax,1                         	;16bit: shift all values
	shr 	ecx,1
	shr 	edx,1
	or 	d ds:[edi+SMP_FLAGS],FL_16BIT
  @@3:	add 	edx,ecx
	test	bl,2				;Ping-pong loop
	jz 	short @@NP
	or 	d ds:[edi+SMP_FLAGS],FL_PINGPONG_LOOP or FL_LOOP
  @@NP:	test 	bl,3				;Loop
	jnz 	short @@4
	mov 	ecx,0ffffffffh
	jmp	short @@8
  @@4:	or 	d ds:[edi+SMP_FLAGS],FL_LOOP
  @@8:	mov 	ds:[edi+SMP_SIZE],eax
	mov 	ds:[edi+SMP_LOOP_START],ecx
	mov 	ds:[edi+SMP_LOOP_END],edx
	;
	push	edi
	mov	ecx,11				;ECX = Sample-name-size
	mov	esi,OFFSET IO_Buffer+18		;ESI = ptr to name
	lea	edi,[edi+SMP_NAME]		;EDI = ptr to dst-name
	rep	movsw
	pop	edi
	;
	add	edi,SIZE GMI_SAMPLE
	dec	ds:[S_Count]
	jnz 	@@L3

	;
	;
	; Now we read in all sample-datas
	;
	pop	edi				;EDI = ptr to sample-header
	mov	ds:[S_Count],16
@@L4:	mov	ecx,ds:[edi+SMP_SIZE]		;ECX = Sample-size (in samples)
	test	ecx,ecx				;
	jz	@@7
	test	ds:[edi+SMP_FLAGS],FL_16BIT	;16bit sample ???
	jz	short @@6
	shl	ecx,1
@@6:	push	ecx				;Save size in bytes
	call	Malloc
	pop	ecx				;ECX = Size of sample
	jc	@@Err
	mov	ds:[edi+SMP_ADDRESS],eax	;EAX = Sample-address
	mov	ds:[edi+SMP_HANDLE],edi
	mov	esi,eax				;ESI = Sample-address
	mov	edx,eax
	mov	ebx,ds:[FHandle]
	call	Read				;Read in sample
	jc	@@Err
	;
	xor	eax,eax				;EAX = zero
	mov	ecx,ds:[edi+SMP_SIZE]		;ECX = size of sample in samples
	test	ds:[edi+SMP_FLAGS],FL_16BIT	;Is it 16bit ???
	jnz	short @@U16
	@@U8:	add	al,ds:[esi]             ;new=sample[i]+old
		mov	ds:[esi],al		;old=sample[i]=new
		inc	esi
		dec	ecx
		jnz	short @@U8
		jmp	short @@5
	@@U16:	add	ax,ds:[esi]             ;new=sample[i]+old
		mov	ds:[esi],ax		;old=sample[i]=new
		add	esi,2
		dec	ecx
		jnz	short @@U16
@@5:    mov	eax,edi
	call	Load_Sample
	jc	@@Err
	;
@@7:	add	edi,SIZE GMI_SAMPLE
	dec	ds:[S_Count]
	jnz	@@L4				;Sample loop
	;
@@NextI:add	ebp,4
	dec	ds:[I_Count]
	jnz     @@L2				;Main instrument loop
	;
	mov	ebx,ds:[FHandle]
	call	Close				;Close File !
	mov	eax,ds:[Song_Header]
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
	;
@@Err:	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

	ALIGN 	dword
	@@C1	dd	12*16*8
	@@C2	dd	1
	@@C3	dd	16
	@@CW	dw	?
GMI_Load_XM ENDP

;
;
; The patterns are stored as ordinary MOD patterns, except that each
; note is stored as 5 bytes:
;
;    ?      1   (byte) Note (0-71, 0 = C-0)
;   +1      1   (byte) Instrument (0-128)
;   +2      1   (byte) Volume column byte (see below)
;   +3      1   (byte) Effect type
;   +4      1   (byte) Effect parameter
;
; A simle packing scheme is also adopted, so that the patterns not become
; TOO large: Since the MSB in the note value is never used, if is used for
; the compression. If the bit is set, then the other bits are interpreted
; as follows:
;
; bit 0 set: Note follows
;	1 set: Instrument follows
; 	2 set: Volume column byte follows
; 	3 set: Effect follows
; 	4 set: Guess what!
;
;
; In:
;   ES:EBP	-	ptr to song-header
;   ES:ESI    	-	ptr to source
;   ECX     	-	Number of rows
;   EAX	-	Channel-Count
; Out:
;   EAX	-	Ptr to new pattern alloctaed
;
XM_Effect_LUT LABEL BYTE
	db	OC_ARPEGGIO                   	;0
	db	OC_PORTA_UP			;1
	db	OC_PORTA_DOWN			;2
	db	OC_TONE_PORTA			;3
	db	OC_VIBRATO			;4
	db	OC_PORTA_AND_VOLUME_SLIDE	;5
	db	OC_VIBRATO_AND_VOLUME_SLIDE     ;6
	db	OC_TREMOLO                      ;7
	db	OC_SET_PANNING                  ;8
	db	OC_SET_SAMPLE_OFFSET            ;9
	db	OC_VOLUME_SLIDE                 ;a
	db	OC_POSITION_JUMP                ;b
	db	OC_SET_VOLUME                   ;c
	db	OC_PATTERN_BREAK                ;d
	db	OC_PARAMETER                    ;e
	db	OC_SET_SPEED                    ;f
	db	OC_SET_GLOBAL_VOLUME            ;g
	db	OC_GLOBAL_VOLUME_SLIDE          ;h
	db	OC_PARAMETER                    ;i
	db	OC_PARAMETER                    ;j
	db	OC_KEY_OFF                      ;k
	db	OC_SET_ENVELOPE_POSITION        ;l
	db	OC_PARAMETER                    ;m
	db	OC_PARAMETER                    ;n
	db	OC_PARAMETER                    ;o
	db	OC_PANNING_SLIDE		;p
	db	OC_PARAMETER                    ;q
	db	OC_MULTI_RETRIGGER		;r
	db	OC_PARAMETER			;s
	db	OC_TREMOR			;t
	db	OC_PARAMETER                    ;u
	db	OC_PARAMETER                    ;v
	db	OC_PARAMETER                    ;w
	db	OC_PARAMETER          		;x
	db	OC_PARAMETER                    ;y
	db	OC_PARAMETER                    ;z

XM_Ext_Effect_LUT LABEL BYTE
	db	OC_SET_FILTER
	db	OC_FINE_SLIDE_UP
	db	OC_FINE_SLIDE_DOWN
	db	OC_SET_GLISSANDO
	db	OC_SET_VIBRATO
	db	OC_SET_FINETUNE
	db	OC_PATTERN_LOOP
	db	OC_SET_TREMOLO
	db	OC_PARAMETER
	db	OC_RETRIGGER
	db	OC_FINE_VOLUME_SLIDE_UP
	db	OC_FINE_VOLUME_SLIDE_DOWN
	db	OC_NOTE_CUT
	db	OC_NOTE_DELAY
	db	OC_PATTERN_DELAY
	db	OC_INVERT_LOOP

XM_Ext2_Effect_LUT LABEL BYTE
	db	OC_PARAMETER
	db	OC_EXTRA_FINE_SLIDE_UP
	db	OC_EXTRA_FINE_SLIDE_DOWN
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_PARAMETER



Convert_XM PROC NEAR
	push	edi
	mov	ds:[No_Rows],ecx
	mov	ds:[No_Channels],eax

	imul	ecx
	shl	eax,4		;16 bytes /channel and row should be enough !
	mov	ecx,eax
	call	Malloc		;Get some memory
	jc	@@Err
	mov	edi,eax		;ES:EDI points to pattern
	push	edi		;Save start address of pattern
	mov	eax,ds:[No_Rows]
	mov	ds:[edi+4],eax	;Save row-count
	add	edi,8		;Skip pattern-size dword
	;
@@L1:   xor	cl,cl		;CL = Channel number
	push	edi		;Save start address of ths row
	inc	edi		;Skip size of this row

	;
	;
	; This is the inner loop for the channels
	;
@@L2:   mov	ds:[Last_Note],0
	mov	dl,ds:[esi]		;DL = Get first byte
	inc	esi			;Next byte
	test	dl,80h			;Test for XM-Compression
	jnz	short @@Compressed
	mov	dl,31			;DL = Compression flags
	dec	esi			;And go back !
@@Compressed:
	test	dl,31			;Is there any information for me ???
	jz	@@Next_Channel
		test	cl,cl
		jz	short @@NoChannel
		mov	al,OC_SET_CHANNEL
		add	al,cl           ;AL = Set this channel opcode
		stosb			;Set_Channel opcode

	;
	;
	; Lets check if there is a note and/or instrument
	;
@@NoCHannel:
	test	dl,1			;Is there a note ???
	jz	short @@NoNote
		test	dl,2
		jz	short @@NoteOnly
		mov	al,OC_NEW_INSTRUMENT
		mov	ah,ds:[esi+1]	;Get instrument
		stosw			;Save opcode
		mov	al,OC_PLAY_NOTE
		mov	ah,ds:[esi]   	;Get note number
		add	esi,2		;Next source bytes
		cmp	ah,61h		;Is it key off
		je	short @@KeyOff
		mov	ds:[Last_Note],edi
		stosw			;Save opcode
		jmp	@@NoInstrument

@@NoteOnly:     mov	al,OC_PLAY_NOTE
		mov	ah,ds:[esi]     ;Get note-number
		inc	esi		;Next src-byte
		cmp	ah,61h		;Is it key off ???
		je	short @@KeyOff
		mov	ds:[Last_Note],edi
		stosw			;Save opcode
		jmp	@@NoInstrument	;Well... we tested if there was one !

@@KeyOff:
	mov	al,OC_KEY_OFF
	stosb
	jmp	@@NoInstrument

	;
@@NoNote:
	test	dl,2                    ;if tehre is an instrument, then
	jz	short @@NoInstrument	;there is no note...  !!!
		mov	al,OC_RESET_INSTRUMENT
		stosb
		lods 	b ds:[esi]
	;
@@NoInstrument:
	test	dl,4			;Is there a volume coloumn ?
	jz	@@NoVolume
		lods 	b ds:[esi]
		cmp	al,10h
		jb	@@NoVolume
		cmp	al,50h
		ja	short @@Vol1
		add	al,OC_SET_DIRECT_VOLUME-10h	;Set direct_volume opcode
		stosb
		jmp	@@NoVolume

	@@Vol1:	cmp	al,60h
		jb	@@NoVolume
		cmp	al,70h          ;60-6f: Volume slide down
		jae	short @@Vol2
		sub	al,60h
		shl	ax,8
		mov	al,OC_VOLUME_SLIDE
		stosw                   ;Save opcode and operand
		jmp	@@NoVolume
	@@Vol2:	cmp	al,80h          ;70-7f: Volume slide up
		jae	short @@Vol3
		sub	al,70h
		shl	ax,12
		mov	al,OC_VOLUME_SLIDE
		stosw                   ;Save opcode and operand
		jmp	@@NoVolume
	@@Vol3:	cmp	al,90h          ;80-8f: Fine Volume slide down
		jae	short @@Vol4
		sub	al,80h
		shl	ax,8
		mov	al,OC_FINE_VOLUME_SLIDE_DOWN
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vol4:	cmp	al,0a0h        	;90-9f: Fine Volume slide up
		jae	short @@Vol5
		sub	al,90h
		shl	ax,8
		mov	al,OC_FINE_VOLUME_SLIDE_UP
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vol5:	cmp	al,0b0h        	;a0-af: Set vibrato speed
		jae	short @@Vol6
		sub	al,0a0h
		shl	ax,12		;4 more bits for vibrato speed
		mov	al,OC_VIBRATO
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vol6:	cmp	al,0c0h        	;b0-bf: vibrato
		jae	short @@Vol7
		sub	al,0b0h
		shl	ax,8
		mov	al,OC_VIBRATO
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vol7:	cmp	al,0d0h        	;c0-cf: panning
		jae	short @@Vol8
		sub	al,0c0h
		shl	ax,8
		mov	al,OC_SET_PANNING
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vol8:	cmp	al,0e0h        	;d0-df: panning slide left
		jae	short @@Vol9
		sub	al,0d0h
		shl	ax,8
		mov	al,OC_PANNING_SLIDE
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vol9:	cmp	al,0f0h        	;e0-ef: panning slide right
		jae	short @@Vola
		sub	al,0e0h
		shl	ax,8
		mov	al,OC_PANNING_SLIDE
		stosw                   ;Save opcode and operand
		jmp	short @@NoVolume
	@@Vola:	sub	al,0f0h		;f0-ff: tone portamento
		shl	ax,8
		mov	al,OC_TONE_PORTA
		stosw                   ;Save opcode and operand
		mov	eax,ds:[Last_Note]
		test	eax,eax
		jz	short @@NoVolume
		mov	b ds:[eax],OC_SET_NOTE
	;
@@NoVolume:
	test	dl,8			;Is there an effect ???
	jz	short @@NoEffect
		lods 	b ds:[esi]
		cmp	al,14
		je	short @@ExtendedEffect
		cmp	al,34
		je	short @@Extended2Effect
		test	al,al		;Is effect=0 => Arpeggio ???
		jz	short @@TestArp
		movzx 	eax,al
		mov	al,ds:[XM_Effect_LUT+eax]
		stosw			;Save opcode and zero-operand
		;
		;
		; Here are some special cases which need some postprocessing
		;
		cmp	al,OC_TONE_PORTA
		jne	short @@E1
		mov	eax,ds:[Last_Note]
		test	eax,eax
		jz	short @@NoEffect
		mov	b ds:[eax],OC_SET_NOTE
		jmp	short @@NoEffect
	@@E1:	cmp	al,OC_KEY_OFF
		jne	short @@E2
		dec	edi
		test	dl,16		;Parameter ???
		jz	@@NoParameter
		inc	esi		;Skip parameter
		and	dl,NOT 16
		jmp	@@NoParameter
	@@E2:	jmp	@@NoEffect
@@TestArp:
	test	dl,16			;Is there an arpeggio value ???
	jz	short @@NoParameter
		lods    b ds:[esi]		;Get arp-value
		jmp	short @@ParameterOnly
	;
@@ExtendedEffect:
	test	dl,16			;Exx without parametr makes no sense !
	jz	short @@NoParameter
		lods	b ds:[esi]	;Get parameter
		push	eax		;Save parameter
		movzx	eax,al
		shr	eax,4           ;Get effect-number
		mov	al,ds:[XM_Ext_Effect_LUT+eax]
		stosb			;Save opcode
		pop	eax
		and	al,0fh          ;Get parameter value
		stosb			;And save it !
		jmp 	short @@NoParameter
	;
@@Extended2Effect:
	test	dl,16			;Xxx without parametr makes no sense !
	jz	short @@NoParameter
		lods	b ds:[esi]	;Get parameter
		push	eax		;Save parameter
		movzx	eax,al
		shr	eax,4           ;Get effect-number
		mov	al,ds:[XM_Ext2_Effect_LUT+eax]
		stosb			;Save opcode
		pop	eax
		and	al,0fh          ;Get parameter value
		stosb			;And save it !
		jmp 	short @@NoParameter
	;
@@NoEffect:
	test	dl,16
	jz	short @@NoParameter
		lods	b ds:[esi]	;Get value
		test	dl,8		;Is there a command ???
		jz	short @@ParameterOnly
		mov	ds:[edi-1],al	;Save parameter
		jmp	short @@NoParameter

@@ParameterOnly:
		test	al,al		;Is there an arpeggio value ?
		jz	short @@NoParameter
		shl	ax,8		;Shift parameter value
		mov	al,OC_ARPEGGIO	;Set arpeggio
		stosw			;Save all
	;
@@NoParameter:
@@Next_Channel:
	inc	cl
	cmp	cl,b ds:[No_Channels]
	jb 	@@L2

	pop	eax		;Restore start address of this row
	mov	ecx,edi		;ECX=end address
	sub	ecx,eax		;ECX=Size of row
	mov 	ds:[eax],cl	;Save size of row !
	dec	ds:[No_Rows]
	jnz	@@L1        	;Go to next row !
	;
	xor	al,al
	stosb                   ;Save pattern-break
	;
	pop	ebx		;Restore start address of pattern
	sub	edi,ebx		;EDI=Size of this pattern in bytes
	mov	ds:[ebx],edi	;Save size here
	mov	ecx,edi		;ECX=Pattern size
	call	Realloc		;Do some reallocation

@@Err:	pop	edi
	retn
Convert_XM ENDP



;
;   GOMEZ MUSIC INTERFACE                                   MOD-LOADER
;
;
;
; Now comes the MOD-Loader of the GMI. The syntax is:
;
;     GMI_Load_MOD
;       In:
;           EBX     - DATA32 ptr to file-name
;           EDX     - Start position (Normally 0)
;       Out:
;           EAX     - Ptr to song header or zero on error
;
;
;Fintune		    0      1      2      3      4      5      6      7
MOD_Adjust_Frequencies dd 10000h,101d7h,103d7h,1059eh,10786h,1096ch,10b5ah,10d45h
		       dd 0f1a1h,0f361h,0f52bh,0f6eeh,0f8b7h,0fa87h,0fc56h,0fe2bh

PUBLIC C GMI_Load_MOD
GMI_Load_MOD PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]         ;DS=ES=Code-alias
	mov	ds:[FStart],edx			;First lets save the start pos.

	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[FHandle],eax

	mov 	ecx,66000
	call 	Malloc                      	;Lets allocate some buffers
	jc 	@@Err
	mov 	ds:[Temp_Ptr],eax

	mov 	ecx,SIZE GMI_SONG_HEADER
	call 	Malloc 				;Allocate song-header
	jc 	@@Err
	mov	ds:[Song_Header],eax

	mov 	ebp,eax				;DS:EBP points to Song_Header
	mov	edi,eax                   	;ES:EDI = ptr to song-header
	xor	eax,eax
	mov 	ecx,SIZE GMI_SONG_HEADER/4
	rep 	stosd				;Clear header


	;
	;
	; Here begins the module-reader. First we will read in the MOD-Header
	; and then check for some signature etc...
	;
	mov 	ds:[ebp+SNG_START_TEMPO],125
	mov 	ds:[ebp+SNG_START_SPEED],6
	mov	ds:[ebp+SNG_TICK_SPEED],50
	mov 	ds:[ebp+SNG_START_VOLUME],64
	mov	ds:[ebp+SNG_FLAGS],GMI_AMIGA_FREQUENCY
	;
	mov	ebx,ds:[FHandle]
	mov	ecx,1080
	add	ecx,ds:[FStart]
	mov	al,SEEK_SET
	call 	Seek                    	;Look for M.K. etc...
	jc	@@Err
	mov	ebx,ds:[FHandle]
	mov	edx,OFFSET IO_Buffer
	mov	ecx,4
	call 	Read				;Read it !
	mov 	eax,d ds:[IO_Buffer]	;EAX = file-magic
	;                                  
@@10: 	cmp 	eax,MOD8_MAGIC_1
	jne 	short @@6_T
@@8_1:	mov 	ds:[I_Count],31
	mov 	ds:[S_Count],31
	mov	ds:[ebp+SNG_CHANNEL_COUNT],8
	jmp 	@@Ready
	;                                  
@@6_T: 	cmp 	eax,'6TLF'
	jne 	short @@4_T
	mov 	ds:[I_Count],31
	mov 	ds:[S_Count],31
	mov	ds:[ebp+SNG_CHANNEL_COUNT],6
	jmp 	@@Ready
	;                                  
@@4_T:	cmp 	eax,'!K!M'
	je 	short @@4_1
	cmp 	eax,'4TLF'
	je 	short @@4_1
	cmp 	eax,'.K.M'
	je 	short @@4_1
	cmp 	eax,'!K&M'
	jne 	short @@CH_T
@@4_1:  mov 	ds:[I_Count],31
	mov 	ds:[S_Count],31
	mov	ds:[ebp+SNG_CHANNEL_COUNT],4
	jmp @@Ready
	;                                  
@@CH_T:	ror 	eax,16				;Get high-bytes
	cmp 	ax,MOD_MAGIC_CH
	jne 	short @@HN_T
	rol 	eax,16
	movzx 	ebx,al
	sub 	bl,'0'
	fastimul edx,ebx,10
	add 	dl,ah
	sub 	dl,'0'
	mov	ds:[I_Count],31
	mov 	ds:[S_Count],31
	mov 	ds:[ebp+SNG_CHANNEL_COUNT],edx	;Channels
	shl	edx,4
	mov 	ds:[ebp+SNG_START_VOLUME],edx
	jmp 	short @@Ready
	;                                  
@@HN_T:	cmp 	ax,MOD_MAGIC_HN
	jne 	short @@15
	rol 	eax,16
	movzx 	edx,al
	sub 	dl,'0'
	mov 	ds:[I_Count],31
	mov 	ds:[S_Count],31
	mov 	ds:[ebp+SNG_CHANNEL_COUNT],edx	;Channels
	shl	edx,4
	mov 	ds:[ebp+SNG_START_VOLUME],edx
	jmp 	short @@Ready
	;                                  
@@15: 	mov	ds:[I_Count],15
	mov 	ds:[S_Count],15
	mov 	ds:[ebp+SNG_CHANNEL_COUNT],4
	mov 	ds:[ebp+SNG_START_VOLUME],64

@@Ready:;
	;
	; Now we read in the name and instrument headers !
	;
	mov	ebx,ds:[FHandle]
	mov	ecx,ds:[FSTart]
	mov	al,SEEK_SET
	call 	Seek                    	;Get song name...
	jc	@@Err
	lea 	edx,[ebp+SNG_NAME]
	mov	ebx,ds:[FHandle]
	mov	ecx,20
	call 	Read				;Read song name
	jc	@@Err
	;
@@L1:	mov	ecx,SIZE GMI_INSTRUMENT
	call	Malloc
	jc	@@Err
	mov	ecx,ds:[I_Count]		;ECX = inst-number
	sub	ecx,ds:[S_Count]
	mov	ds:[ebp+4*ecx+SNG_INSTRUMENT_PTR],eax
	mov	edi,eax				;EDI = ptr to inst.-header
	push	edi
	mov	ecx,(SIZE GMI_INSTRUMENT)/4
	xor	eax,eax
	rep	stosd				;Clear header !
	;                                  
	mov 	ecx,30
	mov	edx,OFFSET IO_Buffer
	mov	ebx,ds:[FHandle]
	call 	Read				;Read in inst-header
	;                                  
	mov	edi,ss:[esp]			;EDI = ptr to instrument
	mov	ds:[edi+INS_FLAGS],FL_PLAY_CHANNEL or FL_FULL_INSTRUMENT
	add	edi,INS_NAME
	mov	esi,OFFSET IO_Buffer
	mov	ecx,22/2
	rep	movsw				;Copy instrument name
	pop	edi
	;                                  
	movzx 	eax,ds:[IO_Buffer.MOD_INST_SIZE]
	rol 	ax,8
	shl 	eax,1
	mov 	ds:[edi+INS_SAMPLES+SMP_SIZE],eax

	movzx 	eax,ds:[IO_Buffer.MOD_INST_LOOP_SIZE]
	mov	ebx,0ffffffffh			;EBX = loop-start
	mov	edx,FL_PLAY_CHANNEL
	rol 	ax,8
	shl 	eax,1
	cmp 	eax,4
	jb 	short @@NoLp
	cmp 	eax,01fffdh
	jae 	short @@NoLp
		movzx 	ebx,ds:[IO_Buffer.MOD_INST_LOOP_START]
		rol 	bx,8
		shl 	ebx,1			;EBX = Loop start
		add	eax,ebx			;EAX = loop end
		or	edx,FL_LOOP
@@NoLp:	mov	ds:[edi+INS_SAMPLES+SMP_LOOP_END],eax
	mov	ds:[edi+INS_SAMPLES+SMP_LOOP_START],ebx
	mov	ds:[edi+INS_SAMPLES+SMP_FLAGS],edx
	mov	ds:[edi+INS_SAMPLES+SMP_PANNING],80h
	lea	eax,[edi+INS_SAMPLES]
	mov	ds:[edi+INS_SAMPLES+SMP_HANDLE],eax
	;                                  
	mov 	bl,ds:[IO_Buffer.MOD_INST_FINETUNE]
	and 	ebx,0fh
	mov 	eax,ds:[MOD_Adjust_Frequencies+4*ebx]
	mov	edx,10000h	;1025bh			;11000h
	imul	edx
	shrd	eax,edx,16
	mov 	ds:[edi+INS_SAMPLES+SMP_RESAMPLE],eax
	mov 	al,ds:[IO_Buffer.MOD_INST_VOLUME]
	mov 	ds:[edi+INS_SAMPLES+SMP_VOLUME],al
	;                                  
	dec	ds:[S_Count]
	jnz  	@@L1

	;
	;
	; Now we check the order list etc...
	;
	lea	edx,[ebp+SNG_ORDER_COUNT]
	mov	ecx,2
	mov	ebx,ds:[FHandle]
	call 	Read
	and 	ds:[ebp+SNG_ORDER_COUNT],0ffh
	;                                  
	lea 	edx,[ebp+SNG_ORDER_LIST]
	mov 	ecx,128
	mov	ebx,ds:[FHandle]
	call 	Read
	;                                  
	cmp 	ds:[I_Count],31				;Do we need to skip
	jb 	short @@4				;JB => No
	mov	ebx,ds:[FHandle]
	mov 	ecx,4
	mov	al,SEEK_CUR
	call 	Seek 					;Skip signature
	;
@@4: 	xor 	eax,eax
	mov 	ebx,127					;Here we examine the
@@L2: 	mov 	dl,ds:[ebp+ebx+SNG_ORDER_LIST-1]	;sequence in order to find
	cmp 	dl,127					;out how many patterns
	jae 	short @@6				;there are to load
	cmp 	dl,al
	jb 	short @@6
	mov 	al,dl
@@6: 	dec 	ebx
	jnz 	short @@L2
	inc 	eax					;Add one pattern
	mov 	ds:[P_Count],eax			;Save them here

	;
	;
	; Now we read in all patterns...
	;
	mov	ecx,32000			;Size of temp-buffer
	call 	Malloc 				;Allocate memory for patterns
	jc 	@@Err
	mov 	ds:[Temp_Ptr],eax		;Save ptr there
	;
	xor	edi,edi
@@L3:	mov	edx,ds:[Temp_Ptr]
	mov	eax,ds:[ebp+SNG_CHANNEL_COUNT]
	fastimul ecx,eax,64*4			;ECX = raw pattern-size
	mov	ebx,ds:[FHandle]
	call 	Read 				;Read patterns

	mov	esi,ds:[Temp_Ptr]		;ESI = ptr to source
	mov	ecx,64				;ECX = Number of rows to process
	mov	eax,ds:[ebp+SNG_CHANNEL_COUNT]	;EAX = Number of channels
	call 	Convert_MOD			;Convert it !
	mov	ds:[ebp+4*edi+SNG_PATTERN_PTR],eax		;Save new pattern ptr
	jc	@@Err				;Carry ==> Error !

	inc 	edi				;Next pattern...
	dec 	ds:[P_Count]
	jnz 	short @@L3
	;
	mov	ecx,ds:[Temp_Ptr]
	call 	Free


	;
	;
	; Finally read in all samples
	;
@@L4:	mov	edi,ds:[ebp+SNG_INSTRUMENT_PTR]
	test 	edi,edi
	je 	short @@9
	add	edi,INS_SAMPLES
	;
	mov	ecx,ds:[edi+SMP_SIZE]		;ECX = Sample-size (in samples)
	test	ecx,ecx				;
	jz	@@9
	push	ecx				;Save size in bytes
	call	Malloc
	pop	ecx				;ECX = Size of sample
	jc	@@Err
	mov	ds:[edi+SMP_ADDRESS],eax	;EAX = Sample-address
	mov	ds:[edi+SMP_HANDLE],edi
	mov	edx,eax
	mov	ebx,ds:[FHandle]
	call	Read				;Read in sample
	jc	@@Err
	mov	eax,edi
	call	Load_Sample
	jc	@@Err
	;
@@9:	add	ebp,4				;Next instrument
	dec	ds:[I_Count]
	jnz	@@L4

	;
	mov	ebx,ds:[FHandle]
	call	Close				;Close File !
	mov	eax,ds:[Song_Header]
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@Err:	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GMI_Load_MOD ENDP

;
;
; Now follows the MOD decoder.
; A MOD-note is build up like that:
;
; Contents for each note:
;
;  _____byte 1_____   byte2_    _____byte 3_____       byte4_
; /                \ /      \  /                \     /      \
; 0000          0000-00000000  0000          0000  -  00000000
;
; Upper four    12 bits for    Lower four    Effect   Effect
; bits of sam-  note pitch.    bits of sam-  code.    parameter.
; ple number.                  ple number.
;
; The pitch for the note actually determines the time between outputting samples.
; For the Amiga, the value of the pitch is the number of clock ticks that a 3.5
; MHz timer must count down between outputting two samples.
; The exact formulas are:
;
; 	         3546894.6
; SampleRate = -----------        (For a PAL machine)
; 		  Pitch
;
; 	         3579545.3
; SampleRate = -----------        (For a NTSC machine)
; 	          Pitch
;
; Thus, the pitch 214 (for note C-3) corresponds to 16,574 Hz, using the PAL
; formula. Each second 16,574 sampled data bytes for the instrument are pushed
; through the D/A convertor. (Actually, with most samplers the D/A conversion
; frequency is fixed and real-time resampling takes place.)
;
; If finetuning is supported, the pitch stored in the note is always one of the
; values in the "pitch table for tuning 0" above. The correct pitch for the note
; comes from one of 15 other tables, according to the finetune value of the
; instrument.
;
; This is an extract of a MOD-description written by:
;	Thiadmer Riemersma
; 	ITB CompuPhase, The Netherlands
;	CIS: 100115,2074
;
;
;
; Now follows the MOD commands. The offsets are stored in a table for fast
; indexing.
;
; Protracker V2.3A/3.01 Effect Commands
; 
; 0 + Normal play or arpeggio             0xy : x-first halfnote add, y-second
; 1 - Slide up                            1xx : up speed
; 2 - Slide down                          2xx : down speed
; 3 + Tone portamento (slide to note)     3xx : up/down speed
; 4 - Vibrato (frequency trembles)        4xy : x-speed,   y-depth
; 5 - Continue effect 3 + volume slide    5xy : x-upspeed, y-downspeed
; 6 - Continue effect 4 + volume slide    6xy : x-upspeed, y-downspeed
; 7 - Tremolo (volume trembles)           7xy : x-speed,   y-depth
; 8 - not used
; 9 - Set sample offset                   9xx : offset (23 -> 2300)
; A - Volume slide                        Axy : x-upspeed, y-downspeed
; B - Position jump                       Bxx : song position
; C - Set volume                          Cxx : volume, 00-40
; D - Pattern break                       Dxx : break position in next pattern
; E - Extended commands
;   E0- Set filter                        E0x : 0=filter on, 1=filter off
;   E1- Fine slide up                     E1x : value
;   E2- Fine slide down                   E2x : value
;   E3+ Glissando control                 E3x : 0=off, 1=on (use with effect 3)
;   E4- Set vibrato waveform              E4x : 0=sine, 1=ramp down, 2=square
;   E5- Set finetune value                E5x : value (0..15)
;   E6- Jump to loop                      E6x : 0=set loop start, >0 play x times
;   E7- Set Tremolo Waveform              E7x : 0=sine, 1=ramp down. 2=square
;   E8- not used
;   E9- Retrig note                       E9x : retrig from note + x vblanks
;   EA- Fine volume slide up              EAx : add x to volume
;   EB- Fine volume slide down            EBx : subtract x from volume
;   EC- Note cut                          ECx : cut from note + x vblanks
;   ED- Note delay                        EDx : delay note x vblanks
;   EE- Pattern delay                     EEx : delay pattern x notes
;   EF- Invert loop                       EFx : speed
; F - Set speed or tempo                  Fxx : speed (00-1F) / tempo (20-FF)
;
;
; This is an extract of a MOD-description written by:
;	Thiadmer Riemersma
; 	ITB CompuPhase, The Netherlands
;	CIS: 100115,2074
;
MOD_Effect_LUT LABEL BYTE
	db	OC_ARPEGGIO                   	;0
	db	OC_PORTA_UP			;1
	db	OC_PORTA_DOWN			;2
	db	OC_TONE_PORTA			;3
	db	OC_VIBRATO			;4
	db	OC_PORTA_AND_VOLUME_SLIDE	;5
	db	OC_VIBRATO_AND_VOLUME_SLIDE     ;6
	db	OC_TREMOLO                      ;7
	db	OC_SET_PANNING                  ;8
	db	OC_SET_SAMPLE_OFFSET            ;9
	db	OC_VOLUME_SLIDE                 ;a
	db	OC_POSITION_JUMP                ;b
	db	OC_SET_VOLUME                   ;c
	db	OC_PATTERN_BREAK                ;d
	db	OC_PARAMETER                    ;e
	db	OC_SET_SPEED                    ;f

MOD_Ext_Effect_LUT LABEL BYTE
	db	OC_SET_FILTER
	db	OC_FINE_SLIDE_UP
	db	OC_FINE_SLIDE_DOWN
	db	OC_SET_GLISSANDO
	db	OC_SET_VIBRATO
	db	OC_SET_FINETUNE
	db	OC_PATTERN_LOOP
	db	OC_SET_TREMOLO
	db	OC_PARAMETER
	db	OC_RETRIGGER
	db	OC_FINE_VOLUME_SLIDE_UP
	db	OC_FINE_VOLUME_SLIDE_DOWN
	db	OC_NOTE_CUT
	db	OC_NOTE_DELAY
	db	OC_PATTERN_DELAY
	db	OC_INVERT_LOOP



Convert_MOD PROC NEAR
	push	edi
	mov	ds:[No_Rows],ecx
	mov	ds:[No_Channels],eax

	imul	ecx
	shl	eax,4			;16 bytes /channel and row should be enough !
	mov	ecx,eax
	call	Malloc			;Get some memory
	jc	@@Err
	mov	edi,eax			;DS:EDI points to pattern
	push	edi			;Save start address of pattern
	mov	eax,ds:[No_Rows]
	mov	ds:[edi+4],eax		;Save row-count
	add	edi,8			;Skip pattern-size dword
	;
@@L1:   xor	cl,cl			;CL = Channel number
	push	edi			;Save start address of ths row
	inc	edi			;Skip size of this row

	;
	;
	; This is the inner loop for the channels
	;
@@L2:   mov	ds:[Last_Note],0
	mov	ebx,ds:[esi]		;EBX = period etc...
	test	ebx,ebx
	jz	@@Next_CHannel
	;
	test	cl,cl
	jz	short @@NoChn
		mov	al,OC_SET_CHANNEL
		add	al,cl           ;AL = Set this channel opcode
		stosb			;Set_Channel opcode
	;
@@NoChn:mov 	al,ds:[esi]		;Get upper 4 bits
	and 	al,0f0h			;Mask out lower 4 period-bits
	mov 	ah,ds:[esi+2]		;Get lower four bits of instrument
	shr 	ah,4			;Shift away effect bits
	add 	ah,al			;AL finally has instrument
	jz	short @@NoI
		mov	bl,ds:[esi+2]
		and	bl,0fh
		cmp	bl,3
		je	short @@ReI
		test	d ds:[esi],0ff0fh
		jz	short @@ReI
		mov	al,OC_NEW_INSTRUMENT
		stosw
		jmp	short @@NoI
	@@ReI:	mov	al,OC_RESET_INSTRUMENT
		stosb
		jmp	short @@NoP
	;
@@NoI:	mov	ebx,ds:[esi]			;EBX = period etc...
	and	ebx,0ff0fh
	rol	bx,8				;EBX = pitch
	jz	short @@NoP
		mov	ds:[Last_Note],edi
		mov	al,OC_PLAY_PERIOD
		stosb
		mov	ax,bx
		shl	ax,2
		stosw
	;
@@NoP:	mov	al,ds:[esi+2]
	and	eax,0fh				;AL = FX-numba
	jz	short @@Arp
		cmp	al,0eh
		je	short @@ExtFX
		cmp	al,0ch
		je	short @@Vol
		mov	al,ds:[MOD_Effect_LUT+eax]
		mov	ah,ds:[esi+3]
		stosw				;Save opcode and zero-operand
		;
		;
		; Here are some special cases which need some postprocessing
		;
		cmp	al,OC_TONE_PORTA
		jne	short @@NoFX
		mov	eax,ds:[Last_Note]
		test	eax,eax
		jz	short @@NoFX
		mov	b ds:[eax],OC_SET_PERIOD
		jmp	short @@NoFX

	@@Vol:	mov	al,ds:[esi+3]
		add	al,OC_SET_DIRECT_VOLUME
		stosb
		jmp	short @@NoFX

	@@Arp:	mov     ah,ds:[esi+3]		;Get arp-value
		test	ah,ah
		jz	short @@NoFX
		mov	al,OC_ARPEGGIO
		stosw
		jmp	short @@NoFX
	;
@@ExtFX:	movzx 	eax,b ds:[esi+3]	;Get parameter
		shr	eax,4           	;Get effect-number
		mov	al,ds:[MOD_Ext_Effect_LUT+eax]
		stosb				;Save opcode
		mov 	al,b ds:[esi+3]	;Get parameter
		and	al,0fh          	;Get parameter value
		stosb				;And save it !
		jmp 	short @@NoFX
	;
@@NoFX:
@@Next_Channel:
	inc	cl
	add	esi,4
	cmp	cl,b ds:[No_Channels]
	jb 	@@L2

	pop	eax		;Restore start address of this row
	mov	ecx,edi		;ECX=end address
	sub	ecx,eax		;ECX=Size of row
	mov 	ds:[eax],cl	;Save size of row !
	dec	ds:[No_Rows]
	jnz	@@L1        	;Go to next row !
	;
	xor	al,al
	stosb                   ;Save pattern-break
	;
	pop	ebx		;Restore start address of pattern
	sub	edi,ebx		;EDI=Size of this pattern in bytes
	mov	ds:[ebx],edi	;Save size here
	mov	ecx,edi		;ECX=Pattern size
	call	Realloc		;Do some reallocation

@@Err:	pop	edi
	retn
Convert_MOD ENDP

;
;   GOMEZ MUSIC INTERFACE                                   S3M-LOADER
;
;
;
; Now comes the S3M-Loader of the GMI. The syntax is:
;
;     GMI_Load_S3M
;       In:
;           EBX     - DATA32 ptr to file-name
;           EDX     - Start position (Normally 0)
;       Out:
;           EAX     - Ptr to song header or zero on error
;
;
PUBLIC C GMI_Load_S3M
GMI_Load_S3M PROC NEAR
	push	ds
	push	es
	push	esi
	push	edi
	push	ebp

	cld
	mov	ds,cs:[DATA32_Selector]
	mov	es,cs:[DATA32_Selector]         ;DS=ES=Code-alias
	mov	ds:[FStart],edx			;First lets save the start pos.

	mov	ecx,O_RDONLY
	call	Open
	jc	@@Err
	mov	ds:[FHandle],eax

	mov 	ecx,66000
	call 	Malloc                      	;Lets allocate some buffers
	jc 	@@Err
	mov 	ds:[Temp_Ptr],eax

	mov 	ecx,SIZE GMI_SONG_HEADER
	call 	Malloc 				;Allocate song-header
	jc 	@@Err
	mov	ds:[Song_Header],eax

	mov 	ebp,eax				;DS:EBP points to Song_Header
	mov	edi,eax                   	;ES:EDI = ptr to song-header
	xor	eax,eax
	mov 	ecx,SIZE GMI_SONG_HEADER/4
	rep 	stosd				;Clear header


	;
	;
	; Here begins the module-reader. First we will read in the MOD-Header
	; and then check for some signature etc...
	;
	mov 	ds:[ebp+SNG_START_TEMPO],125
	mov 	ds:[ebp+SNG_START_SPEED],6
	mov	ds:[ebp+SNG_TICK_SPEED],50
	mov 	ds:[ebp+SNG_START_VOLUME],64
	mov	ds:[ebp+SNG_FLAGS],GMI_AMIGA_FREQUENCY
	;
	mov	ebx,ds:[FHandle]
	mov 	ecx,60h
	mov	edx,OFFSET IO_Buffer
	call 	Read				;Read in header
	;                                  
	mov	esi,OFFSET IO_Buffer
	lea	edi,[ebp+SNG_NAME]
	mov	ecx,28/4
	rep	movsd				;Copy the song name...
	;                                  
	movzx 	eax,ds:[IO_Buffer.S3M_ORDER_COUNT]
	mov	ds:[ebp+SNG_ORDER_COUNT],eax
	movzx 	eax,ds:[IO_Buffer.S3M_PATTERN_COUNT]
	mov 	ds:[P_Count],eax
	mov 	al,ds:[IO_Buffer.S3M_MASTER_VOLUME]
	mov 	al,ds:[IO_Buffer.S3M_GLOBAL_VOLUME]
	movzx 	eax,ds:[IO_Buffer.S3M_START_TEMPO]
	mov 	ds:[ebp+SNG_START_TEMPO],eax
	movzx 	eax,ds:[IO_Buffer.S3M_START_SPEED]
	mov 	ds:[ebp+SNG_START_SPEED],eax
	movzx 	eax,ds:[IO_Buffer.S3M_SAMPLE_FORMAT]
	mov 	ds:[I_Flags],eax
	movzx	eax,ds:[IO_Buffer.S3M_INSTRUMENT_COUNT]
	mov 	ds:[I_Count],eax
	mov	ds:[S_Count],eax
	cmp 	d ds:[IO_Buffer.S3M_MAGIC],'MRCS'
	jne 	@@Err
	;
	mov 	ebx,31
	xor 	edx,edx
 @@L1:	mov 	al,ds:[IO_Buffer.S3M_CHANNEL_MAP+ebx]
	cmp 	al,15
	ja 	short @@2
	inc 	edx
 @@2:   dec 	ebx
	jns 	short @@L1
	mov 	ds:[ebp+SNG_CHANNEL_COUNT],edx
	;
	mov 	ecx,ds:[ebp+SNG_ORDER_COUNT]	;ECX = Number of entries
	lea	edx,[ebp+SNG_ORDER_LIST]	;EDX = Order-list adr
	mov	ebx,ds:[FHandle]		;EBX = File-handle
	call 	Read 				;Get orders

	;
	;
	; Now we read in all instrument para pointers and store them in the
	; instrument-ptrs.
	;
	mov 	ecx,ds:[I_Count]
	mov 	esi,ebp
@@L2:	push 	ecx
	mov	ebx,ds:[FHandle]
	mov 	ecx,2
	mov	edx,OFFSET IO_Buffer
	call 	Read
	movzx 	eax,w ds:[IO_Buffer]
	shl 	eax,4
	mov 	ds:[esi+SNG_INSTRUMENT_PTR],eax
	add 	esi,4
	pop 	ecx
	dec 	ecx
	jnz 	short @@L2
	;
	mov 	ecx,ds:[P_Count]
	mov 	esi,ebp
@@L4:	push 	ecx
	mov	ebx,ds:[FHandle]
	mov 	ecx,2
	mov	edx,OFFSET IO_Buffer
	call 	Read
	movzx 	eax,w ds:[IO_Buffer]
	shl 	eax,4
	mov 	ds:[esi+SNG_PATTERN_PTR],eax
	add 	esi,4
	pop 	ecx
	dec 	ecx
	jnz 	short @@L4
	;
	mov 	ecx,ds:[I_Count]
	mov	esi,ebp				;ESI = ptr to instrument-ptr
@@L3:	push 	ecx
	mov	ebx,ds:[FHandle]
	mov	ecx,ds:[esi+SNG_INSTRUMENT_PTR]
	add	ecx,ds:[FSTart]
	mov	al,SEEK_SET
	call 	Seek

	mov	ebx,ds:[FHandle]
	mov 	ecx,50h
	mov	edx,OFFSET IO_Buffer
	call 	Read

	mov	ecx,SIZE GMI_INSTRUMENT
	call	Malloc
	mov	ds:[esi+SNG_INSTRUMENT_PTR],eax
	mov	edi,eax				;EDI = ptr to instrument header
	push	edi
	mov	ecx,SIZE GMI_INSTRUMENT/4
	xor	eax,eax
	rep	stosd				;Clear instrument
	pop	edi
	mov	ds:[edi+INS_FLAGS],FL_PLAY_CHANNEL or FL_FULL_INSTRUMENT
	;
	push	esi
	push	edi
	mov	esi,OFFSET IO_Buffer+S3M_INST_NAME
	lea	edi,[edi+INS_NAME]
	mov	ecx,28/4
	rep	movsd
	pop	edi
	pop	esi
	;                                  
	add	edi,INS_SAMPLES
	cmp 	ds:[IO_Buffer.S3M_INST_TYPE],1
	ja 	@@NxtI
	cmp 	ds:[IO_Buffer.S3M_INST_MAGIC],'SRCS'
	jne 	@@NxtI
	movzx 	eax,b ds:[IO_Buffer.S3M_INST_ADDRESS]
	shl 	eax,16
	mov 	ax,w ds:[IO_Buffer.S3M_INST_ADDRESS+1]
	shl 	eax,4
	mov 	ds:[edi+SMP_ADDRESS],eax
	mov 	ds:[edi+SMP_HANDLE],edi
	;                                  
	mov 	eax,ds:[IO_Buffer.S3M_INST_SIZE]
	mov 	ds:[edi+SMP_SIZE],eax
	mov 	eax,ds:[IO_Buffer.S3M_INST_RESAMPLE]
	mov	edx,10000h
	imul	edx
	mov	ebx,8363
	idiv	ebx
	mov 	ds:[edi+SMP_RESAMPLE],eax
	mov 	al,ds:[IO_Buffer.S3M_INST_VOLUME]
	cmp 	al,64
	jb 	short @@7
	mov 	al,64
@@7:	mov 	ds:[edi+SMP_VOLUME],al
	mov	ds:[edi+SMP_PANNING],80h
	test 	ds:[IO_Buffer.S3M_INST_FLAGS],1
	jnz 	short @@Lp
		mov 	ds:[edi+SMP_LOOP_START],0ffffffffh
		mov 	ds:[edi+SMP_LOOP_END],0h
		mov	ds:[edi+SMP_FLAGS],FL_PLAY_CHANNEL
		jmp 	short @@NxtI
	@@Lp:  	mov 	eax,ds:[IO_Buffer.S3M_INST_LOOP_START]
		mov 	ds:[edi+SMP_LOOP_START],eax
		mov 	eax,ds:[IO_Buffer.S3M_INST_LOOP_END]
		mov 	ds:[edi+SMP_LOOP_END],eax
		mov	ds:[edi+SMP_FLAGS],FL_PLAY_CHANNEL or FL_LOOP
@@NxtI:	;
	add 	esi,4
	pop 	ecx
	dec 	ecx
	jnz 	@@L3

	;
	;
	; Now all pattern will be read in and converted into the GMI
	; pattern format
	;
	mov	esi,ebp				;ESI = ptr to pattern-ptr
@@L5:  	mov	al,SEEK_SET
	mov	ebx,ds:[FHandle]
	mov	ecx,ds:[esi+SNG_PATTERN_PTR]
	add	ecx,ds:[FStart]
	call 	Seek				;Seek to pattern
	;                                  
	mov	ebx,ds:[Fhandle]
	mov 	ecx,2				;Read word
	mov	edx,OFFSET IO_Buffer
	call 	Read
	jc	@@Err	 			;Get size of packed data
	mov	ebx,ds:[FHandle]
	movzx	ecx,w ds:[IO_Buffer]
	mov	edx,ds:[Temp_Ptr]
	call 	Read				;Read in compessed pattern
	jc	@@Err
	push	esi
	mov	esi,ds:[Temp_Ptr]
	mov	eax,ds:[ebp+SNG_CHANNEL_COUNT]
	mov	ecx,64
	call 	Convert_S3M
	pop	esi
	jc	@@Err
	mov	ds:[esi+SNG_PATTERN_PTR],eax	;Save new pattern
	;                                  
	add	esi,4
	dec 	ds:[P_Count]
	jnz 	@@L5
	;
	mov	ecx,ds:[Temp_Ptr]
	call 	Free

	;
	;
	; Finally the instrument data will be read in
	;
@@L6:  	mov	edi,ds:[ebp+SNG_INSTRUMENT_PTR]
	add	edi,INS_SAMPLES
	cmp 	ds:[edi+SMP_SIZE],0
	je 	@@NxI
	;
	mov	al,SEEK_SET
	mov	ebx,ds:[FHandle]
	mov	ecx,ds:[edi+SMP_ADDRESS]
	add	ecx,ds:[FStart]
	call 	Seek
	;                                  
	mov	ecx,ds:[edi+SMP_SIZE]
	call 	Malloc
	jc	@@Err
	mov 	ds:[edi+SMP_ADDRESS],eax
	;                                  
	mov	ebx,ds:[FHandle]
	mov	ecx,ds:[edi+SMP_SIZE]
	mov	edx,eax
	call 	Read
	jc	@@Err
	cmp 	ds:[I_Flags],2
	jne 	short @@LdI
	mov 	ecx,ds:[edi+SMP_SIZE]
	mov 	ebx,ds:[edi+SMP_ADDRESS]
	dec 	ebx
@@Conv:	add 	b ds:[ebx+ecx],80h
	dec 	ecx
	jnz 	short @@Conv
@@LdI:  ;
	mov	eax,edi
	call	Load_Sample
	jc	@@Err
	;
@@NxI:	add 	ebp,4
	dec	ds:[I_Count]
	jnz 	@@L6

	;
	;
	; This routine will throw out strange sequence-entries, which can
	; occur in S3M-files
	;
	mov	ebp,ds:[Song_Header]
	xor 	ebx,ebx
	mov 	esi,ebp
	mov 	ecx,ds:[ebp+SNG_ORDER_COUNT]
@@L7:  	mov 	al,ds:[esi+SNG_ORDER_LIST+ebx]
	cmp 	al,128
	jb 	short @@Ok5
	inc 	ebx
	dec 	ds:[ebp+SNG_ORDER_COUNT]
	dec 	ecx
	jz 	short @@End
	jmp 	short @@L7
@@Ok5: 	mov 	ds:[esi+SNG_ORDER_LIST],al
	inc 	esi
	dec 	ecx
	jnz 	short @@L7

@@End:	;
	mov	ebx,ds:[FHandle]
	call	Close				;Close File !
	mov	eax,ds:[Song_Header]
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn

@@Err:	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
GMI_Load_S3M ENDP

;
;
; Now follows the S3M loader for Scream-tracker 3.0 modules. Note that S3m
; theoretically also supports FM-Voices. But these modules will not be
; loaded correct !!! (See S3M.DOC for format description)
;
; Unpacked pattern is always 32 channels by 64 rows. Below
; is the unpacked format st uses for reference:
;     byte 0 - Note; hi=oct, lo=note, 255=empty note,
;		  254=key off (used with adlib, with samples stops smp)
;     byte 1 - Instrument      ;0=..
;     byte 2 - Volume          ;255=..
;     byte 3 - Special command ;255=..
;     byte 4 - Command info    ;
;
; Packed data consits of following entries:
;   BYTE:what  0=end of row
;	      &31=channel
;	      &32=follows;  BYTE:note, BYTE:instrument
;	      &64=follows;  BYTE:volume
;	     &128=follows;  BYTE:command, BYTE:info
;
S3M_Last_VSlides	db	32 dup (?)
S3M_Last_PSlides	db	32 dup (?)
S3M_This_Channel	dd	?


S3M_Effect_LUT LABEL BYTE
	db	OC_PARAMETER
	db	OC_SET_SPEED
	db	OC_POSITION_JUMP
	db	OC_PATTERN_BREAK
	db	OC_VOLUME_SLIDE
	db	OC_PORTA_DOWN
	db	OC_PORTA_UP
	db	OC_TONE_PORTA
	db	OC_VIBRATO
	db	OC_TREMOR
	db	OC_ARPEGGIO
	db	OC_VIBRATO_AND_VOLUME_SLIDE
	db	OC_PORTA_AND_VOLUME_SLIDE
	db	OC_PARAMETER
	db	OC_PARAMETER
	db	OC_SET_SAMPLE_OFFSET
	db	OC_PARAMETER
	db	OC_MULTI_RETRIGGER
	db	OC_TREMOLO
	db	OC_PARAMETER
	db	OC_SET_SPEED
	db	OC_FINE_VIBRATO
	db	OC_SET_GLOBAL_VOLUME
	db	OC_PARAMETER
	db	OC_SET_PANNING
	db	OC_TRAELLER
	db	OC_REVERSE_SAMPLE

S3M_Ext_Effect_LUT LABEL BYTE
	db	OC_SET_FILTER
	db	OC_FINE_SLIDE_UP
	db	OC_FINE_SLIDE_DOWN
	db	OC_SET_GLISSANDO
	db	OC_SET_VIBRATO
	db	OC_SET_FINETUNE
	db	OC_PATTERN_LOOP
	db	OC_SET_TREMOLO
	db	OC_PARAMETER
	db	OC_RETRIGGER
	db	OC_FINE_VOLUME_SLIDE_UP
	db	OC_FINE_VOLUME_SLIDE_DOWN
	db	OC_NOTE_CUT
	db	OC_NOTE_DELAY
	db	OC_PATTERN_DELAY
	db	OC_INVERT_LOOP


Convert_S3M PROC NEAR
	push 	esi
	push 	edi
	push 	ebp
	mov	ds:[No_Rows],ecx
	mov	ds:[No_Channels],eax

	imul	ecx
	shl	eax,4		;16 bytes /channel and row should be enough !
	mov	ecx,eax
	call	Malloc		;Get some memory
	jc	@@Err
	mov	edi,eax		;ES:EDI points to pattern
	push	edi		;Save start address of pattern
	mov	eax,ds:[No_Rows]
	mov	ds:[edi+4],eax	;Save row-count
	add	edi,8		;Skip pattern-size dword
	;
@@L1:   xor	cl,cl		;CL = Channel number
	push	edi		;Save start address of ths row
	inc	edi		;Skip size of this row

	;
	;
	; This is the inner loop for the channels
	;
@@L2:   mov	ds:[Last_Note],0
	mov	dl,ds:[esi]		;DL = Get first byte
	inc	esi			;Next byte
	test	dl,dl
	jz	@@Next_Row
	;
	mov 	cl,dl
	and 	ecx,31			;ECX = Channel-no
	mov	ds:[S3M_This_Channel],ecx
	cmp 	ecx,ds:[No_Channels]
	jb 	short @@DC		;Goto decompression
	;                                  
	test 	dl,32			;Skip this track....
	jz 	short @@G1
	add 	esi,2
  @@G1: test 	dl,64
	jz 	short @@G2
	inc 	esi
  @@G2: test 	dl,128
	jz 	short @@L2
	add 	esi,2
  @@G3: jmp 	short @@L2
	;
@@DC:	mov	al,cl			;AL = channel
	test	al,al
	jz	short @@NoC
		add	al,OC_SET_CHANNEL
		stosb			;Set this channel
@@NoC:	;
	test 	dl,32			;32 : Note and instrument
	jz 	@@NoN
	mov 	ax,ds:[esi]		;Get note/instrument
	cmp	ah,0ffh
	je 	short @@NoI
	test	ah,ah
	jz	short @@NoI
	cmp	al,0ffh
	je	short @@ReI
		mov	al,OC_NEW_INSTRUMENT
		stosw
		jmp	@@NoI
	@@ReI:	mov	al,OC_RESET_INSTRUMENT
		stosb
	;                                  
@@NoI:	mov 	al,ds:[esi]		;AL = note
	add	esi,2			;Skip this word in source
	cmp 	al,0feh			;FE = Key-off , FF = No Note
	ja 	short @@NoN
	je 	short @@KeyOff
		mov	ds:[Last_Note],edi
		mov	ebx,eax
		and	eax,0fh
		shr	ebx,4
		and	ebx,0fh
		lea	ebx,[ebx+2*ebx]	;*3
		shl	ebx,2		;*4=*12
		add	eax,ebx
		shl	eax,8
		mov	al,OC_PLAY_NOTE
		stosw
		jmp	short @@NoN
	;                                  
@@KeyOff:	mov	al,OC_KEY_OFF
		stosb
	;
@@NoN:	test 	dl,64			;Test for volume coloumn
	jz 	short @@NoV
	mov 	al,ds:[esi]		;AL = volume coloumn byte
	inc 	esi
	cmp 	al,0ffh
	je 	short @@NoV		;ff =...
	cmp 	al,64
	jb 	short @@Ok1
	mov 	al,64
@@Ok1:	add 	al,OC_SET_DIRECT_VOLUME
	stosb
	;
@@NoV:	test 	dl,128			;Is there an FX ???
	jz 	@@NoFX
	mov 	ax,ds:[esi]		;AL = FX   AH = pararm
	add 	esi,2
	cmp 	al,0ffh
	je 	@@NoFX
@@Ok3:	mov 	bl,ah			;BL = Parameter
	;                                  
	cmp 	al,4 			;Volume slide
	jne 	short @@F
		mov 	ebx,ds:[S3M_This_Channel]
		test 	ah,ah
		jnz 	short @@V1
		mov 	ah,ds:[OFFSET S3M_Last_Vslides+ebx]
	@@V1:	mov 	ds:[OFFSET S3M_Last_Vslides+ebx],ah
		mov 	bl,ah
		cmp	bl,0fh
		je	short @@V2
		and 	bl,0fh
		cmp 	bl,0fh
		jne 	short @@V3
		shr 	ah,4
		jz 	short @@V2
		mov 	al,OC_FINE_VOLUME_SLIDE_UP
		stosw
		jmp	@@NoFX
	@@V2:   mov	al,OC_VOLUME_SLIDE
		stosw
		jmp 	@@NoFX
	@@V3:	mov 	bl,ah
		cmp 	bl,0f0h
		jb 	short @@V2
		and 	ah,0fh
		mov 	al,OC_FINE_VOLUME_SLIDE_DOWN
		stosw
		jmp 	@@NoFX
	;                                  
@@F:    cmp al,5 			;Slide down
	jne short @@A
		mov 	ebx,ds:[S3M_This_Channel]
		test 	ah,ah
		jnz 	short @@PD1
		mov 	ah,ds:[OFFSET S3M_Last_PSlides+eBX]
	@@PD1:	mov 	ds:[OFFSET S3M_Last_PSlides+eBX],ah
		mov 	bl,ah
		cmp	bl,0fh
		je	short @@PD2
		shr 	bl,4
		cmp 	bl,0eh
		jb 	short @@PD2
		je 	short @@PD3
		and 	ah,0fh
		mov	al,OC_FINE_SLIDE_DOWN
		stosw
		jmp 	@@NoFX
	@@PD2: 	mov	al,OC_PORTA_DOWN
		stosw
		jmp 	@@NoFX
	@@PD3:	and 	ah,0fh
		mov	al,OC_EXTRA_FINE_SLIDE_DOWN
		stosw
		jmp 	@@NoFX
	;                                  
@@A:	cmp al,6 			;Slide up
	jne short @@B
		mov 	ebx,ds:[S3M_This_Channel]
		test 	ah,ah
		jnz 	short @@PU1
		mov 	ah,ds:[OFFSET S3M_Last_PSlides+eBX]
	@@PU1:	mov 	ds:[OFFSET S3M_Last_PSlides+eBX],ah
		mov 	bl,ah
		cmp	bl,0fh
		je	short @@PU2
		shr 	bl,4
		cmp 	bl,0eh
		jb 	short @@PU2
		je 	short @@PU3
		and 	ah,0fh
		mov	al,OC_FINE_SLIDE_UP
		stosw
		jmp	@@NoFX
	@@PU2: 	mov	al,OC_PORTA_UP
		stosw
		jmp	@@NoFX
	@@PU3:	and 	ah,0fh
		mov	al,OC_EXTRA_FINE_SLIDE_UP
		stosw
		jmp	@@NoFX
	;                                  
@@B:    cmp	al,19
	je	short @@ExtFX
	cmp	al,0ch
	je	short @@Vol
	movzx	ebx,al
	mov	al,ds:[S3M_Effect_LUT+ebx]
	stosw				;Save opcode and zero-operand
	;
	;
	; Here are some special cases which need some postprocessing
	;
	cmp	al,OC_TONE_PORTA
	jne	short @@NoFX
	mov	eax,ds:[Last_Note]
	test	eax,eax
	jz	short @@NoFX
	mov	b ds:[eax],OC_SET_NOTE
	jmp	short @@NoFX

@@Vol:	mov	al,ah
	add	al,OC_SET_DIRECT_VOLUME
	stosb
	jmp	short @@NoFX
	;
@@ExtFX:movzx 	eax,ah			;Get parameter
	shr	eax,4           	;Get effect-number
	mov	al,ds:[S3M_Ext_Effect_LUT+eax]
	mov	ah,bl
	and	ah,0fh
	stosw				;Save opcode
	jmp 	short @@NoFX
	;
@@NoFX:	jmp	@@L2
	;
@@Next_Row:
	pop	eax		;Restore start address of this row
	mov	ecx,edi		;ECX=end address
	sub	ecx,eax		;ECX=Size of row
	mov 	ds:[eax],cl	;Save size of row !
	dec	ds:[No_Rows]
	jnz	@@L1        	;Go to next row !
	;
	xor	al,al
	stosb                   ;Save pattern-break
	;
	pop	ebx		;Restore start address of pattern
	sub	edi,ebx		;EDI=Size of this pattern in bytes
	mov	ds:[ebx],edi	;Save size here
	mov	ecx,edi		;ECX=Pattern size
	call	Realloc		;Do some reallocation

@@Err:  pop	ebp
	pop	edi
	pop	esi
	retn
Convert_S3M ENDP





;
;   GOMEZ MUSIC INTERFACE                                  ???-LOADER
;
PUBLIC C GMI_Load_STM
PUBLIC C GMI_Load_MTM
PUBLIC C GMI_Load_669
PUBLIC C GMI_Load_FAR
PUBLIC C GMI_Load_ULT
GMI_Load_STM:
GMI_Load_MTM:
GMI_Load_669:
GMI_Load_FAR:
GMI_Load_ULT:
	stc
	retn
code32 ends
END