;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS

GMI_SYSTEM_FILE	equ	1

;
;
;
;   GOMEZ MUSIC INTERFACE                                          v1.0
;
;
;
CODE32	segment para public use32
	assume cs:code32, ds:code32
	largestack


include gomez.inc
include gmi32.inc
include devices.inc



;
;   GOMEZ MUSIC INTERFACE         			DATA AREA
;
;
;
; First come some PUBLIC variables, that will inform the host-program about
; the activities of the GMI. There are also some variables that may be
; modified in order to control some functions of the GMI.
;
; See GMI32.DOC for further information !
;
extrn C GMI_Flags:DWORD
extrn C GMI_Channels:DWORD
extrn C GMI_Play_Frequency:DWORD

PUBLIC C GMI_Mixing_Buffer
PUBLIC C GMI_Mixing_Size
PUBLIC C GMI_IO_Buffer

PUBLIC SM_Set_Sample
PUBLIC SM_Set_Frequency
PUBLIC SM_Set_VOlumeMono
PUBLIC SM_Set_VOlumeStereo
PUBLIC SM_Stop_Sample
PUBLIC SM_Mixing
PUBLIC SM_Init_Mixer
PUBLIC SM_Exit_Mixer
PUBLIC SM_Set_MAster_VOlume
PUBLIC SM_Set_Mixer_Handler

PUBLIC SM_Mix_Mono
PUBLIC SM_Mix_MonoQ
PUBLIC SM_Mix_Stereo
PUBLIC SM_Mix_StereoQ
PUBLIC SM_Conv_Mono8
PUBLIC SM_Conv_Mono16
PUBLIC SM_Conv_Stereo8
PUBLIC SM_Conv_Stereo16

PUBLIC SM_DMA_Buffer
PUBLIC SM_DMA_Size
PUBLIC SM_DMA_Max
PUBLIC SM_DMA_Count
PUBLIC SM_Mixing_Size
PUBLIC SM_Mixing_Buffer
PUBLIC SM_Volume_Table
PUBLIC SM_Boost_Table
PUBLIC SM_Mixing_Proc
PUBLIC SM_Convert_Proc


GMI_IO_Buffer		LABEL BYTE
SM_Mixing_Data		DB SIZE GMI_MIXING_INFO * GMI_MAX_CHANNELS dup (?)
SM_DMA_Buffer		DD ?
SM_Current_Buffer	DD ?
GMI_Mixing_Buffer	LABEL DWORD
SM_Mixing_Buffer	DD ?
GMI_Mixing_Size		LABEL DWORD
SM_Mixing_Size		DD ?
SM_Mixing_Proc		DD ?
SM_Convert_Proc		DD ?
SM_Volume_Table		DD ?
SM_Boost_Table		DD ?
SM_Master_Volume	DD ?
SM_DMA_Max		DD ?			;Number of buffers in one sample
SM_DMA_Count		DD ?
SM_DMA_Size		DD ?

;
;
;
;   GOMEZ MUSIC INTERFACE                                   SOFTWARE-MIXER
;
;
;
MONO		equ	1
STEREO		equ	2
Normal_Mixing_Start MACRO mtype
	xor	eax,eax
	xor	ebx,ebx				;EBX = Zero
	;
	cmp 	dword ptr ds:[ebp+MI_MAX_ECX],eax
	je 	@@End
	;
	mov 	edi,ds:[SM_Mixing_Buffer]
	if mtype eq STEREO
		mov	al,ds:[ebp+MI_VOLUME_L]	;EAX = Left volume
		mov	bl,ds:[ebp+MI_VOLUME_R]	;EBX = right volume
		shl	eax,10
		shl	ebx,10                 	;EBX *= size of one volume-entry
		add	eax,ds:[SM_Volume_Table]
		add	ebx,ds:[SM_Volume_Table]
		mov 	dword ptr ds:[OFFSET @@V1-4],eax
		mov 	dword ptr ds:[OFFSET @@V2-4],ebx
		or	eax,ebx
		jz	@@End
	endif
	if mtype eq MONO
		mov	al,ds:[ebp+MI_VOLUME_L]	;EAX = volume
		shl	eax,10
		jz	@@End
		add	eax,ds:[SM_Volume_Table]
		mov 	dword ptr ds:[OFFSET @@V1-4],eax
	endif
	;
	mov	edx,ds:[ebp+MI_INCREMENT]	;EDX = 16.16bit increment
	mov	esi,ds:[ebp+MI_ADDRESS]		;ESI = Sample start address
	mov 	ecx,ds:[SM_Mixing_Size]		;ECX = DMA_Buffersize
	mov	ebx,edx				;EBX = 16.16bit increment
	shl	edx,16                          ;EDX = 32bit fractional inc
	sar	ebx,16				;EBX = 32bit integer inc
	add	esi,ds:[ebp+MI_POSITION+4]	;ESI = current position
	cmp 	ecx,ds:[ebp+MI_MAX_ECX]		;Does the instrument fit completely
	jb 	short @@J1     			;JB: yes
	sub 	ecx,ds:[ebp+MI_MAX_ECX]		;No: Sub MAX_CX from DMA_Size
	mov 	ds:[@@BufferLeft],ecx		;Save remaining part for later (loops)
	mov 	ecx,ds:[ebp+MI_MAX_ECX]		;ECX = MAX_CX as new DMA_Size
@@J1:  	mov	dword ptr ds:[@@I1-4],edx	;Save fractional inc.
	mov	dword ptr ds:[@@I2-4],ebx	;Save integer inc.
	sub 	ds:[ebp+MI_MAX_ECX],ecx		;Sub current counter from MAX_CX
	mov	edx,ds:[ebp+MI_POSITION]	;EDX = fractional pos.
	;
@@Instrument_Loop_Entry_Point:
	ENDM
;
Normal_Mixing_End MACRO mtype
	sub 	esi,ds:[ebp+MI_ADDRESS]		;ESI = Relative position
	mov 	ds:[ebp+MI_POSITION],edx
	mov	ds:[ebp+MI_POSITION+4],esi      ;Save 64bit position
	cmp 	dword ptr ds:[ebp+MI_MAX_ECX],0
	je 	short @@J2
	retn
	;
@@J2:	cmp 	dword ptr ds:[ebp+MI_LOOP_START],0fffffffh
	jae 	short @@End			;JAE: No loop present
	mov 	ecx,ds:[@@BufferLeft]		;ECX = Size of buffer
	mov 	esi,ds:[ebp+MI_LOOP_START]	;ESI = Loop-start position
	mov 	eax,ds:[ebp+MI_LOOP_END]       	;EAX = Sample size
	xor	edx,edx				;EDX = 0
	mov 	ds:[ebp+MI_POSITION+4],esi	;Save new start position
	mov	ds:[ebp+MI_POSITION],edx	;Clear fractional position
	sub 	eax,esi                  	;EAX = Loop size
	shld 	edx,eax,16			;EDX:EAX = Sample-Size
	shl 	eax,16				;
	div 	dword ptr ds:[ebp+MI_INCREMENT]	;Divide by Increment
	mov 	ds:[ebp+MI_MAX_ECX],eax		;EAX = MAX_ECX
	;                                  
	test	ecx,ecx				;ECX = Size left of buffer
	je 	short @@End			;JE: No buffer left
	;                                  
	cmp 	ecx,eax				;Is sample big enough ???
	jb	short @@J3			;JB: yes
	sub 	ecx,eax				;ECX = Buffer_Left - MAX_ECX
	mov 	ds:[@@BufferLeft],ecx		;Save for later (loops)
	mov 	ecx,eax				;ECX = MAX_ECX
@@J3:   add 	esi,ds:[ebp+MI_ADDRESS]		;ESI = Start-Address + Loop_Start
	sub 	ds:[ebp+MI_MAX_ECX],ecx		;Sub current counter
	jmp 	@@Instrument_Loop_Entry_Point
	;                                  
@@End: 	retn

	@@BufferLeft	dd	?
	ENDM
;
;
; Mixing routines:
;   Input:
;	EBP	- DATA32 ptr to mixing-data
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI
;
;
;
;
SM_Mix_Mono:
	Normal_Mixing_Start MONO
	xor	ebx,ebx
	lea	edi,[edi+4*ecx]			;EDI = ptr to last sample
	neg	ecx				;ECX = Negative size
	@@L1:	mov	bl,ds:[esi]		;EBX = Signed sample
		add	edx,12345678h		;EDX += fractional inc.
	@@I1:	mov	eax,ds:[4*ebx+1234567h]	;EAX  = Sample with volume
	@@V1:   adc	esi,12345678h		;ESI += integer inc.
	@@I2:	add     ds:[edi+4*ecx],eax	;Save sample
		inc	ecx
		jnz	short @@L1		;Loop !
	Normal_Mixing_End MONO
	retn
;
SM_Mix_Stereo:
SM_Mix_MonoQ:
SM_Mix_StereoQ:
	retn

;
;
; Conversion Routines
;   Input:
;	ESI	- DATA32 ptr to mixed buffer
;	EDI	- DATA32 ptr to dst-buffer
;	ECX	- Number of samples to convert
;   Destroys:
;	EAX,EBX,ECX,EDX,ESI,EDI,EBP
;
;
SM_Conv_Mono8:
	mov	ebp,ds:[SM_Boost_Table]
	add	ebp,GMI_BOOST_SIZE/2		;EBP = Boost-Table ptr
	lea	edi,[edi+ecx]			;EDI = Last result-sample
	lea	esi,[esi+4*ecx]			;ESI = Last source-sample
	shr	ecx,1
	neg	ecx				;ECX = Negative sample count
@@L1:	mov	eax,ds:[esi+8*ecx]		;EAX = 24bit sample
	mov	ebx,ds:[esi+8*ecx+4]		;EBX = 24bit sample
	sar	eax,24-GMI_BOOST_BITS
	sar	ebx,24-GMI_BOOST_BITS
	mov	al,ds:[ebp+eax]
	mov	ah,ds:[ebp+ebx]
	mov	ds:[edi+2*ecx],ax
	inc	ecx
	jnz	short @@L1
	retn
;
SM_Conv_Stereo8:
	mov	ebp,ds:[SM_Boost_Table]
	add	ebp,GMI_BOOST_SIZE/2		;EBP = Boost-Table ptr
	lea	edi,[edi+2*ecx]			;EDI = Last result-sample
	lea	esi,[esi+8*ecx]			;ESI = Last source-sample
	neg	ecx				;ECX = Negative sample count
@@L1:	mov	eax,ds:[esi+8*ecx]		;EAX = 24bit sample
	mov	ebx,ds:[esi+8*ecx+4]		;EBX = 24bit sample
	sar	eax,24-GMI_BOOST_BITS
	sar	ebx,24-GMI_BOOST_BITS
	mov	al,ds:[ebp+eax]
	mov	ah,ds:[ebp+ebx]
	mov	ds:[edi+2*ecx],ax
	inc	ecx
	jnz	short @@L1
	retn
;
SM_Conv_Mono16:
SM_Conv_Stereo16:
	retn



;
;
; SM_Mixing:
;   In:
;	Nothing
;
;
; SM_Set_Sample
;   In:
;	ECX	- Channel-Number
;      EAX	- Sample-Handle
; 	EBX	- Start position
;
;
; SM_Set_Frequency:
;   In:
;	ECX	- Channel-Number
;	EAX	- Frequency (Hz) (8bit fixed point)
;
;
; SM_Set_Volume:
;   In:
;	ECX	- Channel-Number
;	EAX	- Volume (0-64)
;	EBX	- Panning (0-255)
;
;
; SM_Stop_Sample:
;   In:
;	ECX	- Channel-Number
;   Out:
;	CF	- Error flag
;
;
; SM_Init_Mixer:
;   In:
;	ECX	- Number of channels
;   Out:
;	CF	- Error flag
;
;
; SM_Exit_Mixer:
;   In:
;	Nothing
;   Out:
;	CF	- Error flag
;
;
; SM_Set_Master_Volume:
;   In:
;	EAX	- Volume (64 Normal)
;   Out:
;	EAX	- Current Volume
;
;
SM_Mixing:
	push	esi
	push	edi
	push	ebp

	mov 	ebx,ds:[SM_DMA_Size]		;EBX = DMA-Increment
	inc 	ds:[SM_DMA_Count]		;Next buffer
	mov 	eax,ds:[SM_DMA_Count]
	add 	ds:[SM_Current_Buffer],ebx	;Set new DMA-Address
	cmp 	eax,ds:[SM_DMA_Max]
	jb 	short @@3
	mov 	eax,ds:[SM_DMA_Buffer]		;Restart from beginning
	mov 	ds:[SM_DMA_Count],1		;Reuse 1st buffer
	add 	eax,10h				;Skip sample-header
	or 	ds:[GMI_Flags],GMI_BUFFER_READY_FLAG
	mov 	ds:[SM_Current_Buffer],eax
	;
@@3:  	mov	edi,ds:[SM_Mixing_Buffer]	;EDI = Buffer ptr
	mov	ecx,ds:[SM_Mixing_Size]		;ECX = Buffer size in samples
	test	ds:[GMI_Flags],GMI_USE_STEREO
	jz	short @@4
	shl	ecx,1				;ECX *= 2 for stereo
@@4:	xor	eax,eax
	rep 	stosd				;Clear buffer !
	;
	mov	eax,ds:[GMI_Channels]		;EAX = Number of channels
	mov	ebp,OFFSET SM_Mixing_Data	;EBP = ptr to mixing data
	mov	ds:[@@channel],eax
	@@L1:	call 	ds:[SM_Mixing_Proc]
		add	ebp,SIZE GMI_MIXING_INFO
		dec	ds:[@@channel]
		jnz	short @@L1
	;
	;
	;Reverb engine
	;
	;
	mov	esi,ds:[SM_Mixing_Buffer]
	mov	edi,ds:[SM_Current_Buffer]
	mov	ecx,ds:[SM_Mixing_Size]
	call	ds:[SM_Convert_Proc]

	pop	ebp
	pop	edi
	pop	esi
	retn

	@@channel	dd	?
;
SM_Set_Sample:
	push	esi
	push	edi
	mov	esi,eax				;ESI = DATA32 ptr to sample-header
	fastimul edi,ecx,SIZE GMI_MIXING_INFO	;EDI = ptr to mixing data
	mov     edx,ds:[esi+SMP_FLAGS]		;EDX = Flags
	mov	ecx,ds:[esi+SMP_LOOP_START]	;ECX = Loop-start
	mov	eax,ds:[esi+SMP_LOOP_END]	;EAX = Loop-end
	cmp	ecx,0fffffffh
	jb	short @@J1                      ;JB: No loop
	mov	eax,ds:[esi+SMP_SIZE]		;EAX = Full sample-size
@@J1:   mov	esi,ds:[esi+SMP_ADDRESS]	;ESI = DATA32 ptr to sample
	mov	ds:[edi+SM_Mixing_Data+MI_FLAGS],edx
	xor	edx,edx				;EDX = 0
	mov	ds:[edi+SM_Mixing_Data+MI_POSITION+4],ebx
	mov	ds:[edi+SM_Mixing_Data+MI_LOOP_START],ecx
	mov	ds:[edi+SM_Mixing_Data+MI_LOOP_END],eax
	mov	ds:[edi+SM_Mixing_Data+MI_ADDRESS],esi
	mov	ds:[edi+SM_Mixing_Data+MI_POSITION],edx
	;
	mov	ecx,ds:[edi+SM_Mixing_Data+MI_INCREMENT]
	sub	eax,ebx				;EAX = Samples to play
	test	ecx,ecx				;ECX = increment
	jz	short @@Div			;Make safe of zero-divisions
	mov	edx,eax
	shl 	eax,16
	sar	edx,16                  	;EDX:EAX holds sample-size
	idiv 	ecx                    		;EAX = MAX_CX
	mov 	ds:[edi+SM_Mixing_Data+MI_MAX_ECX],eax
@@Div:	pop	edi
	pop	esi
	retn
;
SM_Set_Frequency:
	mov	edx,eax
	fastimul ebx,ecx,SIZE GMI_MIXING_INFO
	sar	edx,32-8			;EDX:EAX holds freq
	shl	eax,8				;EDX:EAX = 16bit fudges freq
	idiv	ds:[GMI_Play_Frequency]		;EAX = dst_frq/play_frq shl 16
	mov	ds:[ebx+SM_Mixing_Data+MI_INCREMENT],eax
	;
	test	eax,eax
	jz	short @@Div			;Make safe of zero-divisions
	mov 	ecx,eax				;ECX = increment
	xor	edx,edx				;EDX = 0
	mov 	eax,ds:[ebx+SM_Mixing_Data+MI_LOOP_END]
;	mov 	ds:[ebx+SM_Mixing_Data+MI_POSITION],edx
	sub 	eax,ds:[ebx+SM_Mixing_Data+MI_POSITION+4]
	mov	edx,eax				;EAX = Samples to play
	shl 	eax,16
	sar	edx,16                  	;EDX:EAX holds sample-size
	idiv 	ecx                    		;EAX = MAX_ECX
@@Div:	mov 	ds:[ebx+SM_Mixing_Data+MI_MAX_ECX],eax
	retn
;
SM_Set_VolumeMono:
	fastimul ebx,ecx,SIZE GMI_MIXING_INFO
	mov	ds:[ebx+SM_Mixing_Data+MI_VOLUME_L],al
	retn
SM_Set_VolumeStereo:
	fastimul edx,ecx,SIZE GMI_MIXING_INFO
	imul	ebx,eax 			;EBX = Volume*Panning
	shr	ebx,8				;EBX = Left volume
	sub	al,bl				;AL = right volume
	mov	ds:[edx+SM_Mixing_Data+MI_VOLUME_L],bl
	mov	ds:[edx+SM_Mixing_Data+MI_VOLUME_R],al
	retn
;
SM_Stop_Sample:
	fastimul ebx,ecx,SIZE GMI_MIXING_INFO
	mov	ds:[ebx+SM_Mixing_Data+MI_MAX_ECX],0
	retn
;
SM_Init_Mixer:
	push	edi
	mov	edi,OFFSET SM_Mixing_Data
	mov	ecx,(SIZE GMI_MIXING_INFO * GMI_MAX_CHANNELS)/4
	xor	eax,eax
	rep	stosd
	pop	edi
	clc
	retn
;
SM_Exit_Mixer:
	clc
	retn
;
SM_Set_Mixer_Handler:
	clc
	retn
;
SM_Set_Master_Volume:
	test	ds:[GMI_Flags],GMI_USE_16BIT
	jz	short @@Set8
	jmp	short @@End

@@Set8:	mov 	edi,ds:[SM_Boost_Table]
	mov	ebx,-(GMI_BOOST_SIZE)/2
	mov	ds:[SM_Master_Volume],eax
	mov	ecx,eax
@@L1:	mov	eax,ebx
	imul	ecx				;EDX:EAX = Volume_Factor
	shrd	eax,edx,GMI_BOOST_BITS-5
	add	eax,80h
	cmp	eax,100h
	jb	short @@1
	jl	short @@2
	mov	al,0ffh
	jmp	short @@1
@@2:	xor	eax,eax
@@1:	stosb
	inc	ebx
	cmp	ebx,GMI_BOOST_SIZE/2
	jle	short @@L1

@@End:  mov	eax,ds:[SM_Master_Volume]
	clc
	retn
code32 ends
end