;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
;
VERBOSITY		equ	0

METHOD_XMS		equ	1
METHOD_RAW		equ	2
METHOD_VCPI		equ	3

OS_DOS			equ	1 shl 3
OS_WINDOWS		equ	2 shl 3
OS_OS2			equ	3 shl 3
OS_DESQVIEW		equ	4 shl 3

CPU_80386		equ	3 shl 7
CPU_80486		equ	4 shl 7
CPU_PENTIUM		equ	5 shl 7

FPU_387                 equ	3 shl 11
FPU_BUILTIN             equ	4 shl 11

PAGING_ENABLED		equ	1 shl 14
;
b			equ	byte ptr
w			equ	word ptr
d			equ	dword ptr
o			equ	offset
s			equ	small
;
O_RDONLY         	equ	1
O_WRONLY         	equ	2
O_RDWR           	equ	4

FINDFIRST               equ     4eh
FINDNEXT                equ	4fh

SEEK_SET		equ	0
SEEK_CUR		equ     1
SEEK_END		equ     2
;
EXIT_ON_LOWMEM		equ	1
EXIT_ON_RESET		equ	2
VERBOSE_RESET		equ	4
VERBOSE_PAUSE		equ	8

TRUE			equ	1
FALSE			equ	-1

;
;
BLOCK_MAGIC		equ	'URUG'
FREE_BLOCK		equ	1
LAST_BLOCK		equ	2

DESCRIPTOR STRUC        	   ; Strukturtyp fr den Deskriptor
	   LIMIT0_15       DW ?    ; Segmentgre  0-15
	   BASIS0_15       DW ?    ; Basisadresse  0-15
	   BASIS16_23      DB ?    ; Basisadresse 16-23
	   ZUGRIFF         DB ?    ; Zugriffsrechte
	   EXTRA           DB ?    ; Zustzliche Segmentinfo
	   BASIS24_31      DB ?    ; Basisadresse 24-31
DESCRIPTOR ENDS

;
;
; A nice macro used to align your code.
;
CODEALIGN MACRO
 if (((($+15) and (not 15)) - $) le 8) and ($ and (not 15) ne $)
	db	((($+15) and (not 15)) - $) dup (90)
 endif
ENDM


;
;
; Some substitues for PUSHW POPW for older assemblers
;
IF ??Version le 310h
 PUSHFW MACRO
   ??thispos=$
   xor	ax,ax
   ??codesize=$-??thispos-2
   ORG	??thispos
   if 	??codesize eq 1
	db	66h,9ch
   else
	db 	9ch
   endif
 ENDM

 POPFW MACRO
   ??thispos=$
   xor	ax,ax
   ??codesize=$-??thispos-2
   ORG	??thispos
   if 	??codesize eq 1
	db	66h,9dh
   else
	db 	9dh
   endif
 ENDM
ENDIF



PRINT MACRO level,text
	LOCAL 	J,t
	if 	(level ge 4)
	 err	"Wrong level in PRINT macro. Level must be less or equal 3"
	endif
	if	(level ge VERBOSITY)
	 pushad
	 jmp	short J
	 t	db text,10,13,'$'
J:	 mov	esi,OFFSET t
	 call	Print32
	 popad
	endif
ENDM



;
;This macro constructs a 4GB descriptor
;In:
;  EAX - Base
;Out:
;  EDX:EAX - Descriptor
;
MAKE_DESCRIPTOR32 MACRO TYPE,LEVEL
	xor	edx,edx
	mov	edx,eax
	and	edx,0ff000000h		;Get high byte of base
	shr	edx,8
	shl	eax,8
	shld	edx,eax,8
	shl	eax,8			;Base is now distributed...
	mov	ax,0ffffh		;Set limit
	or	edx,(TYPE shl 9) or (1100b shl 20) or 0f0000h or (LEVEL shl 13) or (1001b shl 12)
	ENDM


MAKE_DESCRIPTOR16 MACRO TYPE,LEVEL
	xor	edx,edx
	shl	eax,8
	shld	edx,eax,8
	shl	eax,8			;Base is now distributed...
	mov	ax,0ffffh		;Set limit
	or	edx,(TYPE shl 9) or (LEVEL shl 13) or (1001b shl 12)
	ENDM

;
;This macro constructs a system descriptor
;In:
;  EAX - Base
;Out:
;  EDX:EAX - Descriptor
;
MAKE_SYS_DESCRIPTOR16 MACRO TYPE,LEVEL,LIMIT
	xor	edx,edx
	mov	edx,eax
	and	edx,0ff000000h		;Get high byte of base
	shr	edx,8
	shl	eax,8
	shld	edx,eax,8
	shl	eax,8			;Base is now distributed...
	mov	ax,LIMIT		;Set limit
	or	edx,(TYPE shl 8) or (LEVEL shl 13) or (1000b shl 12)
	ENDM

DESC_CODE		equ	5
DESC_DATA		equ	1

SDESC_TSS286		equ	1
SDESC_LDT		equ	2
SDESC_TSS286a		equ	3
SDESC_CALL_GATE286	equ	4
SDESC_TASK_GATE		equ	5
SDESC_INT_GATE286	equ	6
SDESC_TRAP_GATE286	equ	7
SDESC_TSS386		equ	9
SDESC_TSS386a		equ	11
SDESC_CALL_GATE386	equ	12
SDESC_INT_GATE386	equ	14
SDESC_TRAP_GATE386	equ	15


;
;
; These are all the front-end rutines for the user
;
ifndef GOMEZ_SYSTEM_FILE

EXTRN C LIN_Selector:dword   ,C CODE16_Selector:dword ,C DATA16_Selector:dword
EXTRN C DATA32_Selector:dword,C STACK32_Selector:dword,C CODE32_Selector:dword
EXTRN C UDATA32_Selector:dword
EXTRN C LIN_Address:dword    ,C CODE16_Address:dword  ,C CODE32_Address:dword  ,C DATA16_Address:dword
EXTRN C DATA32_Address:dword ,C STACK32_Address       ,C PSP_Address:dword
EXTRN C GDT32_Address:dword  ,C IDT32_Address:dword   ,C IDT16_Address:dword
EXTRN C UDATA32_Address:dword
EXTRN C HIMEM_Size:dword     ,C HIMEM_Address:dword
EXTRN C GOMEZ_Flags:dword    ,C GOMEZ_System:dword

EXTRN C V86_EAX:dword	,C V86_AX:word	,C V86_AL:byte	,C V86_AH:byte
EXTRN C V86_EBX:dword	,C V86_BX:word	,C V86_BL:byte	,C V86_BH:byte
EXTRN C V86_ECX:dword	,C V86_CX:word	,C V86_CL:byte	,C V86_CH:byte
EXTRN C V86_EDX:dword	,C V86_DX:word	,C V86_DL:byte	,C V86_DH:byte
EXTRN C V86_ESI:dword	,C V86_SI:word
EXTRN C V86_EDI:dword	,C V86_DI:word
EXTRN C V86_EBP:dword	,C V86_BP:word
EXTRN C V86_ESP:dword	,C V86_SP:word
EXTRN C V86_ES:word	,C V86_FS:word	,C V86_GS:word	,C V86_DS:word
EXTRN C V86_EFLAGS:dword,C V86_FLAGS:word

EXTRN C Init_PMODE32:near      	,C Exit_PMODE32:near
EXTRN C Switch_to_RM:dword     	,C Switch_to_PM:dword
EXTRN C Set_Real_Interrupt:near	,C Get_Real_Interrupt:near
EXTRN C Set_Flat_Interrupt:near	,C Get_Flat_Interrupt:near
EXTRN C Set_Flat_Exception:near	,C Get_Flat_Exception:near
EXTRN C Set_Flat_IRQ:near      	,C Get_Flat_IRQ:near
EXTRN C Link_Real_IRQ:near     	,C Unlink_Real_IRQ:near
EXTRN C Invoke_Real_Int:near   	,C Invoke_Real_IRQ:near
EXTRN C Enable_IRQ:near		,C Disable_IRQ:near
EXTRN C Call_Real_Proc:near    	,C Call_Real_Int:near
EXTRN C Alloc_Selector:near    	,C Free_Selector:near
EXTRN C Set_Selector_Base:near	,C Set_Selector_Rights:near
EXTRN C Set_Selector_Limit:near ,C Get_Selector_Data:near

EXTRN C Print32:near
EXTRN C Scan_Argument:near	,C Scan_Environment:near

EXTRN C Malloc:near	       	,C Free:near      	,C Page_Malloc:near
EXTRN C DMA_Malloc:near    	,C Coreleft:near   	,C Get_Size:near
EXTRN C Realloc:near		,C FindFile:near	,C Chdir:near
EXTRN C Map_Memory:near		,C Unmap_Memory:near

EXTRN C DOS_Malloc:near	       	,C DOS_Free:near
EXTRN C DOS_DMA_Malloc:near    	,C DOS_Coreleft:near

EXTRN C Open:near	,C Close:near	,C Read:near    ,C Write:near
EXTRN C Creat:near	,C Tell:near	,C Seek:near    ,C Chsize:near
EXTRN C Getchar:near	,C Putchar:near

endif

