;͸
;                                                                           
; (c) 1995,1996 by Marc van Shaney , aka Kaya Memisoglu                     
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;              Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza       
;                                                                           
;                                                                           
;;
;
P386
LOCALS
_DEVICE_SYSTEM_FILE	equ	1


Delay MACRO
	LOCAL L1
	push 	ecx
	pushfd
	mov 	ecx,010000h
L1:	nop
	nop
	loop	short L1
	popfd
	pop 	ecx
      ENDM



;
;
;
;   GOMEZ SOUND BLASTER DMA DRIVER
;
;
;
CODE32	segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include devices.inc

ALIGN 4
PUBLIC C SBDMA_Driver
SBDMA_Driver LABEL BYTE
	db	"SOUND",0,0,0			;8 bytes driver-type
	dd	100h				;Version
	dd	?				;Reserved
	db	"SoundBlaster DMA"		;Driver name

	dd      DRV_Init
	dd	DRV_Exit
	dd	DRV_Detect
	dd	Play_Sample
	dd	Stop_Sample
	dd	Set_Next_Block
	dd	Set_Play_Handler
	dd	Set_Master_Volume
;
DSP_Base        DW 220h
DSP_IRQ         DB 7
DSP_DMA         DB 1

ALIGN DWORD
Voice_Rate    	DD ?
Voice_Address	DD ?
Voice_Size	DD ?
Play_Handler	DD 0
Next_Block	DD ?

Old_IRQ		dd ?
Old_Real_IRQ	dd ?

SB_Flags	DD ?		;bit 0: SBpro
				;bit 1: SB16
				;bit 2: Speed is higher than 23000Hz
				;bit 3: Sample is stereo


SB_TYPE_PRO	equ	3
SB_TYPE_NORMAL	equ	1

;
;   DMA stuff
;
;
;
; DMA_Setup:
;   Input:
;	EAX	- LIN32 address of DMA-block
;	BL	- DMA-Channel
;	BH	- DMA mode
;	ECX	- Data size
;   Output:
;	Nothing
;
;
; Set_Interrupt_Flag:
; Clear_Interrupt_Flag:
;   Input:
;      EBX	- Interrupt number
;   Output:
;      Nothing
;
;
DMA_Page_Table db 87h,83h,81h,82h
DMA_Setup:
	push	eax			;Save block-address
	xor 	al,al
	out 	0ch,al         		;Clear flip-flop

;      	mov 	al,bl
;      	or 	al,0100b
;     	out 	0ah,al                 	;Set mask

	movzx 	edx,bl
	shl 	edx,1
	inc 	edx			;EDX holds DMA-I/O address for channel
	mov 	eax,ecx
	dec 	eax                     ;EAX = DMA-Size - 1
	out 	dx,al
	shr 	eax,8
	out 	dx,al                   ;Set size

	mov 	al,bl
	add 	al,bh
	out 	0bh,al			;Set DMA-Mode

	pop	eax			;EAX = block-address
	dec 	edx			;EDX = DMA-Offset I/O address
	out 	dx,al
	shr 	eax,8
	out 	dx,al
	shr 	eax,8			;Set Offset

	and 	ebx,0ffh         	;EBX = DSP_DMA_Channel
	mov 	dl,ds:[ebx+OFFSET DMA_Page_Table]
	out 	dx,al			;Set DMA-Page
;      	shr 	eax,8
;      	mov 	dh,4
;      	out 	dx,al

	mov 	al,bl	        	;AL = DMA-Channel
	out 	0ah,al
	retn
;
;   SB-DMA driver                                     DSP-routines
;
;
;
; DSP_Init:
;   Input:
;	Nothing
;   Output:
;	CF	- error flag
;
;
; DSP_Read
;   Input:
;      Nothing
;   Output:
;	EAX	- byte read from DSP
;
;
; DSP_Write:
;   Input:
;	EAX	- byte to send to DSP
;   Output:
;	Nothing
;
;
; DSP_Init_Frequency:
;   Input:
; 	EBX	- play frequency (in Hz)
;   Output:
;	Nothing
;
DSP_Retry		equ  100h
DSP_Out_DMA         	equ  14h
DSP_Reset_Port      	equ  6
DSP_Read_Port       	equ  0ah
DSP_Write_Port      	equ  0ch
DSP_Status_Port     	equ  0eh

DSP_Init:
	mov 	dx,ds:[DSP_Base]
	add     dx,DSP_Reset_Port
	mov 	al,1
	out 	dx,al
	Delay
	xor 	al,al
	out 	dx,al

	mov 	dx,ds:[DSP_Base]
	add 	dx,DSP_Read_Port
	mov 	ecx,200h
	@@L1:	push 	ecx
		mov 	dx,ds:[DSP_Base]
		add 	dx,DSP_Status_Port
		mov 	cx,4000h
	@@L2: 	in 	al,dx
		test 	al,128
		loope @@L2
		mov 	dx,ds:[DSP_Base]
		add 	dx,DSP_Read_Port
		in 	al,dx
		pop 	ecx
		cmp 	al,0aah
		je 	short @@OK
	loop 	@@L1
	stc
	retn

 @@OK:	clc
	retn
;
DSP_Read:
	mov 	dx,ds:[DSP_Base]
	add 	dx,DSP_Status_Port
	mov 	ecx,DSP_Retry
@@L1:	in 	al,dx
	test 	al,128
	loope 	@@L1
	add 	dx,DSP_Read_Port-DSP_Status_Port
	in 	al,dx
	movzx 	eax,al		;EAX = byte read
	retn
;
DSP_Write:
	push	eax		;Save value
	push	ecx
	mov 	dx,ds:[DSP_Base]
	add 	dx,DSP_Write_Port
	mov 	ecx,DSP_Retry
@@L1:	in 	al,dx
	test 	al,128
	loopne 	@@L1
	pop	ecx
	pop	eax		;EAX = Value
	out 	dx,al
	retn
;
DSP_Init_Frequency:
	push	ebx				;Save freq.
	mov	al,40h
	call 	DSP_Write

	pop	ebx				;EBX = freq
	test	ds:[SB_Flags],8 		;Is sample stereo ???
	jz	short @@1
	shl	ebx,1
@@1:	xor 	edx,edx
	mov 	eax,1000000
	div 	ebx
	neg 	al				;AL = rate-constant

	and	ds:[SB_Flags],NOT 4		;Clear fast-flag
	cmp 	ebx,23000			;is rate below 23000 ?
	jb 	short @@NoProCommand
	or	ds:[SB_Flags],4

  @@NoProCommand:
	call	DSP_Write			;Write speed

	test	ds:[SB_Flags],1			;IS it a stereo card ???
	jz	short @@End

	test	ds:[SB_Flags],8
	jz 	short @@Mono
	mov 	dx,ds:[DSP_Base]        	;Set up mixer for stereo
	add 	dx,4
	mov 	al,0eh
	out 	dx,al
	inc 	edx
	in 	al,dx
	or 	al,2
	out 	dx,al
	jmp 	@@End

@@Mono:	mov 	dx,ds:[DSP_Base]
	add 	dx,4				;Setup mixer for mono
	mov 	al,0eh
	out 	dx,al
	inc 	edx
	in 	al,dx
	and 	al,NOT 2
	out 	dx,al
@@End:	retn
;
DSP_Status MACRO
	mov 	dx,ds:[DSP_Base]
	add 	dx,DSP_Status_Port
	in 	al,dx
	add 	dx,DSP_Read_Port-DSP_Status_Port
	in 	al,dx
      ENDM
;
Play_Voice:
	mov	eax,ds:[Voice_Address]
	mov	bl,ds:[DSP_DMA]
	mov 	bh,72
	mov 	ecx,ds:[Voice_Size]
	add	eax,ds:[DATA32_Address]		;EAX = LIN32 address
	call 	DMA_Setup
	mov 	ebx,ds:[Voice_Size]
	dec 	ebx
	test	ds:[SB_Flags],4			;Is it 23000 or more Hz ???
	jz 	short @@NoPro

	mov	al,48h
	call	DSP_Write
	mov	al,bl
	call	DSP_Write
	mov	al,bh
	call	DSP_Write
	mov	al,91h
	call	DSP_Write
	retn

@@NoPro:
	mov	al,14h
	call	DSP_Write
	mov	al,bl
	call	DSP_Write
	mov	al,bh
	call	DSP_Write
	retn

;
;
;
;   GOMEZ SOUND BLASTER DMA DRIVER                        DRIVER ROUTINES
;
;
;
;
;
; First some init/exit/detect routines
;
SB_Test_Retry		equ	1024
EnvString		db	"BLASTER=~"
DRV_Init:
	push	ds
	push	es
	mov	ds,cs:[DATA32_Selector]
	;
	cli
	movzx 	eax,byte ptr ds:[DSP_IRQ]
	call	Get_FLat_IRQ
	mov	ds:[Old_IRQ],eax
	movzx 	eax,byte ptr ds:[DSP_IRQ]
	call	Link_Real_IRQ
	mov	ds:[Old_Real_IRQ],ebx	;EBX = old real-mode proc
	movzx 	eax,byte ptr ds:[DSP_IRQ]
	call	Unlink_Real_IRQ
	sti
	xor	ebx,ebx
	mov 	ds:[Play_Handler],ebx
	mov	ds:[SB_Flags],ebx
	;
	call 	DSP_Init
	jc	@@Err
	;
	mov 	dx,ds:[DSP_Base]
	add 	dx,4			;Mixer chip
	mov	al,22h			;Select some crappy register
	out	dx,al
	inc	dx
	in	al,dx
	mov 	ah,al			;save old reg-value

	dec	dx
	mov	al,22h                  ;Reselct register
	out	dx,al
	inc	dx
	mov	al,ah
	not	al
	out	dx,al			;Write some new crap

	dec	dx
	mov	al,22h                  ;Reselct register
	out	dx,al
	inc	dx
	in 	al,dx			;Read again register

	mov	bl,al
	not	bl
	cmp	bl,ah			;Is written value still the same ?
	jne	short @@NoPro

	or	ds:[SB_Flags],1		;Set SBPro flag
	dec	dx
	mov	al,22h                  ;Reselct register
	out	dx,al
	inc	dx
	mov	al,ah
	out	dx,al			;Restore old value

@@NoPro:clc
@@Err:	pop	es
	pop	ds
	retn
;
DRV_Exit:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	movzx 	eax,ds:[DSP_IRQ]
	mov 	ebx,ds:[Old_IRQ]
	call	Set_Flat_IRQ
	movzx 	eax,ds:[DSP_IRQ]
	mov 	ebx,ds:[Old_Real_IRQ]
	call	Unlink_Real_IRQ
	pop	ds
	retn
;
DRV_Detect:
	push	ds
	push	es
	push 	esi
	push	edi
	push	ebp

	mov	ds,cs:[DATA32_Selector]
	mov	es,ds:[DATA32_Selector]

	mov	eax,OFFSET EnvString
	call	Scan_Argument
	jc	@@Not_Found
	lea	esi,[eax+8]
	;
	xor 	edx,edx				;Clear thing
	xor 	eax,eax
@@L1:	lodsb
	test 	al,al			;Terminating 0 ???
	jz 	short @@Found
	cmp 	al,32
	je 	short @@L1		;Is it a silly space ?
	cmp	al,'9'
	ja	short @@ADR
	cmp	al,'0'
	jb	short @@ADR
	sub	al,'0'
	shl	edx,4
	or	dl,al
	jmp	short @@L1

@@ADR:	cmp	ah,'A'
	jne	short @@IRQ
		mov	ds:[DSP_Base],dx
		mov	ah,al
		xor	edx,edx
		jmp	short @@L1
@@IRQ:	cmp	ah,'I'
	jne	short @@DMA
		cmp	dl,9
		jbe	short @@Ok
		sub	dl,6
	@@Ok:	mov	ds:[DSP_IRQ],dl
		mov	ah,al
		xor	edx,edx
		jmp	short @@L1
@@DMA:	cmp	ah,'D'
	jne	short @@OTH
		mov	ds:[DSP_DMA],dl
		mov	ah,al
		xor	edx,edx
		jmp	short @@L1
@@OTH:	xor	edx,edx
	mov	ah,al
	jmp	short @@L1
	;
@@Found:mov 	dx,ds:[DSP_Base]
	add 	dx,6h
	mov 	al,1
	out 	dx,al
	mov 	al,0
	out 	dx,al
	mov 	ecx,SB_Test_Retry
	mov 	dx,ds:[DSP_Base]
	add 	dx,0eh
	@@L2:  	in 	al,dx
		cmp 	al,128
		jae 	short @@1
		loop 	@@L2
@@1:	test	ecx,ecx
	jz 	short @@Not_Found
	mov 	dx,ds:[DSP_Base]
	add 	dx,0ah
	in 	al,dx
	cmp 	al,0aah
	jne 	short @@Not_Found
	;
	call 	DSP_Init
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
	;
@@Not_Found:
	stc
	pop	ebp
	pop	edi
	pop	esi
	pop	es
	pop	ds
	retn
;
;
; Other driver-routines come here.
;
; Play_Sample:
;   Input:
;	EAX	- DATA32 ptr to sample-header
;   Output:
;	CF	- error flag
;
;
; Stop_Sample:
;   Input:
;	Nothing
;   Output:
;	Nothing
;
;
; Set_Play_Handler
;   Input:
;	EAX	- DATA32 ptr to retn terminated handler
;   Output:
;	EAX	- DATA32 ptr to old play-handler or zero
;
;
; Set_Next_Block:
;   Input:
;	EAX	- DATA32 ptr to next block
;   Output:
;	Nothing
;
;
Play_Sample:
	push	ds
	push 	esi
	mov	ds,cs:[DATA32_Selector]

	and	ds:[SB_Flags],NOT (8+4)	;Clear stereo bit
	mov 	esi,eax			;ESI = ptr to sample-header
	cmp 	dword ptr ds:[esi],0
	je 	@@Return_Info
	;
	call 	DSP_Init
	movzx 	ebx,byte ptr ds:[esi+8] ;EBX = Number of channels
	mov	eax,ds:[esi]		;EAX = Size of sample
	shr	ebx,1			;Get bit 1 (set for 2 channels)
	shl	ebx,3
	jz	short @@2               ;Is it mono ?
	shl	eax,1			;No, mul size by two
@@2:	or  	ds:[SB_Flags],ebx
	mov 	ds:[Voice_Size],eax	;EAX = Size of sample in bytes
	mov 	ebx,ds:[esi+4]		;EBX = sample-rate in Hz
	call	DSP_Init_Frequency
	lea 	eax,[esi+16]		;EAX = ptr to first sample
	mov 	ds:[Voice_Address],eax
	mov 	ds:[Next_Block],0
	;
	mov	al,0d1h			;Turn on speaker
	call 	DSP_Write
	;
	cli
	movzx 	eax,ds:[DSP_IRQ]	;EAX = IRQ number
	mov	ebx,OFFSET Play_Interrupt
	call	Set_Flat_IRQ		;Set new IRQ
	movzx 	eax,ds:[DSP_IRQ]	;EAX = IRQ number
	call	Link_Real_IRQ
	movzx	eax,ds:[DSP_IRQ]
	call 	Enable_IRQ
	;
	DSP_Status
	call	Play_Voice		;Start voice-output
	sti
	clc
	pop 	esi
	pop 	ds
	retn
	;
@@Return_Info:
	mov	dword ptr ds:[esi+12],0		;Clear flags
	mov 	byte ptr ds:[esi+9],8		;Bits per sample
	test	ds:[SB_Flags],1			;is it a stereo card ?
	jz 	short @@Mono
	cmp 	byte ptr ds:[esi+8],2		;Number of channels
	je 	short @@Stereo
@@Mono:	mov 	ebx,ds:[esi+4]			;EBX = Sample-rate
	cmp 	ebx,44400
	jbe 	short @@3
	mov 	ebx,44400
@@3:	xor 	edx,edx
	mov 	eax,1000000
	idiv 	ebx
	movzx 	ebx,al
	xor 	edx,edx
	mov 	eax,1000000
	idiv 	ebx
	mov 	ds:[esi+4],eax			;Set new sample-rate
	mov 	byte ptr ds:[esi+8],1		;Set number of channels
	jmp 	short @@End
	;
@@Stereo:
	mov 	ebx,ds:[esi+4]			;EBX = Sample-rate
	cmp 	ebx,22000
	jbe 	short @@4
	mov 	ebx,22000
@@4:	xor 	edx,edx
	mov 	eax,1000000
	shl 	ebx,1
	idiv 	ebx
	movzx 	ebx,al
	xor 	edx,edx
	mov 	eax,1000000
	idiv 	ebx
	shr 	eax,1
	mov 	ds:[esi+4],eax

@@End:	pop 	esi
	pop 	ds
	clc
	retn
;
Stop_Sample:
	push	ds
	pushfd
	cli

	mov	ds,cs:[DATA32_Selector]
	movzx	eax,ds:[DSP_IRQ]	;EAX = IRQ-number
	mov	ebx,ds:[Old_IRQ]
	call	Set_Flat_IRQ
	movzx	eax,ds:[DSP_IRQ]	;EAX = IRQ-number
	mov	ebx,ds:[Old_Real_IRQ]
	call	Unlink_Real_IRQ
	;
	mov	al,0d0h			;Stop voice
	call 	DSP_Write
	mov	al,0d3h			;Turn off speaker
	call	DSP_Write
	movzx	eax,ds:[DSP_IRQ]
	call 	Disable_IRQ
	;
	mov 	bl,ds:[DSP_DMA]		;BL holds DMA_Channel
	mov 	al,bl
	or 	al,0100b
	out 	0ah,al                        ;Set mask
	;
	mov 	ds:[Voice_Size],0
	mov 	ds:[Voice_Address],0ffffffffh
	mov	ds:[Voice_Rate],0

	popfd
	pop	ds
	clc
	retn
;
Set_Play_Handler:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	xchg 	ds:[Play_Handler],eax
	pop 	ds
	clc
	retn
;
Set_Next_Block:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	mov 	ds:[Next_Block],eax
	pop 	ds
	clc
	retn
;
Set_Master_Volume:
	clc
	retn
;
;   GOMEZ SOUND BLASTER DMA DRIVER                        INTERRUPT ROUTINE
;
Play_Interrupt:
	pushad
	push 	ds
	mov	ds,cs:[DATA32_Selector]
	;
	DSP_Status
	mov 	al,20h				;Send EOI
	mov	dx,20h                          ;Select first IRQ-Controller
	cmp	ds:[DSP_IRQ],7
	jbe	short @@1
	mov 	dx,0a0h				;Select 2nd IRQ-Controller
@@1:	out 	dx,al
	;
	mov	ebx,ds:[Next_Block]		;EBX = ptr to next block
	test	ebx,ebx
	jz 	short @@Last
	movzx 	eax,byte ptr ds:[ebx+8]		;EAX = number of channels
	imul 	dword ptr ds:[ebx]		;EAX = sample-size in bytes
	add 	ebx,10h				;Skip header
	mov 	ds:[Voice_Size],eax
	mov 	ds:[Voice_Address],ebx
	call	Play_Voice			;Start new block !
	mov 	ds:[Next_Block],0
	;
	cmp 	ds:[Play_Handler],0		;Is there a handler ???
	je 	short @@3
	sti
	call 	ds:[Play_Handler]
	jc 	short @@Stop
	;
@@3:	pop 	ds
	popad
	iretd
	;
@@Last:	cmp 	ds:[Play_Handler],0
	je 	short @@Stop
	sti
	call 	ds:[Play_Handler]
	jc 	short @@Stop
	pop 	ds
	popad
	iretd
	;
@@Stop:	call 	Stop_Sample
	pop 	ds
	popad
	iretd
code32 ends
END