;͸
;                                                                           
; (c) 1996 by Marc van Shaney , aka Kaya Memisoglu                          
;                                                                           
; This Source-Code was written by and is copyrighted by Kaya Memisoglu	     
; You may use the whole code or only parts of it in your own programs       
; whether they are commercial or not. BUT you must give credits for these   
; parts to me (Kaya Memisoglu  or  Marc van Shaney).                        
; I am not responsible for any damage or loss caused by this program, so    
; if you success in erasing your harddisk with this code, then it is your   
; own fault and you should not claim me to be responsible...                
; I would be very pleased if you also sent me a postcard or even a letter   
; if you can use this code. My address:                                     
;                                                                           
;        Kaya Memisoglu                                                     
;        Reichenberger Ring 50                                              
;        63512 Hainburg                                                     
;        Germany                                                            
;	                                                                     
;	  Internet: memisogl@stud.uni-frankfurt.de                           
;                                                                           
; You can also leave a message for Marc van Shaney on the Nirvana BBS:      
;                                                                           
;        Nirvana BBS     ++49-(0)6245-4236      Sysop:Raytrayza             
;                                                                           
;                                                                           
;;
;
P486
LOCALS
JUMPS
;The Sound_Block structure:
;	dword 		Sample_rate
;	dword 		Sample_Size
;	byte 		Bits_per_Sample
;	byte 		Channels
;	6 bytes 	resreved
;
;The following external MACROS can be defined
;  EXTERNAL_ROUTINES
;  DRV_NAME *
;  DRV_INIT
;  DRV_EXIT
;  DRV_TEXT *
;  DRV_VERSION *
;  VOICE_INIT
;  VOICE_STOP
;  VOICE_START
;  VOICE_OUT *


MAJOR_VERSION		equ	4


;
;
;
;   GOMEZ SOUND BLASTER DMA DRIVER
;
;
;
code32  segment para public use32
	assume cs:code32, ds:code32
	largestack

include gomez.inc
include devices.inc

b	equ	byte ptr
w	equ	word ptr
d	equ	dword ptr


ALIGN 16
PUBLIC C &DRV_NAME
&DRV_NAME LABEL DWORD
	db	"SOUND",0,0,0			;8 bytes driver-type
	dd  	256*MAJOR_VERSION+DRV_VERSION  	;Version
	dd	100h				;Version
	dd	?				;Reserved
	db	DRV_TEXT			;Driver name

	dd      @DRV_Init
	dd	@DRV_Exit
	dd	@DRV_Detect
	dd	Play_Sample
	dd	Stop_Sample
	dd	Set_Next_Block
	dd	Set_Play_Handler
	dd	Set_Master_Volume
;
Data_Adress     DD ?
Data_Size       DD ?

Old_IRQ		DD ?

Play_Handler	DD 0
Voice_Rate      DD ?
Timer_Constant	DD ?

Next_Block 	DD 0
Busy		DB ?

;
;   GOMEZ TIMER SOUND DRIVER					Main routines
;
ifdef EXTERNAL_ROUTINES
EXTERNAL_ROUTINES
endif
;
@DRV_Init:
	xor	eax,eax
	call	Get_Flat_IRQ
	mov 	ds:[Old_IRQ],ebx
	mov 	ds:[Play_Handler],0
	ifdef DRV_INIT
	 DRV_INIT
	endif
	clc
	retn
;
@DRV_Exit:
	cli
	xor	eax,eax
	mov	ebx,ds:[Old_IRQ]
	call	Set_Flat_IRQ
	mov 	al,36h
	out 	43h,al
	mov 	dx,40h
	mov 	al,0ffh
	out 	dx,al
	out 	dx,al
	sti
	clc
	ifdef 	DRV_EXIT
	 DRV_EXIT
	endif
	retn
;
@DRV_Detect:
	ifdef AUTO_DETECT
	 AUTO_DETECT
	 retn
	else
	 clc
	 retn
	endif
;
Play_Sample:
	push	ds
	push	esi

	mov 	ds,cs:[DATA32_Selector]
	mov 	esi,eax				;EAX = Ptr to sound-block
	cmp 	dword ptr ds:[esi+SAMPLE_SIZE],0
	je 	Info
	mov 	ebx,ds:[esi+SAMPLE_RATE]
	mov 	ds:[Voice_Rate],ebx
	xor 	edx,edx
	mov 	eax,123333h
	div 	ebx
	mov 	ds:[Timer_Constant],eax
	;
	mov 	eax,ds:[esi+SAMPLE_SIZE]
	mov 	ds:[Data_Size],eax
	lea	eax,[esi+16]
	mov 	dword ptr cs:[DAdr-4],eax
	mov 	ds:[Data_Adress],eax
	mov 	ds:[Next_Block],0
	mov 	ds:[Busy],0
	;
	ifdef VOICE_INIT
	 VOICE_INIT
	endif
	;
	cli
	xor	eax,eax
	mov	ebx,OFFSET Sound_IRQ32
	call	Set_Flat_IRQ

	mov 	al,36h
	out 	43h,al
	mov 	eax,ds:[Timer_Constant]
	out 	40h,al
	shr 	ax,8
	out 	40h,al                      ;Geschwindigkeit setzen
	;
	ifdef VOICE_START
	 VOICE_START
	endif
	;
	pop	esi
	pop 	ds
	clc
	sti
	retn

	;
Info:	mov 	byte ptr ds:[esi+SAMPLE_CHANNELS],1
	mov	dword ptr ds:[esi+SAMPLE_FLAGS],SOUND_USES_TIMER or SOUND_LOW_DMA_BUFFER
	mov 	byte ptr ds:[esi+SAMPLE_RESOLUTION],8
	mov 	ebx,ds:[esi+SAMPLE_RATE]
	cmp 	ebx,65000
	jbe 	short @@2
	mov 	ebx,65000
@@2:	xor 	edx,edx
	mov 	eax,123333h
	div 	ebx
	mov 	ebx,eax
	xor 	edx,edx
	mov 	eax,123333h
	div 	ebx
	mov 	ds:[esi+SAMPLE_RATE],eax

	pop 	esi
	pop 	ds
	clc
	retn
;
Stop_Sample:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	cli

	mov 	al,36h
	out 	43h,al
	mov 	al,0ffh
	out 	40h,al
	out 	40h,al

	xor	eax,eax
	mov	ebx,ds:[Old_IRQ]
	call	Set_Flat_IRQ
	sti

	mov 	ds:[Data_Size],0
	mov 	ds:[Data_Adress],0ffffffffh

	ifdef VOICE_STOP
	 VOICE_STOP
	endif

	pop	ds
	clc
	retn
;
Set_Play_Handler:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	xchg 	ds:[Play_Handler],eax
	pop 	ds
	clc
	retn
;
Set_Next_Block:
	push	ds
	mov	ds,cs:[DATA32_Selector]
	mov 	ds:[Next_Block],eax
	pop 	ds
	clc
	retn
;
Set_Master_Volume:
	clc
	retn


;
;   GOMEZ TIMER SOUND DRIVER				    Timer interrupts
;
Sound_IRQ32:
	push 	eax
	push 	ds

	mov 	ds,cs:[DATA32_Selector]
	mov 	al,ds:[12345678h]
DAdr:	inc 	dword ptr ds:[DAdr-4]

	VOICE_OUT

	mov 	al,20h
	out 	20h,al

	dec 	ds:[Data_Size]
	jz 	short @@End

	pop 	ds
	pop 	eax
	iretd

	;
@@End:	cmp 	ds:[Next_Block],0
	je 	short @@Last
	push 	ebx
	mov 	ebx,ds:[Next_Block]
	mov 	eax,ds:[ebx+SAMPLE_SIZE]
	add	ebx,16
	mov 	ds:[Data_Size],eax
	mov 	d ds:[DAdr-4],ebx
	mov 	d ds:[Data_Adress],ebx
	sti
	pop 	ebx
	mov 	ds:[Next_Block],0
	cmp 	ds:[Play_Handler],0
	jne 	short @@User
	pop 	ds
	pop 	eax
	iretd
	;
@@Last:	pushad
	push 	es
	call 	Stop_Sample
	cmp 	ds:[Play_Handler],0
	je 	short @@1
	cmp 	ds:[Busy],1
	je 	short @@1
	mov 	ds:[Busy],1
	call 	ds:[Play_Handler]
	mov 	ds:[Busy],0
@@1:	pop 	es
	popad
	pop 	ds
	pop 	eax
	iretd
	;
@@User:	pushad
	push 	es
	cmp 	ds:[Busy],1
	je 	short @@2
	mov 	ds:[Busy],1
	call 	ds:[Play_Handler]
	mov 	ds:[Busy],0
	jc 	@@Stop
@@2: 	pop 	es
	popad
	pop 	ds
	pop 	eax
	iretd

@@Stop:	call	Stop_Sample
	jmp	short @@2




